// DiscreteIn5_300.inc
// Copyright (C) Siemens AG (1999-2000). All Rights Reserved
// Product:	SIMATIC PDM  						
// Description: 	Profile 3 - Function Block #1: Discrete In
// $Revision:   1.0  $
// $Date:   Oct 22 2002  $

//It is a file that modifies SIMENS standard file DiscreteIn1_300.inc. 


#ifndef FUNC5_TITLE
#define FUNC5_TITLE [func1_DI]
#endif

#define DEF_LABEL_FUNC5_DI	[func1_DI]



#ifndef FUNC5_DI_NUMBER
	#define FUNC5_DI_NUMBER				5
#endif

/*
#ifndef BLOCK_MODE_AUTO
	#define	BLOCK_MODE_AUTO				0x08
	#define	BLOCK_MODE_MAN				0x10
	#define	BLOCK_MODE_OUT_OF_SERVICE	0x80
#endif
*/

#ifndef FUNC_AI_FAIL_SAFE_VALUE
	#define FUNC_AI_FAIL_SAFE_VALUE			0
	#define FUNC_AI_STORING_LAST_SETPOINT	1
	#define FUNC_AI_FAIL_SAFE_POSITION		2
#endif


/* #define FUNC5_AVAILABLE */
#define FUNC5_SIMULATION_AVAILABLE


#define FUNC5_LOAD_TO_PC \
					func5_DI_st_rev,	\
					func5_DI_channel,	\
					func5_DI_invert,	\
					func5_DI_batch_id,	\
					func5_DI_batch_unit,	\
					func5_DI_batch_operation,	\
					func5_DI_batch_phase,	\
					func5_DI_fsafe_type,	\
					func5_DI_fsafe_value


#define FUNC5_LOAD_TO_DEVICE	\
					func5_DI_channel,	\
					func5_DI_invert,	\
					func5_DI_batch_id,	\
					func5_DI_batch_unit,	\
					func5_DI_batch_operation,	\
					func5_DI_batch_phase,	\
					func5_DI_fsafe_type,	\
					func5_DI_fsafe_value



BLOCK func5_DI_block
{
	TYPE	FUNCTION;
	NUMBER	FUNC5_DI_NUMBER ;
}

func5_DI_blk_reserve						LIKE VARIABLE	phys_blk_reserve
{
}

VARIABLE func5_DI_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	2,	[blk_block_object_FUNCTION]		}
	}
	HANDLING	READ;
}

VARIABLE func5_DI_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[func_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	1,	[func_blk_parent_class_INPUT]	}
	}
	HANDLING	READ;
}

VARIABLE func5_DI_blk_class
{
	LABEL		[blk_class];
	HELP		[func_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	2,		[func_blk_class_DI]		},
		{	250,	[not_used]				},
		{	251,	[none]					},
		{	252,	[unknown]				},
		{	253,	[special]				}
	}	
	HANDLING	READ;
}

func5_DI_blk_dd_reference					LIKE VARIABLE	phys_blk_dd_reference
{											
}											
											
func5_DI_blk_dd_rev							LIKE VARIABLE	phys_blk_dd_rev
{											
}											
											
func5_DI_blk_profile						LIKE VARIABLE	phys_blk_profile
{
}

VARIABLE func5_DI_blk_profile_rev
{
	LABEL		[blk_profile_rev];
	HELP		[blk_profile_rev_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		{	0x0300,	"3.0"	},
		{	0x0301,	"3.01"	}

	}
	HANDLING	READ;
}



func5_DI_blk_execution_time					LIKE VARIABLE	phys_blk_execution_time
{											
}											
											
func5_DI_blk_num_parameters					LIKE VARIABLE	phys_blk_num_parameters
{											
}											

func5_DI_blk_index_view_1					LIKE VARIABLE	phys_blk_index_view_1
{											
}											
											
func5_DI_blk_num_view_lists					LIKE VARIABLE	phys_blk_num_view_lists
{											
}											
											
func5_DI_st_rev								LIKE VARIABLE	phys_st_rev
{											
}											
											
VARIABLE func5_DI_tag_desc
{											
	LABEL		[tag_desc];		
	HELP		[tag_desc_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32);
	HANDLING	READ & WRITE;
}											
											
func5_DI_strategy							LIKE VARIABLE	phys_strategy
{											
}											
											
func5_DI_alert_key							LIKE VARIABLE	phys_alert_key
{
}

VARIABLE func5_DI_target_mode
{
	LABEL		[target_mode];		
	HELP		[target_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE func5_DI_actual_mode
{
	LABEL		[actual_mode];		
	HELP		[actual_mode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE func5_DI_permitted_mode
{
	LABEL		[permitted_mode];		
	HELP		[permitted_mode_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE func5_DI_normal_mode
{
	LABEL		[normal_mode];		
	HELP		[normal_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

func5_DI_current_state_alarm_sum			LIKE VARIABLE	phys_current_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}

}

func5_DI_unacknowledged_state_alarm_sum		LIKE VARIABLE	phys_unacknowledged_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

func5_DI_unreported_state_alarm_sum			LIKE VARIABLE	phys_unreported_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

func5_DI_disabled_state_alarm_sum			LIKE VARIABLE	phys_disabled_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

VARIABLE func5_DI_batch_id
{
	LABEL		[func_batch_id];		
	HELP		[func_batch_id_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func5_DI_batch_unit
{
	LABEL		[func_batch_unit];		
	HELP		[func_batch_unit_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func5_DI_batch_operation
{
	LABEL		[func_batch_operation];		
	HELP		[func_batch_operation_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func5_DI_batch_phase
{
	LABEL		[func_batch_phase];		
	HELP		[func_batch_phase_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

/*---------------------------------------------------------------------*/
/*    Function Block: Discrete Input 1	Additional Parameter		   */
/*---------------------------------------------------------------------*/

VARIABLE func5_DI_out_value
{
	LABEL		[func_out_value];
	HELP		[func_ai_out_value_help];
	CLASS		OUTPUT & DYNAMIC;
	TYPE        UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING
		IF (func5_DI_target_mode == BLOCK_MODE_MAN)
		{
			READ & WRITE;
		}
		ELSE {
			READ;
		}
}

VARIABLE func5_DI_out_status_quality
{
	LABEL		[status_quality];
	HELP		[func_out_status_help];
	CLASS		OUTPUT & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		IF (func5_DI_target_mode == BLOCK_MODE_MAN)
		{
			STATUS_INPUT_NO_RCAS
		}
		ELSE {
			STATUS_OUTPUT_NO_RCAS
		}
	}
	POST_EDIT_ACTIONS
	{
		IF (func5_DI_target_mode == BLOCK_MODE_MAN)
		{
			method_set_status_limit_func5_DI
		}
	}
	HANDLING
		IF (func5_DI_target_mode == BLOCK_MODE_MAN)
		{
			READ & WRITE;
		}
		ELSE {
			READ;
		}
}

func5_DI_out_status_limit					LIKE VARIABLE	func5_DI_out_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_INPUT_LIMIT (func5_DI_out_status_quality)
	}
}

VARIABLE func5_DI_channel
{
   /* ST_REV */
	LABEL		[func_channel];
	HELP		[func_channel_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE 0x013E;
#ifdef FUNC5_CHANNEL_LIST
		FUNC5_CHANNEL_LIST
#endif
	}
	HANDLING	READ & WRITE;
}


VARIABLE func5_DI_invert
{
   /* ST_REV */
	LABEL		[func_invert];
	HELP		[func_invert_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[func_invert_NOT_INVERT]	},
		{	1,	[func_invert_INVERT]		}
	}
	HANDLING	READ & WRITE;
}

VARIABLE func5_DI_fsafe_type /* Art der Reaktion auf Sensorausfall */
{
	/* ST_REV */
	LABEL		[func_ao_fsafe_type];
	HELP		[func_ao_fsafe_type_help_PROFILE_3];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE    FUNC_AI_STORING_LAST_SETPOINT;
		{ FUNC_AI_FAIL_SAFE_VALUE,			[func_ai_fsafe_type_FAIL_SAFE_VALUE]		},
		{ FUNC_AI_STORING_LAST_SETPOINT,	[func_ai_fsafe_type_STORING_LAST_SETPOINT]	},
		{ FUNC_AI_FAIL_SAFE_POSITION,		[func_ai_fsafe_type_FAIL_SAFE_POSITION]		}
	}
   HANDLING		READ & WRITE;
}

VARIABLE func5_DI_fsafe_value /* Ersatzwert bei Sensorausfall */
{
   /* ST_REV */
   LABEL		[func_ai_fsafe_value] ;
   HELP			[func_ai_fsafe_value_help];
   CLASS		CONTAINED;
   TYPE			UNSIGNED_INTEGER (1)
   {
      DEFAULT_VALUE    0;
   }
   HANDLING		READ & WRITE;
   VALIDITY		IF (func5_DI_fsafe_type == FUNC_AI_FAIL_SAFE_VALUE)
				{
					TRUE;
				}
				ELSE
				{
					FALSE;
				}
}

VARIABLE func5_DI_simulate_value
{
   /* ST_REV */
	LABEL		[func_simulate_value];
	HELP		[func_ai_simulate_value_help];
	CLASS		CONTAINED & SERVICE;
	TYPE        UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	0;
	}   
	HANDLING	READ & WRITE;
}

VARIABLE func5_DI_simulate_status_quality
{
	LABEL		[status_quality];
	HELP		[func_simulate_status_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit_func5_DI
	}
	HANDLING	READ & WRITE;
}

func5_DI_simulate_status_limit				LIKE VARIABLE	func5_DI_simulate_status_quality
{
   /* ST_REV */
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_INPUT_LIMIT (func5_DI_simulate_status_quality)
	}
}

VARIABLE func5_DI_simulation_enabled
{
   /* ST_REV */
	LABEL		[func_simulation_enabled];
	HELP		[func_simulation_enabled_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[disabled]		},
		{	1,	[enabled]		}
	}
	HANDLING READ & WRITE;
}


/*---------------------------------------------------------------------*/
/*    Function Block: Commands						                   */
/*---------------------------------------------------------------------*/

COMMAND read_func5_DI_blk
{
	BLOCK func5_DI_block;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_blk_reserve, func5_DI_blk_object, func5_DI_blk_parent_class, func5_DI_blk_class,
			func5_DI_blk_dd_reference, func5_DI_blk_dd_rev, func5_DI_blk_profile, func5_DI_blk_profile_rev,
			func5_DI_blk_execution_time, func5_DI_blk_num_parameters, func5_DI_blk_index_view_1,
			func5_DI_blk_num_view_lists
		}
	}
}

COMMAND read_func5_DI_st_rev
{
	BLOCK func5_DI_block;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_st_rev   
		}
	}
}

COMMAND read_func5_DI_tag_desc
{
	BLOCK func5_DI_block;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_tag_desc
		}
	}
}

COMMAND write_func5_DI_tag_desc
{
	BLOCK func5_DI_block;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func5_DI_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_func5_DI_strategy
{
	BLOCK func5_DI_block;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_strategy
		}
	}
}

COMMAND write_func5_DI_strategy
{
	BLOCK func5_DI_block;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func5_DI_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_func5_DI_alert_key
{
	BLOCK func5_DI_block;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_alert_key
		}
	}
}

COMMAND write_func5_DI_alert_key
{
	BLOCK func5_DI_block;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func5_DI_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_func5_DI_target_mode
{
	BLOCK func5_DI_block;
	INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_target_mode
		}
	}
}

COMMAND write_func5_DI_target_mode
{
	BLOCK func5_DI_block;
	INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func5_DI_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_func5_DI_mode
{
	BLOCK func5_DI_block;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 func5_DI_actual_mode, func5_DI_permitted_mode, func5_DI_normal_mode
		}
	}
}

COMMAND read_func5_DI_alarm
{
	BLOCK func5_DI_block;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_current_state_alarm_sum, func5_DI_unacknowledged_state_alarm_sum,
			func5_DI_unreported_state_alarm_sum, func5_DI_disabled_state_alarm_sum
		}
	}
}

COMMAND read_func5_DI_batch_information
{
	BLOCK func5_DI_block;
	INDEX 8;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_batch_id, func5_DI_batch_unit, func5_DI_batch_operation, func5_DI_batch_phase
		}
	}
}

COMMAND write_func5_DI_batch_information
{
	BLOCK func5_DI_block;
	INDEX 8;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func5_DI_batch_id, func5_DI_batch_unit, func5_DI_batch_operation, func5_DI_batch_phase
		}
		REPLY
		{
		}
	}
}

/*---------------------------------------------------------------------*/
/*    Function Block :  Commands	Additional Parameter	           */
/*---------------------------------------------------------------------*/
COMMAND read_func5_DI_out 
{
	BLOCK func5_DI_block;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_out_value, 
			func5_DI_out_status_quality	<0xFC>,
			func5_DI_out_status_limit	<0x03>,
		}
	}
}

COMMAND write_func5_DI_out 
{
	BLOCK func5_DI_block;
	INDEX 10;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func5_DI_out_value, 
			func5_DI_out_status_quality	<0xFC>,
			func5_DI_out_status_limit	<0x03>,
		}
		REPLY
		{
		}
	}
}

COMMAND read_func5_DI_channel 
{
	BLOCK func5_DI_block;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_channel
		}
	}
}

COMMAND write_func5_DI_channel 
{
	BLOCK func5_DI_block;
	INDEX 14;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func5_DI_channel
		}
		REPLY
		{
		}
	}
}

COMMAND read_func5_DI_invert 
{
	BLOCK func5_DI_block;
	INDEX 15;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_invert
		}
	}
}

COMMAND write_func5_DI_invert 
{
	BLOCK func5_DI_block;
	INDEX 15;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func5_DI_invert
		}
		REPLY
		{
		}
	}
}

COMMAND read_func5_DI_fsafe_type
{
	BLOCK func5_DI_block;
	INDEX 20;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_fsafe_type
		}
	}
}

COMMAND write_func5_DI_fsafe_type
{
	BLOCK func5_DI_block;
	INDEX 20;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func5_DI_fsafe_type
		}
		REPLY
		{
		}
	}
}

COMMAND read_func5_DI_fsafe_value
{
	BLOCK func5_DI_block;
	INDEX 21;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_fsafe_value
		}
	}
}

COMMAND write_func5_DI_fsafe_value
{
	BLOCK func5_DI_block;
	INDEX 21;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func5_DI_fsafe_value
		}
		REPLY
		{
		}
	}
}

COMMAND read_func5_DI_simulate 
{
	BLOCK func5_DI_block;
	INDEX 24;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func5_DI_simulate_status_quality	<0xFC>,
			func5_DI_simulate_status_limit		<0x03>,
			func5_DI_simulate_value, 
			func5_DI_simulation_enabled
		}
	}
}

COMMAND write_func5_DI_simulate 
{
	BLOCK func5_DI_block;
	INDEX 24;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func5_DI_simulate_status_quality	<0xFC>,
			func5_DI_simulate_status_limit		<0x03>,
			func5_DI_simulate_value, 
			func5_DI_simulation_enabled
		}
		REPLY
		{
		}
	}
}


/*---------------------------------------------------------------------*/
/*    Function Block: Methods                                          */
/*---------------------------------------------------------------------*/

METHOD method_set_status_limit_func5_DI
{
	CLASS		INPUT;
	DEFINITION
	{
		int	quality;
		int block_mode;			/* !!! temp.: bis Methoden mit Aufrufparametern funktionieren !!! */

		quality = ivar_value(func5_DI_simulate_status_quality);
		if ((quality == 0x20) || (quality == 0x30))
			iassign(func5_DI_simulate_status_limit, 0);

		block_mode	= ivar_value(func5_DI_target_mode);
		quality		= ivar_value(func5_DI_out_status_quality);
		if ((block_mode == BLOCK_MODE_MAN) && ((quality == 0x20) || (quality == 0x30)))
			iassign(func5_DI_out_status_limit, 0);
	}
}

/***********************************************************************/
/*    Function Block  Unit Relations                                   */
/***********************************************************************/

/* Function Block : no unit relations */


/***********************************************************************/
/*    Function Block   Collections                                     */
/***********************************************************************/

COLLECTION OF VARIABLE func5
{
	MEMBERS
	{
		actual_mode,		func5_DI_actual_mode,			FUNC5_TITLE ;
		simulation_enabled, func5_DI_simulation_enabled,	FUNC5_TITLE ;
		out,				func5_DI_out_value,			FUNC5_TITLE ;
		simulate_value,		func5_DI_simulate_value,		FUNC5_TITLE ;
	}
}

/***********************************************************************/
/*    Function Block : Tab-MENUs                                       */
/***********************************************************************/

MENU Tab_s_func5
{
	LABEL		FUNC5_TITLE;
	ITEMS
	{
		func5_DI_st_rev,

#ifdef FUNC5_CHANNEL_LIST
		func5_DI_channel,
#endif
		func5_DI_invert,
		
		func5_DI_target_mode,		//Add
		func5_DI_actual_mode,		//Add
		
		Tab_s_func5_DI_batch,
		Tab_s_func5_DI_fsafe
	}
}


MENU Tab_m_func5
{
	LABEL		FUNC5_TITLE;
	ITEMS
	{
		func5_DI_st_rev,

#ifdef FUNC5_CHANNEL_LIST
		func5_DI_channel	(READ_ONLY),
#endif
		
		func5_DI_target_mode(READ_ONLY),	//Add
		func5_DI_actual_mode,				//Add

		Tab_s_func5_DI_batch,
		Tab_m_func5_DI_fsafe
	}
}

MENU Tab_s_func5_DI_batch
{
	LABEL		[menu_ident_batch_info];
	ITEMS
	{
			func5_DI_batch_id,
			func5_DI_batch_unit,
			func5_DI_batch_operation,
			func5_DI_batch_phase
	}
}

MENU Tab_s_func5_DI_fsafe
{
	LABEL [menu_fail_safe] ;
	ITEMS
	{
		func5_DI_fsafe_type,		
		func5_DI_fsafe_value
	}
}

MENU Tab_m_func5_DI_fsafe
{
	LABEL [menu_fail_safe] ;
	ITEMS
	{
		func5_DI_fsafe_type		(READ_ONLY),		
		func5_DI_fsafe_value	(READ_ONLY)
	}
}

/***********************************************************************/
/*    Function Block : Online-Windows                                  */
/***********************************************************************/


/*---------------------------------------------------------------------*/
/*    Function Block: Display Menus						               */
/*---------------------------------------------------------------------*/


MENU Page_display_func5
{
	LABEL		FUNC5_TITLE;
	ITEMS
	{

		BarVal_out_display_func5,
		Group_display_func5_out
		Group_display_func5_in
	}
}

MENU BarVal_out_display_func5
{
	LABEL		[func_out_value];
	HELP		[func_DI_out_value_help];
	ITEMS
	{
		func5_DI_out_value				(READ_ONLY),
	}
}

MENU Group_display_func5
{
	LABEL		FUNC5_TITLE;
	ITEMS
	{
		func5_DI_actual_mode	(READ_ONLY),
		func5_DI_current_state_alarm_sum	(READ_ONLY),
		func5_DI_unreported_state_alarm_sum	(READ_ONLY)

	}
}

MENU Group_display_func5_out
{
	LABEL		[menu_dialog_display_output] ;
	ITEMS
	{
		func5_DI_actual_mode	(READ_ONLY),
#ifdef _PDM_
		SEPARATOR,
#endif
		func5_DI_out_status_quality	(READ_ONLY),
		func5_DI_out_status_limit	(READ_ONLY)
		func5_DI_current_state_alarm_sum	(READ_ONLY),
	}
}

MENU Group_display_func5_in
{
	LABEL		[menu_dialog_display_input] ;
	ITEMS
	{
#ifdef FUNC5_PV
		FUNC5_PV,
#endif

#ifdef FUNC5_CHANNEL_LIST
		func5_DI_channel	(READ_ONLY),
#endif
	
#ifdef _PDM_
		SEPARATOR,
#endif
		func5_DI_invert 	(READ_ONLY),

#ifdef FUNC5_PV_STATUS
		FUNC5_PV_STATUS,
#endif
		func5_DI_simulation_enabled	(READ_ONLY)
	}
}

/*---------------------------------------------------------------------*/
/*    Function Block: Alarm Menus                                      */
/*---------------------------------------------------------------------*/

MENU OnlineWindow_S_alarm_func5
{
	LABEL		FUNC5_TITLE;
	ITEMS
	{
		Page_alarm_sum_func5
	}
}

MENU OnlineWindow_M_alarm_func5
{
	LABEL		FUNC5_TITLE;
	ITEMS
	{
		Page_alarm_sum_func5
	}
}

MENU Page_alarm_sum_func5
{
	LABEL		[menu_dialog_alarm_sum];
	ITEMS
	{
	    func5_DI_current_state_alarm_sum,
		func5_DI_unacknowledged_state_alarm_sum,
#ifdef _PDM_
		SEPARATOR,
#endif
		func5_DI_unreported_state_alarm_sum,
		func5_DI_disabled_state_alarm_sum
	}
}

/*---------------------------------------------------------------------*/
/*    Function Block: Diagnosis Menus						               */
/*---------------------------------------------------------------------*/

MENU Page_diagnosis_func5
{
	LABEL		FUNC5_TITLE;
	ITEMS
	{
		func5_DI_blk_object,
		func5_DI_blk_parent_class,
		func5_DI_blk_class,
		func5_DI_blk_dd_reference,
		func5_DI_blk_dd_rev,
		func5_DI_blk_profile,
		func5_DI_blk_profile_rev,
		func5_DI_st_rev,
		func5_DI_actual_mode
	}
}


/*---------------------------------------------------------------------*/
/*    Function Block: Simulation Menus						               */
/*---------------------------------------------------------------------*/

MENU OnlineDialog_simulation_func5
{
	LABEL		FUNC5_TITLE;
	ITEMS
	{
		Page_simulation_input_func5,
		Page_simulation_output_func5
	}
}

MENU Page_simulation_input_func5
{
	LABEL		[menu_dialog_simulation_input];
	ITEMS
	{
		func5_DI_simulation_enabled,
		Group_simulate_input_func5,
#ifdef _PDM_
		method_set
#endif
	}
}

MENU Group_simulate_input_func5
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func5_DI_simulate_value,
#ifdef _PDM_
		SEPARATOR,
#endif
		func5_DI_simulate_status_quality,
		func5_DI_simulate_status_limit
	}
}

MENU Page_simulation_output_func5
{
	LABEL		[menu_dialog_simulation_output];
	ITEMS
	{
		func5_DI_target_mode,
		func5_DI_actual_mode,
		Group_simulate_output_func5,
#ifdef _PDM_
		method_set
#endif
	}
}

MENU Group_simulate_output_func5
{
	LABEL		[func_out_value];
	ITEMS
	{
		func5_DI_out_value,
#ifdef _PDM_
		SEPARATOR,
#endif
		func5_DI_out_status_quality,
		func5_DI_out_status_limit
	}
}


