/***************************************************************************************************
*  Copyright (C) Yokogawa Electric Corporation 2003,2004  All Rights Reserved.                     *
*
*  $Workfile:   YEC_AXF0101PA.h  $
*    $Author:   harigane.daisuke  $
*  $Revision:   1.1  $
*      $Date:   2007/10/17 10:53:28  $
*                                                                                                  *
****************************************************************************************************
*  PROJECT_NAME        AXF Profibus PA
*
*  FIRST_AUTHOR        Daisuke Harigane
*
*  FILE_DESCRIPTION    AXF (Profibus PA) DD sorce file for DTM and PDM
*
*  FUNCTIONAL_MODULE_DESCRIPTION
*    This file used in order to define "#define"
*=================================================================================================*/

#define FLOAT_INF_P 3.40282366920938E+38
#define FLOAT_INF_N -3.40282366920938E+38

/* Identcheck */
//#define 	CHECK_PROFILE_REV			0x300		// Profil-Revision (3.0)
#define 	CHECK_PROFILE_REV			0x301		// Profil-Revision (3.1)
#define 	DEFAULT_MANUFACTURER_ID		55			// Manufacturer
//#define		CHECK_DEVICE_TYPE			"ADMAG AXF"	// Device
#define		CHECK_DEVICE_TYPE			"AXF"		// Device

#define DEVICE_TITLE [axf_pa]

/* TB */
#define LOW_FLOW_CUTOFF_DEFAULT_SELECT 0.0

#define AXFPA_TRANS_UNIT_LIST															\
		{ 1355,	[unit_1355],	[unit_1355_help]	},		/* Ml/d          */			\
		{ 1522,	[unit_1522],	[unit_1522_help]	},		/* Ml/h          */			\
		{ 1521,	[unit_1521],	[unit_1521_help]	},		/* Ml/min        */			\
		{ 1350,	[unit_1350],	[unit_1350_help]	},		/* m3/d          */			\
		{ 1349,	[unit_1349],	[unit_1349_help]	},		/* m3/h          */			\
		{ 1348,	[unit_1348],	[unit_1348_help]	},		/* m3/min        */			\
		{ 1347,	[unit_1347],	[unit_1347_help]	},		/* m3/sec        */			\
		{ 1520,	[unit_1520],	[unit_1520_help]	},		/* kL/d          */			\
		{ 1519,	[unit_1519],	[unit_1519_help]	},		/* kL/h          */			\
		{ 1518,	[unit_1518],	[unit_1518_help]	},		/* kL/min        */			\
		{ 1523,	[unit_1523],	[unit_1523_help]	},		/* kL/s          */			\
		{ 1354,	[unit_1354],	[unit_1354_help]	},		/* l/d           */			\
		{ 1353,	[unit_1353],	[unit_1353_help]	},		/* l/h           */			\
		{ 1352,	[unit_1352],	[unit_1352_help]	},		/* l/min         */			\
		{ 1351,	[unit_1351],	[unit_1351_help]	},		/* l/sec         */			\
		{ 1514,	[unit_1514],	[unit_1514_help]	},		/* cm3/d         */			\
		{ 1513,	[unit_1513],	[unit_1513_help]	},		/* cm3/h         */			\
		{ 1512,	[unit_1512],	[unit_1512_help]	},		/* cm3/min       */			\
		{ 1511,	[unit_1511],	[unit_1511_help]	},		/* cm3/s         */			\
		{ 1061,	[unit_1061],	[unit_1061_help]	},		/* m/s           */			\
		{ 1329,	[unit_1329],	[unit_1329_help]	},		/* t/d           */			\
		{ 1328,	[unit_1328],	[unit_1328_help]	},		/* t/h           */			\
		{ 1327,	[unit_1327],	[unit_1327_help]	},		/* t/min         */			\
		{ 1326,	[unit_1326],	[unit_1326_help]	},		/* t/s           */			\
		{ 1325,	[unit_1325],	[unit_1325_help]	},		/* kg/d          */			\
		{ 1324,	[unit_1324],	[unit_1324_help]	},		/* kg/h          */			\
		{ 1323,	[unit_1323],	[unit_1323_help]	},		/* kg/min        */			\
		{ 1322,	[unit_1322],	[unit_1322_help]	},		/* kg/s          */			\
		{ 1321,	[unit_1321],	[unit_1321_help]	},		/* g/d           */			\
		{ 1320,	[unit_1320],	[unit_1320_help]	},		/* g/h           */			\
		{ 1319,	[unit_1319],	[unit_1319_help]	},		/* g/min         */			\
		{ 1318,	[unit_1318],	[unit_1318_help]	},		/* g/s           */			\
		{ 1527,	[unit_1527],	[unit_1527_help]	},		/* kft3/d        */			\
		{ 1526,	[unit_1526],	[unit_1526_help]	},		/* kCFH          */			\
		{ 1525,	[unit_1525],	[unit_1525_help]	},		/* kCFM          */			\
		{ 1524,	[unit_1524],	[unit_1524_help]	},		/* kCFS          */			\
		{ 1359,	[unit_1359],	[unit_1359_help]	},		/* ft3/d         */			\
		{ 1358,	[unit_1358],	[unit_1358_help]	},		/* ft3/h         */			\
		{ 1357,	[unit_1357],	[unit_1357_help]	},		/* ft3/min       */			\
		{ 1356,	[unit_1356],	[unit_1356_help]	},		/* ft3/sec       */			\
		{ 1531,	[unit_1531],	[unit_1531_help]	},		/* mft3/d        */			\
		{ 1530,	[unit_1530],	[unit_1530_help]	},		/* mCFH          */			\
		{ 1529,	[unit_1529],	[unit_1529_help]	},		/* mCFM          */			\
		{ 1528,	[unit_1528],	[unit_1528_help]	},		/* mCFS          */			\
		{ 1366,	[unit_1366],	[unit_1366_help]	},		/* Mega US gal/d */			\
		{ 1459,	[unit_1459],	[unit_1459_help]	},		/* Mega US gal/h */			\
		{ 1455,	[unit_1455],	[unit_1455_help]	},		/* Mega US gal/min */		\
		{ 1451,	[unit_1451],	[unit_1451_help]	},		/* Mega US gal/s */			\
		{ 1462,	[unit_1462],	[unit_1462_help]	},		/* kgal/d        */			\
		{ 1458,	[unit_1458],	[unit_1458_help]	},		/* kgal/h        */			\
		{ 1454,	[unit_1454],	[unit_1454_help]	},		/* kgal/min      */			\
		{ 1450,	[unit_1450],	[unit_1450_help]	},		/* kgal/s        */			\
		{ 1365,	[unit_1365],	[unit_1365_help]	},		/* US gallon/d   */			\
		{ 1364,	[unit_1364],	[unit_1364_help]	},		/* US gallon/h   */			\
		{ 1363,	[unit_1363],	[unit_1363_help]	},		/* US gallon/min */			\
		{ 1362,	[unit_1362],	[unit_1362_help]	},		/* US gallon/sec */			\
		{ 1461,	[unit_1461],	[unit_1461_help]	},		/* mgal/d        */			\
		{ 1457,	[unit_1457],	[unit_1457_help]	},		/* mgal/h        */			\
		{ 1453,	[unit_1453],	[unit_1453_help]	},		/* mgal/min      */			\
		{ 1449,	[unit_1449],	[unit_1449_help]	},		/* mgal/s        */			\
		{ 1493,	[unit_1493],	[unit_1493_help]	},		/* kbbl/d   (US Oil) */		\
		{ 1489,	[unit_1489],	[unit_1489_help]	},		/* kbbl/h   (US Oil) */		\
		{ 1485,	[unit_1485],	[unit_1485_help]	},		/* kbbl/min (US Oil) */		\
		{ 1481,	[unit_1481],	[unit_1481_help]	},		/* kbbl/s   (US Oil) */		\
		{ 1374,	[unit_1374],	[unit_1374_help]	},		/* bbl/d    (US Oil) */		\
		{ 1373,	[unit_1373],	[unit_1373_help]	},		/* bbl/h    (US Oil) */		\
		{ 1372,	[unit_1372],	[unit_1372_help]	},		/* bbl/min  (US Oil) */		\
		{ 1371,	[unit_1371],	[unit_1371_help]	},		/* bbl/s    (US Oil) */		\
		{ 1492,	[unit_1492],	[unit_1492_help]	},		/* mbbl/d   (US Oil) */		\
		{ 1488,	[unit_1488],	[unit_1488_help]	},		/* mbbl/h   (US Oil) */		\
		{ 1484,	[unit_1484],	[unit_1484_help]	},		/* mbbl/min (US Oil) */		\
		{ 1480,	[unit_1480],	[unit_1480_help]	},		/* mbbl/s   (US Oil) */		\
		{ 1491,	[unit_1491],	[unit_1491_help]	},		/* ubbl/d   (US Oil) */		\
		{ 1487,	[unit_1487],	[unit_1487_help]	},		/* ubbl/h   (US Oil) */		\
		{ 1483,	[unit_1483],	[unit_1483_help]	},		/* ubbl/min (US Oil) */		\
		{ 1479,	[unit_1479],	[unit_1479_help]	},		/* ubbl/s   (US Oil) */		\
		{ 1534,	[unit_1534],	[unit_1534_help]	},		/* kbbl/d   (US federal) */	\
		{ 1533,	[unit_1533],	[unit_1533_help]	},		/* kbbl/h   (US federal) */	\
		{ 1532,	[unit_1532],	[unit_1532_help]	},		/* kbbl/min (US federal) */	\
		{ 1645,	[unit_1645],	[unit_1645_help]	},		/* bbl/d    (US federal) */	\
		{ 1644,	[unit_1644],	[unit_1644_help]	},		/* bbl/h    (US federal) */	\
		{ 1643,	[unit_1643],	[unit_1643_help]	},		/* bbl/min  (US federal) */	\
		{ 1642,	[unit_1642],	[unit_1642_help]	},		/* bbl/s    (US federal) */	\
		{ 1542,	[unit_1542],	[unit_1542_help]	},		/* mbbl/d   (US federal) */	\
		{ 1541,	[unit_1541],	[unit_1541_help]	},		/* mbbl/h   (US federal) */	\
		{ 1540,	[unit_1540],	[unit_1540_help]	},		/* mbbl/min (US federal) */	\
		{ 1539,	[unit_1539],	[unit_1539_help]	},		/* mbbl/s   (US federal) */	\
		{ 1544,	[unit_1544],	[unit_1544_help]	},		/* ubbl/min (US federal) */	\
		{ 1543,	[unit_1543],	[unit_1543_help]	},		/* ubbl/s   (US federal) */	\
		{ 1067,	[unit_1067],	[unit_1067_help]	},		/* ft/s          */			\
		{ 1548,	[unit_1548],	[unit_1548_help]	},		/* klb/d         */			\
		{ 1547,	[unit_1547],	[unit_1547_help]	},		/* klb/h         */			\
		{ 1546,	[unit_1546],	[unit_1546_help]	},		/* klb/min       */			\
		{ 1545,	[unit_1545],	[unit_1545_help]	},		/* klb/s         */			\
		{ 1333,	[unit_1333],	[unit_1333_help]	},		/* lb/d          */			\
		{ 1332,	[unit_1332],	[unit_1332_help]	},		/* lb/h          */			\
		{ 1331,	[unit_1331],	[unit_1331_help]	},		/* lb/min        */			\
		{ 1330,	[unit_1330],	[unit_1330_help]	}		/* lb/s          */

/* ALARM PERFORM BIT DEFINE */
#define MASK_SIG_OVERFLOW		0x00000001			/* (bit0)  */
#define MASK_EMPTY_PIPE			0x00000002			/* (bit1)  */
#define MASK_ADHESION_ALM		0x00000004			/* (bit2)  */
#define MASK_ADHESION_WNG		0x00000008			/* (bit3)  */
#define MASK_AUTOZERO_WNG		0x00000010			/* (bit4)  */
#define MASK_FLOW_VEL_OVER		0x00000020			/* (bit5)  */
#define BIT6_NOT_USE			0x00000040			/* (bit6)  */
#define BIT7_NOT_USE			0x00000080			/* (bit7)  */

#define BIT8_NOT_USE			0x00000100			/* (bit8)  */
#define BIT9_NOT_USE			0x00000200			/* (bit9)  */
#define BIT10_NOT_USE			0x00000400			/* (bit10) */
#define BIT11_NOT_USE			0x00000800			/* (bit11) */
#define BIT12_NOT_USE			0x00001000			/* (bit12) */
#define BIT13_NOT_USE			0x00002000			/* (bit13) */
#define BIT14_NOT_USE			0x00004000			/* (bit14) */
#define BIT15_NOT_USE			0x00008000			/* (bit15) */

#define MASK_AI_ALARM			0x00010000			/* (bit16) */
#define MASK_TOT1_ALARM			0x00020000			/* (bit17) */
#define MASK_TOT2_ALARM			0x00040000			/* (bit18) */
#define MASK_TOT3_ALARM			0x00080000			/* (bit19) */
#define MASK_DI1_ALARM			0x00100000			/* (bit20) */
#define MASK_DI2_ALARM			0x00200000			/* (bit21) */
#define BIT22_NOT_USE			0x00400000			/* (bit22) */
#define BIT23_NOT_USE			0x00800000			/* (bit23) */

#define BIT24_NOT_USE			0x01000000			/* (bit24) */
#define BIT25_NOT_USE			0x02000000			/* (bit25) */
#define BIT26_NOT_USE			0x04000000			/* (bit26) */
#define BIT27_NOT_USE			0x08000000			/* (bit27) */
#define BIT28_NOT_USE			0x10000000			/* (bit28) */
#define BIT29_NOT_USE			0x20000000			/* (bit29) */
#define BIT30_NOT_USE			0x40000000			/* (bit30) */
#define BIT31_NOT_USE			0x80000000			/* (bit31) */




/* PB */
#define PHYS_ADDITIONAL_PARAMETER				phys_soft_desc
#define DEVICE_TYPE								"ADMAG AXF"
#define DEFAULT_phys_ident_number				1
#define DEFAULT_VALUE_phys_device_certification	""
#define DEFAULT_VALUE_phys_blk_profile			0x4002


/* AI */
#define FUNC1_DEFAULT_UNIT 1349
#define FUNC1_TITLE	[func_blk_class_AI]
#define FUNC1_CHANNEL_LIST { 0x111, "Volume Flow Value" }

#define DEFAULT_VALUE_func1_upper_range_value	28.27433
#define DEFAULT_VALUE_func1_lower_range_value	 0.00000
#define MAX_VALUE_func1_AI_pv_ftime				FLOAT_INF_P
#define DEFAULT_VALUE_func1_AI_pv_ftime			0.000

#define FUNC1_UNIT_LIST								    \
		{ 1342,	[unit_1342],	[unit_1342_help]	},	\
		{ 1355,	[unit_1355],	[unit_1355_help]	},	\
		{ 1522,	[unit_1522],	[unit_1522_help]	},	\
		{ 1521,	[unit_1521],	[unit_1521_help]	},	\
		{ 1350,	[unit_1350],	[unit_1350_help]	},	\
		{ 1349,	[unit_1349],	[unit_1349_help]	},	\
		{ 1348,	[unit_1348],	[unit_1348_help]	},	\
		{ 1347,	[unit_1347],	[unit_1347_help]	},	\
		{ 1520,	[unit_1520],	[unit_1520_help]	},	\
		{ 1519,	[unit_1519],	[unit_1519_help]	},	\
		{ 1518,	[unit_1518],	[unit_1518_help]	},	\
		{ 1523,	[unit_1523],	[unit_1523_help]	},	\
		{ 1354,	[unit_1354],	[unit_1354_help]	},	\
		{ 1353,	[unit_1353],	[unit_1353_help]	},	\
		{ 1352,	[unit_1352],	[unit_1352_help]	},	\
		{ 1351,	[unit_1351],	[unit_1351_help]	},	\
		{ 1514,	[unit_1514],	[unit_1514_help]	},	\
		{ 1513,	[unit_1513],	[unit_1513_help]	},	\
		{ 1512,	[unit_1512],	[unit_1512_help]	},	\
		{ 1511,	[unit_1511],	[unit_1511_help]	},	\
		{ 1061,	[unit_1061],	[unit_1061_help]	},	\
		{ 1329,	[unit_1329],	[unit_1329_help]	},	\
		{ 1328,	[unit_1328],	[unit_1328_help]	},	\
		{ 1327,	[unit_1327],	[unit_1327_help]	},	\
		{ 1326,	[unit_1326],	[unit_1326_help]	},	\
		{ 1325,	[unit_1325],	[unit_1325_help]	},	\
		{ 1324,	[unit_1324],	[unit_1324_help]	},	\
		{ 1323,	[unit_1323],	[unit_1323_help]	},	\
		{ 1322,	[unit_1322],	[unit_1322_help]	},	\
		{ 1321,	[unit_1321],	[unit_1321_help]	},	\
		{ 1320,	[unit_1320],	[unit_1320_help]	},	\
		{ 1319,	[unit_1319],	[unit_1319_help]	},	\
		{ 1318,	[unit_1318],	[unit_1318_help]	},	\
		{ 1527,	[unit_1527],	[unit_1527_help]	},	\
		{ 1526,	[unit_1526],	[unit_1526_help]	},	\
		{ 1525,	[unit_1525],	[unit_1525_help]	},	\
		{ 1524,	[unit_1524],	[unit_1524_help]	},	\
		{ 1359,	[unit_1359],	[unit_1359_help]	},	\
		{ 1358,	[unit_1358],	[unit_1358_help]	},	\
		{ 1357,	[unit_1357],	[unit_1357_help]	},	\
		{ 1356,	[unit_1356],	[unit_1356_help]	},	\
		{ 1531,	[unit_1531],	[unit_1531_help]	},	\
		{ 1530,	[unit_1530],	[unit_1530_help]	},	\
		{ 1529,	[unit_1529],	[unit_1529_help]	},	\
		{ 1528,	[unit_1528],	[unit_1528_help]	},	\
		{ 1366,	[unit_1366],	[unit_1366_help]	},	\
		{ 1459,	[unit_1459],	[unit_1459_help]	},	\
		{ 1455,	[unit_1455],	[unit_1455_help]	},	\
		{ 1451,	[unit_1451],	[unit_1451_help]	},	\
		{ 1462,	[unit_1462],	[unit_1462_help]	},	\
		{ 1458,	[unit_1458],	[unit_1458_help]	},	\
		{ 1454,	[unit_1454],	[unit_1454_help]	},	\
		{ 1450,	[unit_1450],	[unit_1450_help]	},	\
		{ 1365,	[unit_1365],	[unit_1365_help]	},	\
		{ 1364,	[unit_1364],	[unit_1364_help]	},	\
		{ 1363,	[unit_1363],	[unit_1363_help]	},	\
		{ 1362,	[unit_1362],	[unit_1362_help]	},	\
		{ 1461,	[unit_1461],	[unit_1461_help]	},	\
		{ 1457,	[unit_1457],	[unit_1457_help]	},	\
		{ 1453,	[unit_1453],	[unit_1453_help]	},	\
		{ 1449,	[unit_1449],	[unit_1449_help]	},	\
		{ 1493,	[unit_1493],	[unit_1493_help]	},	\
		{ 1489,	[unit_1489],	[unit_1489_help]	},	\
		{ 1485,	[unit_1485],	[unit_1485_help]	},	\
		{ 1481,	[unit_1481],	[unit_1481_help]	},	\
		{ 1374,	[unit_1374],	[unit_1374_help]	},	\
		{ 1373,	[unit_1373],	[unit_1373_help]	},	\
		{ 1372,	[unit_1372],	[unit_1372_help]	},	\
		{ 1371,	[unit_1371],	[unit_1371_help]	},	\
		{ 1492,	[unit_1492],	[unit_1492_help]	},	\
		{ 1488,	[unit_1488],	[unit_1488_help]	},	\
		{ 1484,	[unit_1484],	[unit_1484_help]	},	\
		{ 1480,	[unit_1480],	[unit_1480_help]	},	\
		{ 1491,	[unit_1491],	[unit_1491_help]	},	\
		{ 1487,	[unit_1487],	[unit_1487_help]	},	\
		{ 1483,	[unit_1483],	[unit_1483_help]	},	\
		{ 1479,	[unit_1479],	[unit_1479_help]	},	\
		{ 1534,	[unit_1534],	[unit_1534_help]	},	\
		{ 1533,	[unit_1533],	[unit_1533_help]	},	\
		{ 1532,	[unit_1532],	[unit_1532_help]	},	\
		{ 1645,	[unit_1645],	[unit_1645_help]	},	\
		{ 1644,	[unit_1644],	[unit_1644_help]	},	\
		{ 1643,	[unit_1643],	[unit_1643_help]	},	\
		{ 1642,	[unit_1642],	[unit_1642_help]	},	\
		{ 1542,	[unit_1542],	[unit_1542_help]	},	\
		{ 1541,	[unit_1541],	[unit_1541_help]	},	\
		{ 1540,	[unit_1540],	[unit_1540_help]	},	\
		{ 1539,	[unit_1539],	[unit_1539_help]	},	\
		{ 1544,	[unit_1544],	[unit_1544_help]	},	\
		{ 1543,	[unit_1543],	[unit_1543_help]	},	\
		{ 1067,	[unit_1067],	[unit_1067_help]	},	\
		{ 1548,	[unit_1548],	[unit_1548_help]	},	\
		{ 1547,	[unit_1547],	[unit_1547_help]	},	\
		{ 1546,	[unit_1546],	[unit_1546_help]	},	\
		{ 1545,	[unit_1545],	[unit_1545_help]	},	\
		{ 1333,	[unit_1333],	[unit_1333_help]	},	\
		{ 1332,	[unit_1332],	[unit_1332_help]	},	\
		{ 1331,	[unit_1331],	[unit_1331_help]	},	\
		{ 1330,	[unit_1330],	[unit_1330_help]	},	\
		{ 1337,	[unit_1337],	[unit_1337_help]	},	\
		{ 1336,	[unit_1336],	[unit_1336_help]	},	\
		{ 1335,	[unit_1335],	[unit_1335_help]	},	\
		{ 1334,	[unit_1334],	[unit_1334_help]	},	\
		{ 1341,	[unit_1341],	[unit_1341_help]	},	\
		{ 1340,	[unit_1340],	[unit_1340_help]	},	\
		{ 1339,	[unit_1339],	[unit_1339_help]	},	\
		{ 1338,	[unit_1338],	[unit_1338_help]	},	\
		{ 1478,	[unit_1478],	[unit_1478_help]	},	\
		{ 1474,	[unit_1474],	[unit_1474_help]	},	\
		{ 1470,	[unit_1470],	[unit_1470_help]	},	\
		{ 1466,	[unit_1466],	[unit_1466_help]	},	\
		{ 1477,	[unit_1477],	[unit_1477_help]	},	\
		{ 1473,	[unit_1473],	[unit_1473_help]	},	\
		{ 1469,	[unit_1469],	[unit_1469_help]	},	\
		{ 1465,	[unit_1465],	[unit_1465_help]	},	\
		{ 1370,	[unit_1370],	[unit_1370_help]	},	\
		{ 1369,	[unit_1369],	[unit_1369_help]	},	\
		{ 1368,	[unit_1368],	[unit_1368_help]	},	\
		{ 1367,	[unit_1367],	[unit_1367_help]	},	\
		{ 1476,	[unit_1476],	[unit_1476_help]	},	\
		{ 1472,	[unit_1472],	[unit_1472_help]	},	\
		{ 1468,	[unit_1468],	[unit_1468_help]	},	\
		{ 1464,	[unit_1464],	[unit_1464_help]	},	\
		{ 1995,	func1_AI_out_unit_text              }
		

/* TOT1, TOT2, TOT3 */
#define FUNC2_TITLE	"Totilizer1"
#define FUNC3_TITLE	"Totilizer2"
#define FUNC4_TITLE	"Totilizer3"

#define FUNC2_CHANNEL_LIST { 0x111, "Volume Flow Value" }
#define FUNC3_CHANNEL_LIST { 0x111, "Volume Flow Value" }
#define FUNC4_CHANNEL_LIST { 0x111, "Volume Flow Value" }

#define FUNC2_DEFAULT_UNIT 1034
#define FUNC3_DEFAULT_UNIT 1034
#define FUNC4_DEFAULT_UNIT 1034

#define DEFAULT_VALUE_func2_TOT_hi_hi_lim	FLOAT_INF_P
#define DEFAULT_VALUE_func2_TOT_hi_lim		FLOAT_INF_P
#define DEFAULT_VALUE_func2_TOT_lo_lim		FLOAT_INF_N
#define DEFAULT_VALUE_func2_TOT_lo_lo_lim	FLOAT_INF_N
#define DEFAULT_VALUE_func2_TOT_alarm_hys	0.00

#define DEFAULT_VALUE_func3_TOT_hi_hi_lim	FLOAT_INF_P
#define DEFAULT_VALUE_func3_TOT_hi_lim		FLOAT_INF_P
#define DEFAULT_VALUE_func3_TOT_lo_lim		FLOAT_INF_N
#define DEFAULT_VALUE_func3_TOT_lo_lo_lim	FLOAT_INF_N
#define DEFAULT_VALUE_func3_TOT_alarm_hys	0.00

#define DEFAULT_VALUE_func4_TOT_hi_hi_lim	FLOAT_INF_P
#define DEFAULT_VALUE_func4_TOT_hi_lim		FLOAT_INF_P
#define DEFAULT_VALUE_func4_TOT_lo_lim		FLOAT_INF_N
#define DEFAULT_VALUE_func4_TOT_lo_lo_lim	FLOAT_INF_N
#define DEFAULT_VALUE_func4_TOT_alarm_hys	0.00

#define AXF_PA_TOT_UNITS							    \
		{ 1549,	[unit_1549],	[unit_1549_help]	},	\
		{ 1034,	[unit_1034],	[unit_1034_help]	},	\
		{ 1517,	[unit_1517],	[unit_1517_help]	},	\
		{ 1041,	[unit_1041],	[unit_1041_help]	},	\
		{ 1038,	[unit_1038],	[unit_1038_help]	},	\
		{ 1040,	[unit_1040],	[unit_1040_help]	},	\
		{ 1035,	[unit_1035],	[unit_1035_help]	},	\
		{ 1036,	[unit_1036],	[unit_1036_help]	},	\
		{ 1092,	[unit_1092],	[unit_1092_help]	},	\
		{ 1091,	[unit_1091],	[unit_1091_help]	},	\
		{ 1088,	[unit_1088],	[unit_1088_help]	},	\
		{ 1089,	[unit_1089],	[unit_1089_help]	},	\
		{ 1090,	[unit_1090],	[unit_1090_help]	},	\
		{ 1043,	[unit_1043],	[unit_1043_help]	},	\
		{ 1048,	[unit_1048],	[unit_1048_help]	},	\
		{ 1051,	[unit_1051],	[unit_1051_help]	},	\
		{ 1641,	[unit_1641],	[unit_1641_help]	},	\
		{ 1094,	[unit_1094],	[unit_1094_help]	}

#define FUNC2_UNIT_LIST AXF_PA_TOT_UNITS
#define FUNC3_UNIT_LIST AXF_PA_TOT_UNITS
#define FUNC4_UNIT_LIST AXF_PA_TOT_UNITS

/* DI1, DI2 */
#define FUNC5_TITLE	"Discrete Input1"
#define FUNC6_TITLE	"Discrete Input2"

#define FUNC5_CHANNEL_LIST { 0x013E, "LIMSW1 Value D" },\
                           { 0x0144, "LIMSW2 Value D" },\
                           { 0x014A, "SWITCH1 Value D" },\
                           { 0x014C, "SWITCH2 Value D" }
                           
                           
#define FUNC6_CHANNEL_LIST { 0x013E, "LIMSW1 Value D" },\
                           { 0x0144, "LIMSW2 Value D" },\
                           { 0x014A, "SWITCH1 Value D" },\
                           { 0x014C, "SWITCH2 Value D" }
                           
                           

/* Function Block Available */
#define FUNC1_AVAILABLE
#define FUNC2_AVAILABLE
#define FUNC3_AVAILABLE
#define FUNC4_AVAILABLE
#define FUNC5_AVAILABLE
#define FUNC6_AVAILABLE

/* Simulation Available */
#define FUNC1_SIMULATION_AVAILABLE
#define FUNC2_SIMULATION_AVAILABLE
#define FUNC3_SIMULATION_AVAILABLE
#define FUNC4_SIMULATION_AVAILABLE
#define FUNC5_SIMULATION_AVAILABLE
#define FUNC6_SIMULATION_AVAILABLE

/* #include */
#include "SIPAST_Macros_300.inc"