/***************************************************************************************************
*  Copyright (C) Yokogawa Electric Corporation 2003,2004  All Rights Reserved.                     *
*
*  $Workfile:   YEC_AXF0101_PA.inc  $
*    $Author:   $
*  $Revision:   $
*      $Date:   $
*                                                                                                  *
****************************************************************************************************
*  PROJECT_NAME        AXF Profibus PA
*
*  FIRST_AUTHOR        Daisuke Harigane
*
*  FILE_DESCRIPTION    Define for PDM of AXF(Profibus PA)
*
*  FUNCTIONAL_MODULE_DESCRIPTION
*    This file is made based on the following SIEMENS standard DDL files.
*    SIPASTTFEM_300.ddl   (Revision: Date:   )
*
*    (Other include file, etc...)
*         PA_Sensor_Flow_Electromagnetic_Profil3.Devices
*
*  RELATED_DOCUMENTS
*    Document No.        Name               Title
*---------------------------------------------------------------------------------------------------
*    STR-PBAXFPA-B***              
*=================================================================================================*/
#ifdef _V600_
	#define YT11_LABEL		[func_out_value]
	#define YT11_VALUE		func1_AI_out_value
	#define	YT11_LRV		func1_AI_out_lower_range_value
	#define YT11_URV		func1_AI_out_upper_range_value
	
	#define YT12_LABEL		[volume_flow]
	#define YT12_VALUE		trans1_volume_flow_value
	#define	YT12_LRV		trans1_volume_flow_lower_limit
	#define YT12_URV		trans1_volume_flow_upper_limit
	
	#define YT21_LABEL		[func_tot_out_total_value]
	#define YT21_VALUE		func2_TOT_total_value
	#define	YT21_LRV		func2_TOT_hi_hi_lim
	#define YT21_URV		func2_TOT_lo_lo_lim
	
	#define YT31_LABEL		[func_tot_out_total_value]
	#define YT31_VALUE		func3_TOT_total_value
	#define	YT31_LRV		func3_TOT_hi_hi_lim
	#define YT31_URV		func3_TOT_lo_lo_lim
	
	#define YT41_LABEL		[func_tot_out_total_value]
	#define YT41_VALUE		func4_TOT_total_value
	#define	YT41_LRV		func4_TOT_hi_hi_lim
	#define YT41_URV		func4_TOT_lo_lo_lim
#else
	#define YT1_LABEL		[func_out_value]
	#define YT1_VALUE		func1_AI_out_value
	#define YT1_LRV			func1_AI_out_lower_range_value
	#define YT1_URV			func1_AI_out_upper_range_value
	
	#define YT2_LABEL		[volume_flow]
	#define YT2_VALUE		trans1_volume_flow_value
	#define YT2_LRV			trans1_volume_flow_lower_limit
	#define YT2_URV			trans1_volume_flow_upper_limit
	
	#define YT12_LABEL		FUNC2_TITLE
	#define YT12_VALUE		func2_TOT_total_value
	#define YT12_LRV		func2_TOT_hi_hi_lim
	#define YT12_URV		func2_TOT_lo_lo_lim
	
	#define YT13_LABEL		FUNC3_TITLE
	#define YT13_VALUE		func3_TOT_total_value
	#define	YT13_LRV		func3_TOT_hi_hi_lim
	#define YT13_URV		func3_TOT_lo_lo_lim
	
	#define YT14_LABEL		FUNC4_TITLE
	#define YT14_VALUE		func4_TOT_total_value
	#define	YT14_LRV		func4_TOT_hi_hi_lim
	#define YT14_URV		func4_TOT_lo_lo_lim
#endif

#include "SIPAST.inc"
//#include "SIPAST_CommError.inc"
#include "SIPAST_CommonDlgs.inc"

#include "SI_FileM.inc"
#include "SI_DevM.inc"
#include "SI_ViewM.inc"
#include "SI_OptM.inc"
#include "SI_HlpM.inc"

#include "YEC_AXF0101PA.h"

/*
#include "SIPASTPB_300.inc"
#include "Trans1_Flow_Vol_Electromagnetic_300.inc"
#include "SIPASTAI_300.inc"
#include "totalizer2_300.inc"
#include "totalizer3_300.inc"
#include "totalizer4_300.inc"
#include "DiscreteIn5_300.inc"
#include "DiscreteIn6_300.inc"
*/

#ifdef _V600_
	#include "SI_YT.inc"
	#include "SI_YT_1.inc"
	#include "SI_YT_2.inc"
	#include "SI_YT_3.inc"
	#include "SI_YT_4.inc"
#else
	#include "SI_YT.inc"
	#include "SI_YT_2.inc"
#endif


// Upload to PC, Dowuload to device Parameter (AXF PA Original) ----------------------
#define TRANS1_AXF_LOAD_TO_PC				\
		/* TRANS1_FLOW_LOAD_TO_PC */		\
		trans1_blk_profile_rev,				\
		trans1_st_rev,						\
		trans1_tag_desc,					\
		trans1_strategy,					\
		trans1_alert_key,					\
		trans1_target_mode,					\
		trans1_permitted_mode,				\
		trans1_normal_mode,					\
		trans1_calibration_factor,			\
		trans1_low_flow_cutoff,				\
		trans1_nominal_size,				\
		trans1_nominal_size_units,			\
		/* TRANS1_FLOW_VOL_LOAD_TO_PC */	\
		trans1_volume_flow_units,			\
		trans1_volume_flow_lower_limit,		\
		trans1_volume_flow_upper_limit,		\
		/* TRANS1_LOAD_TO_PC */				\
		trans1_flow_direction,				\
		trans1_measurement_mode,			\
		trans1_sample_rate,					\
		trans1_sample_rate_units,			\
		trans1_zero_point,					\
		trans1_zero_point_adjust,			\
		trans1_zero_point_units,			\
		/**** Add from TRANS1_LOAD_TO_PC ****/\
		trans1_volume_flow_ftime,			\
		trans1_dual_frequency_mode,			\
		trans1_low_mf,						\
		trans1_high_mf,						\
		trans1_low_mf_edf,					\
		trans1_high_mf_edf,					\
		trans1_select_flow_tube,			\
		trans1_density_unit,				\
		trans1_mass_flow_density,			\
		trans1_limsw_1_value_d_value,		\
		trans1_limsw_1_value_d_status_quality	<0xFC>,\
		trans1_limsw_1_value_d_status_limit		<0x03>,\
		trans1_limsw_1_target,				\
		trans1_limsw_1_setpoint,			\
		trans1_limsw_1_direction,			\
		trans1_limsw_1_hysteresis,			\
		trans1_limsw_1_unit,				\
		trans1_limsw_2_value_d_value,		\
		trans1_limsw_2_value_d_status_quality	<0xFC>,\
		trans1_limsw_2_value_d_status_limit		<0x03>,\
		trans1_limsw_2_target,				\
		trans1_limsw_2_setpoint,			\
		trans1_limsw_2_direction,			\
		trans1_limsw_2_hysteresis,			\
		trans1_limsw_2_unit,				\
		trans1_switch_1_value_d_value,		\
		trans1_switch_1_value_d_status_quality	<0xFC>,\
		trans1_switch_1_value_d_status_limit	<0x03>,\
		trans1_switch_1_target,				\
		trans1_switch_2_value_d_value,		\
		trans1_switch_2_value_d_status_quality	<0xFC>,\
		trans1_switch_2_value_d_status_limit	<0x03>,\
		trans1_switch_2_target,				\
		trans1_alarm_perform_1,				\
		trans1_alarm_perform_2,				\
		trans1_operation_time,				\
		trans1_alm_record_1,				\
		trans1_alm_record_time_1,			\
		trans1_alm_record_2,				\
		trans1_alm_record_time_2,			\
		trans1_alm_record_3,				\
		trans1_alm_record_time_3,			\
		trans1_alm_record_4,				\
		trans1_alm_record_time_4,			\
		trans1_diplay_select1,				\
		trans1_diplay_select2,				\
		trans1_diplay_select3,				\
		trans1_diplay_cycle,				\
		trans1_language,					\
		trans1_rate_limit,					\
		trans1_dead_time,					\
		trans1_pulsing_flow,				\
		trans1_power_synch,					\
		trans1_power_frequency,				\
		trans1_software_rev_no,				\
		trans1_adhesion_check,				\
		trans1_adhesion_level_1,			\
		trans1_adhesion_level_2,			\
		trans1_adhesion_level_3,			\
		trans1_adhesion_level_4,			\
		trans1_adh_measure_value,			\
		trans1_target_mode,					\
		trans1_actual_mode


#define TRANS1_AXF_LOAD_TO_DEVICE			\
		trans1_measurement_mode,			\
		trans1_flow_direction,				\
		trans1_zero_point_units,			\
		trans1_nominal_size_units,			\
		trans1_volume_flow_units,			\
		trans1_density_unit,				\
		trans1_sample_rate_units,			\
		trans1_low_flow_cutoff,				\
		trans1_nominal_size,				\
		trans1_volume_flow_ftime,			\
		trans1_mass_flow_density,			\
		trans1_limsw_1_target,				\
		trans1_limsw_1_setpoint,			\
		trans1_limsw_1_direction,			\
		trans1_limsw_1_hysteresis,			\
		trans1_limsw_2_target,				\
		trans1_limsw_2_setpoint,			\
		trans1_limsw_2_direction,			\
		trans1_limsw_2_hysteresis,			\
		trans1_alarm_perform_1,				\
		trans1_alarm_perform_2,				\
		trans1_diplay_select1,				\
		trans1_diplay_select2,				\
		trans1_diplay_select3,				\
		trans1_diplay_cycle,				\
		trans1_language,					\
		trans1_rate_limit,					\
		trans1_dead_time,					\
		trans1_pulsing_flow,				\
		trans1_power_synch,					\
		trans1_power_frequency,				\
		trans1_adhesion_check,				\
		trans1_adhesion_level_1,			\
		trans1_adhesion_level_2,			\
		trans1_adhesion_level_3,			\
		trans1_adhesion_level_4


#define PHYS_AXF_LOAD_TO_PC					\
		phys_st_rev,						\
		phys_tag_desc,						\
		phys_device_man_id,					\
		phys_device_id						\
		phys_device_ser_num,				\
		phys_software_rev,					\
		phys_hardware_rev,					\
		phys_blk_profile_rev,				\
		phys_install_date,					\
		phys_device_certification,			\
		phys_descriptor,					\
		phys_message,						\
		phys_ident_number,					\
		/***** Add from PHYS_LOAD_TO_PC *****/\
		phys_soft_desc,						\
		phys_target_mode,					\
		phys_actual_mode


#define PHYS_AXF_LOAD_TO_DEVICE				\
		phys_tag_desc,						\
		phys_descriptor,					\
		phys_message,						\
		phys_install_date

#define FUNC1_AXF_LOAD_TO_PC				\
		func1_AI_st_rev,					\
		func1_AI_channel,					\
		func1_AI_strategy,					\
		func1_AI_alert_key,					\
		func1_AI_tag_desc,					\
		func1_AI_pv_upper_range_value,		\
		func1_AI_pv_lower_range_value,		\
		func1_AI_out_unit,					\
		func1_AI_out_upper_range_value,		\
		func1_AI_out_lower_range_value,		\
		func1_AI_pv_ftime,					\
		func1_AI_alarm_hys,					\
		func1_AI_hi_lim,					\
		func1_AI_lo_lim,					\
		func1_AI_hi_hi_lim,					\
		func1_AI_lo_lo_lim,					\
		func1_AI_out_decimal_point,			\
		func1_AI_batch_id,					\
		func1_AI_batch_unit,				\
		func1_AI_batch_operation,			\
		func1_AI_batch_phase,				\
		func1_AI_FSafeType,					\
		func1_AI_FSafeValue,				\
		func1_AI_out_unit_text,				\
		/***** Add from FUNC1_LOAD_TO_PC ****/\
		func1_AI_lin_type,					\
		func1_AI_velocity_check,			\
		func1_AI_target_mode,				\
		func1_AI_actual_mode


#define FUNC1_AXF_LOAD_TO_DEVICE			\
		func1_AI_pv_upper_range_value,		\
		func1_AI_pv_lower_range_value,		\
		func1_AI_lin_type,					\
		func1_AI_out_upper_range_value,		\
		func1_AI_out_lower_range_value,		\
		func1_AI_out_unit,					\
		func1_AI_out_decimal_point,			\
		func1_AI_hi_hi_lim,					\
		func1_AI_hi_lim,					\
		func1_AI_lo_lim,					\
		func1_AI_lo_lo_lim,					\
		func1_AI_batch_id,					\
		func1_AI_batch_unit,				\
		func1_AI_batch_operation,			\
		func1_AI_batch_phase,				\
		func1_AI_channel,					\
		func1_AI_pv_ftime,					\
		func1_AI_FSafeType,					\
		func1_AI_FSafeValue,				\
		func1_AI_alarm_hys,					\
		func1_AI_out_unit_text



#define FUNC2_AXF_LOAD_TO_PC				\
		func2_TOT_blk_profile,				\
		func2_TOT_blk_profile_rev,			\
		func2_TOT_st_rev,					\
		func2_TOT_channel,					\
		func2_TOT_unit_tot,					\
		func2_TOT_mode_tot,					\
		func2_TOT_fail_tot,					\
		func2_TOT_preset_tot,				\
		func2_TOT_alarm_hys,				\
		func2_TOT_hi_lim,					\
		func2_TOT_hi_hi_lim,				\
		func2_TOT_lo_lim,					\
		func2_TOT_lo_lo_lim,				\
		func2_TOT_batch_id,					\
		func2_TOT_batch_unit,				\
		func2_TOT_batch_operation,			\
		func2_TOT_batch_phase,				\
		func2_TOT_tag_desc,					\
		func2_TOT_strategy,					\
		func2_TOT_alert_key,				\
		/***** Add from FUNC2_LOAD_TO_PC ****/\
		func2_TOT_target_mode,				\
		func2_TOT_actual_mode


#define FUNC2_AXF_LOAD_TO_DEVICE			\
		func2_TOT_unit_tot,					\
		func2_TOT_channel,					\
		func2_TOT_mode_tot,					\
		func2_TOT_fail_tot,					\
		func2_TOT_alarm_hys,				\
		func2_TOT_hi_hi_lim,				\
		func2_TOT_hi_lim,					\
		func2_TOT_preset_tot,				\
		func2_TOT_lo_lim,					\
		func2_TOT_lo_lo_lim,				\
		func2_TOT_batch_id,					\
		func2_TOT_batch_unit,				\
		func2_TOT_batch_operation,			\
		func2_TOT_batch_phase


#define FUNC3_AXF_LOAD_TO_PC				\
		func3_TOT_blk_profile,				\
		func3_TOT_blk_profile_rev,			\
		func3_TOT_st_rev,					\
		func3_TOT_channel,					\
		func3_TOT_unit_tot,					\
		func3_TOT_mode_tot,					\
		func3_TOT_fail_tot,					\
		func3_TOT_preset_tot,				\
		func3_TOT_alarm_hys,				\
		func3_TOT_hi_lim,					\
		func3_TOT_hi_hi_lim,				\
		func3_TOT_lo_lim,					\
		func3_TOT_lo_lo_lim,				\
		func3_TOT_batch_id,					\
		func3_TOT_batch_unit,				\
		func3_TOT_batch_operation,			\
		func3_TOT_batch_phase,				\
		func3_TOT_tag_desc,					\
		func3_TOT_strategy,					\
		func3_TOT_alert_key,				\
		/***** Add from FUNC3_LOAD_TO_PC ****/\
		func3_TOT_target_mode,				\
		func3_TOT_actual_mode


#define FUNC3_AXF_LOAD_TO_DEVICE			\
		func3_TOT_unit_tot,					\
		func3_TOT_channel,					\
		func3_TOT_mode_tot,					\
		func3_TOT_fail_tot,					\
		func3_TOT_alarm_hys,				\
		func3_TOT_hi_hi_lim,				\
		func3_TOT_hi_lim,					\
		func3_TOT_preset_tot,				\
		func3_TOT_lo_lim,					\
		func3_TOT_lo_lo_lim,				\
		func3_TOT_batch_id,					\
		func3_TOT_batch_unit,				\
		func3_TOT_batch_operation,			\
		func3_TOT_batch_phase


#define FUNC4_AXF_LOAD_TO_PC				\
		func4_TOT_blk_profile,				\
		func4_TOT_blk_profile_rev,			\
		func4_TOT_st_rev,					\
		func4_TOT_channel,					\
		func4_TOT_unit_tot,					\
		func4_TOT_mode_tot,					\
		func4_TOT_fail_tot,					\
		func4_TOT_preset_tot,				\
		func4_TOT_alarm_hys,				\
		func4_TOT_hi_lim,					\
		func4_TOT_hi_hi_lim,				\
		func4_TOT_lo_lim,					\
		func4_TOT_lo_lo_lim,				\
		func4_TOT_batch_id,					\
		func4_TOT_batch_unit,				\
		func4_TOT_batch_operation,			\
		func4_TOT_batch_phase,				\
		func4_TOT_tag_desc,					\
		func4_TOT_strategy,					\
		func4_TOT_alert_key,				\
		/***** Add from FUNC4_LOAD_TO_PC ****/\
		func4_TOT_target_mode,				\
		func4_TOT_actual_mode


#define FUNC4_AXF_LOAD_TO_DEVICE			\
		func4_TOT_unit_tot,					\
		func4_TOT_channel,					\
		func4_TOT_mode_tot,					\
		func4_TOT_fail_tot,					\
		func4_TOT_alarm_hys,				\
		func4_TOT_hi_hi_lim,				\
		func4_TOT_hi_lim,					\
		func4_TOT_preset_tot,				\
		func4_TOT_lo_lim,					\
		func4_TOT_lo_lo_lim,				\
		func4_TOT_batch_id,					\
		func4_TOT_batch_unit,				\
		func4_TOT_batch_operation,			\
		func4_TOT_batch_phase


#define FUNC5_AXF_LOAD_TO_PC				\
		func5_DI_st_rev,					\
		func5_DI_channel,					\
		func5_DI_invert,					\
		func5_DI_batch_id,					\
		func5_DI_batch_unit,				\
		func5_DI_batch_operation,			\
		func5_DI_batch_phase,				\
		func5_DI_fsafe_type,				\
		func5_DI_fsafe_value,				\
		/***** Add from FUNC5_LOAD_TO_PC ****/\
		func5_DI_target_mode,				\
		func5_DI_actual_mode


#define FUNC5_AXF_LOAD_TO_DEVICE			\
		func5_DI_batch_id,					\
		func5_DI_batch_unit,				\
		func5_DI_batch_operation,			\
		func5_DI_batch_phase,				\
		func5_DI_channel,					\
		func5_DI_invert,					\
		func5_DI_fsafe_type,				\
		func5_DI_fsafe_value


#define FUNC6_AXF_LOAD_TO_PC				\
		func6_DI_st_rev,					\
		func6_DI_channel,					\
		func6_DI_invert,					\
		func6_DI_batch_id,					\
		func6_DI_batch_unit,				\
		func6_DI_batch_operation,			\
		func6_DI_batch_phase,				\
		func6_DI_fsafe_type,				\
		func6_DI_fsafe_value,				\
		/***** Add from FUNC6_LOAD_TO_PC ****/\
		func6_DI_target_mode,				\
		func6_DI_actual_mode				\


#define FUNC6_AXF_LOAD_TO_DEVICE			\
		func6_DI_batch_id,					\
		func6_DI_batch_unit,				\
		func6_DI_batch_operation,			\
		func6_DI_batch_phase,				\
		func6_DI_channel,					\
		func6_DI_invert,					\
		func6_DI_fsafe_type,				\
		func6_DI_fsafe_value



/*******************************************************************************/
/*********  Device -> PC  ******************************************************/
/*******************************************************************************/

MENU download_variables
{
	LABEL		[menu_load_to_PC];
	ITEMS
	{
		PHYS_AXF_LOAD_TO_PC,
		TRANS1_AXF_LOAD_TO_PC,
		FUNC1_AXF_LOAD_TO_PC,
		FUNC2_AXF_LOAD_TO_PC,
		FUNC3_AXF_LOAD_TO_PC,
		FUNC4_AXF_LOAD_TO_PC,
		FUNC5_AXF_LOAD_TO_PC,
		FUNC6_AXF_LOAD_TO_PC
	}
}

/*******************************************************************************/
/*********  PC -> Device  ******************************************************/
/*******************************************************************************/
MENU upload_variables
{
	LABEL		[menu_load_to_device];
	PRE_WRITE_ACTIONS
	{
		method_pre_write_target_mode_to_os,
	}
	ITEMS
	{
		PHYS_AXF_LOAD_TO_DEVICE,	//Mod AXF_DP(PB)
		TRANS1_AXF_LOAD_TO_DEVICE,	//Mod AXF_DP(TB)
		FUNC1_AXF_LOAD_TO_DEVICE,	//Mod AXF_DP(AI)
		FUNC2_AXF_LOAD_TO_DEVICE,	//Mod AXF_DP(TOT1)
		FUNC3_AXF_LOAD_TO_DEVICE,	//Mod AXF_DP(TOT2)
		FUNC4_AXF_LOAD_TO_DEVICE,	//Mod AXF_DP(TOT3)
		FUNC5_AXF_LOAD_TO_DEVICE,	//Mod AXF_DP(DI1)
		FUNC6_AXF_LOAD_TO_DEVICE	//Mod AXF_DP(DI2)
	}
	POST_WRITE_ACTIONS
	{
		method_pre_write_target_mode_return,
	}
}

/* This METHOD is called before "upload_variables" */
METHOD method_pre_write_target_mode_to_os
{
	LABEL	"Write O/S";
	DEFINITION
	{
		int ret;
		int temp_phys_mode;
		int temp_trans1_mode;
		int temp_func1_mode;
		int temp_func2_mode;
		int temp_func3_mode;
		int temp_func4_mode;
		int temp_func5_mode;
		int temp_func6_mode;

		ret = ReadCommand (read_phys_target_mode);
		temp_phys_mode = phys_target_mode;
		phys_target_mode = 0x80;
		
		ret = ReadCommand (read_trans1_target_mode);
		temp_trans1_mode = trans1_target_mode;
		trans1_target_mode = 0x80;
		
		ret = ReadCommand (read_func1_AI_target_mode);
		temp_func1_mode = func1_AI_target_mode;
		func1_AI_target_mode = 0x80;
		
		ret = ReadCommand (read_func2_TOT_target_mode);
		temp_func2_mode = func2_TOT_target_mode;
		func2_TOT_target_mode = 0x80;
		
		ret = ReadCommand (read_func3_TOT_target_mode);
		temp_func3_mode = func3_TOT_target_mode;
		func3_TOT_target_mode = 0x80;
		
		ret = ReadCommand (read_func4_TOT_target_mode);
		temp_func4_mode = func4_TOT_target_mode;
		func4_TOT_target_mode = 0x80;
		
		ret = ReadCommand (read_func5_DI_target_mode);
		temp_func5_mode = func5_DI_target_mode;
		func5_DI_target_mode = 0x80;
		
		ret = ReadCommand (read_func6_DI_target_mode);
		temp_func6_mode = func6_DI_target_mode;
		func6_DI_target_mode = 0x80;
		
		ret = WriteCommand (write_phys_target_mode);
		ret = WriteCommand (write_trans1_target_mode);
		ret = WriteCommand (write_func1_AI_target_mode);
		ret = WriteCommand (write_func2_TOT_target_mode);
		ret = WriteCommand (write_func3_TOT_target_mode);
		ret = WriteCommand (write_func4_TOT_target_mode);
		ret = WriteCommand (write_func5_DI_target_mode);
		ret = WriteCommand (write_func6_DI_target_mode);
	
		phys_target_mode      = temp_phys_mode;
		trans1_target_mode    = temp_trans1_mode;
		func1_AI_target_mode  = temp_func1_mode;
		func2_TOT_target_mode = temp_func2_mode;
		func3_TOT_target_mode = temp_func3_mode;
		func4_TOT_target_mode = temp_func4_mode;
		func5_DI_target_mode  = temp_func5_mode;
		func6_DI_target_mode  = temp_func6_mode;
		
	}
}

/* This METHOD is called after "upload_variables" */
METHOD method_pre_write_target_mode_return
{
	LABEL	"Write Auto";
	DEFINITION
	{
		int ret;
		
		phys_target_mode      = 0x08;
		trans1_target_mode    = 0x08;
		func1_AI_target_mode  = 0x08;
		func2_TOT_target_mode = 0x08;
		func3_TOT_target_mode = 0x08;
		func4_TOT_target_mode = 0x08;
		func5_DI_target_mode  = 0x08;
		func6_DI_target_mode  = 0x08;

		ret = WriteCommand (write_phys_target_mode);
		ret = WriteCommand (write_trans1_target_mode);
		ret = WriteCommand (write_func1_AI_target_mode);
		ret = WriteCommand (write_func2_TOT_target_mode);
		ret = WriteCommand (write_func3_TOT_target_mode);
		ret = WriteCommand (write_func4_TOT_target_mode);
		ret = WriteCommand (write_func5_DI_target_mode);
		ret = WriteCommand (write_func6_DI_target_mode);
	}
	
	
}


/*******************************************************************************/
/*********  Transfer Button  ***************************************************/
/*******************************************************************************/
METHOD method_set
{
	LABEL		[transfer];
	HELP		[transfer_help];
	DEFINITION
	{
	}
}

/*******************************************************************************/
/*********  Main Menu  *********************************************************/
/*******************************************************************************/

MENU Menu_Main_Specialist
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_S_Device,
		Menu_S_View,
		Menu_Options,
		Menu_Help
	}
}



MENU Menu_Main_Maintenance
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_M_Device,
		Menu_M_View,
		Menu_M_Options,
		Menu_Help
	}
}


/*******************************************************************************/
/*********  Parameter table  ***************************************************/
/*******************************************************************************/
MENU Table_Main_Specialist
{
	LABEL	DEVICE_TITLE ;
	ITEMS
	{
		Tab_s_easy_setup,
		Tab_s_ident,
		Tab_s_input,
		Tab_s_output,
		Tab_s_opconds,
		Tab_s_const,
		Tab_s_interface_set,
/*		Tab_s_certificates,*/
		Tab_trans_display_set,
		Tab_s_set_target_mode
	}
}

MENU Table_Main_Maintenance
{
	LABEL	DEVICE_TITLE ;
	ITEMS
	{
		Tab_m_easy_setup,
		Tab_m_ident,
		Tab_m_input,
		Tab_m_output,
		Tab_s_opconds,
		Tab_s_const,
		Tab_s_interface_set,
/*		Tab_s_certificates,*/
		Tab_trans_display_set,
		Tab_m_set_target_mode
	}
}

MENU Tab_s_input
{
	LABEL		[menu_input];
	ITEMS
	{
		Tab_s_trans1
	}
}

MENU Tab_m_input
{
	LABEL		[menu_input];
	ITEMS
	{
		Tab_m_trans1
	}
}


MENU Tab_s_output
{
	LABEL		[menu_output];
	ITEMS
	{
		Tab_s_func1,
		Tab_s_func5,
		Tab_s_func6,
		Tab_s_func2,
		Tab_s_func3,
		Tab_s_func4
	}
}

MENU Tab_m_output
{
	LABEL		[menu_output];
	ITEMS
	{
		Tab_m_func1,
		Tab_m_func5,
		Tab_m_func6,
		Tab_m_func2,
		Tab_m_func3,
		Tab_m_func4
	}
}

/* Easy Setup [Specialist] */
MENU Tab_s_easy_setup
{
	LABEL		[easy_setup];
	ITEMS
	{
		phys_tag_desc,
		phys_descriptor,

		Tab_s_easy_setup_volume_flow,
		Tab_s_func1_pv_range,
		Tab_s_easy_setup_outscale,
		Tab_easy_setup_local_display,

		Tab_s_trans1_target_mode,
		Tab_s_easy_setup_ai
	}
}

/* Easy Setup [Maintenance] */
MENU Tab_m_easy_setup
{
	LABEL		[easy_setup];
	ITEMS
	{
		phys_tag_desc			(READ_ONLY),
		phys_descriptor,

		Tab_m_easy_setup_volume_flow,
		Tab_m_func1_pv_range,
		Tab_m_easy_setup_outscale,
		Tab_easy_setup_local_display,

		Tab_m_trans1_target_mode,
		Tab_m_easy_setup_ai
	}
}

/* Easy Setup -> Volume Flow(Measured Value) [Specialist] */
MENU Tab_s_easy_setup_volume_flow
{
	LABEL		[volume_flow];
	ITEMS
	{
		trans1_volume_flow_units,
		trans1_volume_flow_ftime, 
	}
}


/* Easy Setup -> Volume Flow(Measured Value) [Maintenance] */
MENU Tab_m_easy_setup_volume_flow
{
	LABEL		[volume_flow];
	ITEMS
	{
		trans1_volume_flow_units (READ_ONLY),
		trans1_volume_flow_ftime (READ_ONLY)
	}
}

/* Easy Setup -> Out Scale [Specialist] */
MENU Tab_s_easy_setup_outscale
{
	LABEL		[out_scale];
	ITEMS
	{
		func1_AI_out_lower_range_value,
		func1_AI_out_upper_range_value,
		func1_AI_out_unit,
		func1_AI_out_decimal_point
		
	}
}

/* Easy Setup -> Out Scale [Maintenance] */
MENU Tab_m_easy_setup_outscale
{
	LABEL		[out_scale];
	ITEMS
	{
		func1_AI_out_lower_range_value	(READ_ONLY),
		func1_AI_out_upper_range_value	(READ_ONLY),
		func1_AI_out_unit				(READ_ONLY),
		func1_AI_out_decimal_point		(READ_ONLY)
		
	}
}

/* Easy Setup -> Local Display */
MENU Tab_easy_setup_local_display
{
	LABEL		[local_diaplay];
	ITEMS
	{
		trans1_diplay_select1,
		trans1_diplay_select2,
		trans1_diplay_select3
	}
}


/* Easy Setup -> Analog Input [Specialist] */
MENU Tab_s_easy_setup_ai
{
	LABEL		FUNC1_TITLE;
	ITEMS
	{
		func1_AI_target_mode,
		func1_AI_actual_mode,
		func1_AI_pv_ftime,
		func1_AI_velocity_check
	}
}


/* Easy Setup -> Analog Input [Maintenance] */
MENU Tab_m_easy_setup_ai
{
	LABEL		FUNC1_TITLE;
	ITEMS
	{
		func1_AI_target_mode	(READ_ONLY),
		func1_AI_actual_mode,
		func1_AI_pv_ftime		(READ_ONLY),
		func1_AI_velocity_check
	}
}

/* Input -> TransducerBlock(Flow) -> Flow Tube [Specialist] */
MENU Tab_s_trans_flow_tube
{
	LABEL		[flow_tube];
	ITEMS
	{
		trans1_select_flow_tube,
		trans1_dual_frequency_mode,
		trans1_low_mf,
		trans1_high_mf,
		trans1_low_mf_edf,
		trans1_high_mf_edf
	}
}

/* Input -> TransducerBlock(Flow) -> Flow Tube [Maintenance] */
MENU Tab_m_trans_flow_tube
{
	LABEL		[flow_tube];
	ITEMS
	{
		trans1_select_flow_tube		(READ_ONLY),
		trans1_dual_frequency_mode	(READ_ONLY),
		trans1_low_mf				(READ_ONLY),
		trans1_high_mf				(READ_ONLY),
		trans1_low_mf_edf			(READ_ONLY),
		trans1_high_mf_edf			(READ_ONLY)
	}
}

/* Input -> TransducerBlock(Flow) -> DI Set [Specialist] */
MENU Tab_s_trans_di_set
{
	LABEL		[di_set];
	ITEMS
	{
		Tab_s_trans_limit_switch_1,
		Tab_s_trans_limit_switch_2,
		Tab_s_trans_switch_1,
		Tab_s_trans_switch_2
		
	}
}


/* Input -> TransducerBlock(Flow) -> DI Set -> Limit Switch 1 [Specialist] */
MENU Tab_s_trans_limit_switch_1
{
	LABEL		[limit_switch_1];
	ITEMS
	{
		trans1_limsw_1_value_d_value,
		trans1_limsw_1_value_d_status_quality	<0xFC>,
		trans1_limsw_1_value_d_status_limit		<0x03>,
		trans1_limsw_1_target,
		trans1_limsw_1_setpoint,
		trans1_limsw_1_direction,
		trans1_limsw_1_hysteresis,
		trans1_limsw_1_unit
	}
}

/* Input -> TransducerBlock(Flow) -> DI Set -> Limit Switch 2 [Specialist] */
MENU Tab_s_trans_limit_switch_2
{
	LABEL		[limit_switch_2];
	ITEMS
	{
		trans1_limsw_2_value_d_value,
		trans1_limsw_2_value_d_status_quality	<0xFC>,
		trans1_limsw_2_value_d_status_limit		<0x03>,
		trans1_limsw_2_target,
		trans1_limsw_2_setpoint,
		trans1_limsw_2_direction,
		trans1_limsw_2_hysteresis,
		trans1_limsw_2_unit
	}
}

/* Input -> TransducerBlock(Flow) -> DI Set -> Switch 1 [Specialist] */
MENU Tab_s_trans_switch_1
{
	LABEL		[switch_1];
	ITEMS
	{
		trans1_switch_1_value_d_value,
		trans1_switch_1_value_d_status_quality	<0xFC>,
		trans1_switch_1_value_d_status_limit	<0x03>,
		trans1_switch_1_target
	}
}

/* Input -> TransducerBlock(Flow) -> DI Set -> Switch 2 [Specialist] */
MENU Tab_s_trans_switch_2
{
	LABEL		[switch_2];
	ITEMS
	{
		trans1_switch_2_value_d_value,
		trans1_switch_2_value_d_status_quality	<0xFC>,
		trans1_switch_2_value_d_status_limit	<0x03>,
		trans1_switch_2_target
	}
}


/* Input -> TransducerBlock(Flow) -> DI Set [Maintenance] */
MENU Tab_m_trans_di_set
{
	LABEL		[di_set];
	ITEMS
	{
		Tab_m_trans_limit_switch_1,
		Tab_m_trans_limit_switch_2,
		Tab_m_trans_switch_1,
		Tab_m_trans_switch_2
	}
}


/* Input -> TransducerBlock(Flow) -> DI Set -> Limit Switch 1 [Maintenance] */
MENU Tab_m_trans_limit_switch_1
{
	LABEL		[limit_switch_1];
	ITEMS
	{
		trans1_limsw_1_value_d_value,
		trans1_limsw_1_value_d_status_quality	<0xFC>,
		trans1_limsw_1_value_d_status_limit		<0x03>,
		trans1_limsw_1_target		(READ_ONLY),
		trans1_limsw_1_setpoint		(READ_ONLY),
		trans1_limsw_1_direction	(READ_ONLY),
		trans1_limsw_1_hysteresis	(READ_ONLY),
		trans1_limsw_1_unit			(READ_ONLY)
	}
}

/* Input -> TransducerBlock(Flow) -> DI Set -> Limit Switch 2 [Maintenance] */
MENU Tab_m_trans_limit_switch_2
{
	LABEL		[limit_switch_2];
	ITEMS
	{
		trans1_limsw_2_value_d_value,
		trans1_limsw_2_value_d_status_quality	<0xFC>,
		trans1_limsw_2_value_d_status_limit		<0x03>,
		trans1_limsw_2_target		(READ_ONLY),
		trans1_limsw_2_setpoint		(READ_ONLY),
		trans1_limsw_2_direction	(READ_ONLY),
		trans1_limsw_2_hysteresis	(READ_ONLY),
		trans1_limsw_2_unit			(READ_ONLY)
	}
}


/* Input -> TransducerBlock(Flow) -> DI Set -> Switch 1 [Maintenance] */
MENU Tab_m_trans_switch_1
{
	LABEL		[switch_1];
	ITEMS
	{
		trans1_switch_1_value_d_value,
		trans1_switch_1_value_d_status_quality	<0xFC>,
		trans1_switch_1_value_d_status_limit	<0x03>,
		trans1_switch_1_target (READ_ONLY)
	}
}

/* Input -> TransducerBlock(Flow) -> DI Set -> Switch 2 [Maintenance] */
MENU Tab_m_trans_switch_2
{
	LABEL		[switch_2];
	ITEMS
	{
		trans1_switch_2_value_d_value,
		trans1_switch_2_value_d_status_quality	<0xFC>,
		trans1_switch_2_value_d_status_limit	<0x03>,
		trans1_switch_2_target (READ_ONLY)
	}
}

/* Input -> TransducerBlock(Flow) -> Aux [Specialist] */
MENU Tab_s_trans_aux
{
	LABEL		[aux];
	ITEMS
	{
		trans1_rate_limit,
		trans1_dead_time,
		trans1_pulsing_flow,
		trans1_power_synch,
		trans1_power_frequency,
		trans1_software_rev_no
	}
}


/* Input -> TransducerBlock(Flow) -> Aux [Maintenance] */
MENU Tab_m_trans_aux
{
	LABEL		[aux];
	ITEMS
	{
		trans1_rate_limit		(READ_ONLY),
		trans1_dead_time		(READ_ONLY),
		trans1_pulsing_flow		(READ_ONLY),
		trans1_power_synch		(READ_ONLY),
		trans1_power_frequency	(READ_ONLY),
		trans1_software_rev_no
	}
}


/* Input -> TransducerBlock(Flow) -> Mask Alarm [Specialist] */
MENU Tab_s_trans_mask_alarm
{
	LABEL		[mask_alarm];
	ITEMS
	{
//		trans1_alarm_perform
		
		trans1_alarm_perform_1,
		trans1_alarm_perform_2

	}
	
}

/* Input -> TransducerBlock(Flow) -> Mask Alarm [Maintenance] */
MENU Tab_m_trans_mask_alarm
{
	LABEL		[mask_alarm];
	ITEMS
	{
//		trans1_alarm_perform	(READ_ONLY)
		
		trans1_alarm_perform_1	(READ_ONLY),
		trans1_alarm_perform_2	(READ_ONLY)
	}
	
}

/* Input -> TransducerBlock(Flow) -> Adhesion [Specialist] */
MENU Tab_s_trans_adhesion
{
	LABEL		[adhesion];
	ITEMS
	{
		trans1_adhesion_check,
		trans1_adhesion_level_1,
		trans1_adhesion_level_2,
		trans1_adhesion_level_3,
		trans1_adhesion_level_4,
		trans1_adh_measure_value
	}
}

/* Input -> TransducerBlock(Flow) -> Adhesion [Maintenance] */
MENU Tab_m_trans_adhesion
{
	LABEL		[adhesion];
	ITEMS
	{
		trans1_adhesion_check	(READ_ONLY),
		trans1_adhesion_level_1	(READ_ONLY),
		trans1_adhesion_level_2	(READ_ONLY),
		trans1_adhesion_level_3	(READ_ONLY),
		trans1_adhesion_level_4	(READ_ONLY),
		trans1_adh_measure_value
	}
}

/* Local Display */
MENU Tab_trans_display_set
{
	LABEL		[local_diaplay];
	ITEMS
	{
		trans1_diplay_select1,
		trans1_diplay_select2,
		trans1_diplay_select3,
		trans1_diplay_cycle,
		trans1_language
	}
}

/* Target Mode [specialist] */
MENU Tab_s_set_target_mode
{
	LABEL		[target_mode];
	ITEMS
	{
		Tab_s_phys_target_mode,
		Tab_s_trans1_target_mode,
		Tab_s_func1_target_mode,
		Tab_s_func2_target_mode,
		Tab_s_func3_target_mode,
		Tab_s_func4_target_mode,
		Tab_s_func5_target_mode,
		Tab_s_func6_target_mode
	}
}


/* Target Mode [Maintenance] */
MENU Tab_m_set_target_mode
{
	LABEL		[target_mode];
	ITEMS
	{
		Tab_m_phys_target_mode,
		Tab_m_trans1_target_mode,
		Tab_m_func1_target_mode,
		Tab_m_func2_target_mode,
		Tab_m_func3_target_mode,
		Tab_m_func4_target_mode,
		Tab_m_func5_target_mode,
		Tab_m_func6_target_mode
	}
}

/* Target Mode -> Physical Block [Specialist] */
MENU Tab_s_phys_target_mode
{
	LABEL		[blk_block_object_PHYSICAL];
	ITEMS
	{
		phys_target_mode,
		phys_actual_mode
	}
	
}

/* Target Mode -> Physical Block [Maintenance] */
MENU Tab_m_phys_target_mode
{
	LABEL		[blk_block_object_PHYSICAL];
	ITEMS
	{
		phys_target_mode	(READ_ONLY),
		phys_actual_mode
	}
	
}

/* Target Mode -> Transducer Block [Specialist] */
MENU Tab_s_trans1_target_mode
{
	LABEL		[trans_block];
	ITEMS
	{
		trans1_target_mode,
		trans1_actual_mode
	}
	
}

/* Target Mode -> Transducer Block [Maintenance] */
MENU Tab_m_trans1_target_mode
{
	LABEL		[trans_block];
	ITEMS
	{
		trans1_target_mode	(READ_ONLY),
		trans1_actual_mode
	}
	
}

/* Target Mode -> Analog Input [Specialist] */
MENU Tab_s_func1_target_mode
{
	LABEL		FUNC1_TITLE;
	ITEMS
	{
		func1_AI_target_mode,
		func1_AI_actual_mode
	}
}

/* Target Mode -> Analog Input [Maintenance] */
MENU Tab_m_func1_target_mode
{
	LABEL		FUNC1_TITLE;
	ITEMS
	{
		func1_AI_target_mode	(READ_ONLY),
		func1_AI_actual_mode
	}
}

/* Target Mode -> Totalizer1 [Specialist] */
MENU Tab_s_func2_target_mode
{
	LABEL		FUNC2_TITLE;
	ITEMS
	{
		func2_TOT_target_mode,
		func2_TOT_actual_mode
	}
}

/* Target Mode -> Totalizer1 [Maintenance] */
MENU Tab_m_func2_target_mode
{
	LABEL		FUNC2_TITLE;
	ITEMS
	{
		func2_TOT_target_mode	(READ_ONLY),
		func2_TOT_actual_mode
	}
}

/* Target Mode -> Totalizer2 [Specialist] */
MENU Tab_s_func3_target_mode
{
	LABEL		FUNC3_TITLE;
	ITEMS
	{
		func3_TOT_target_mode,
		func3_TOT_actual_mode
	}
}

/* Target Mode -> Totalizer2 [Maintenance] */
MENU Tab_m_func3_target_mode
{
	LABEL		FUNC3_TITLE;
	ITEMS
	{
		func3_TOT_target_mode	(READ_ONLY),
		func3_TOT_actual_mode
	}
}

/* Target Mode -> Totalizer3 [Specialist] */
MENU Tab_s_func4_target_mode
{
	LABEL		FUNC4_TITLE;
	ITEMS
	{
		func4_TOT_target_mode,
		func4_TOT_actual_mode
	}
}

/* Target Mode -> Totalizer3 [Maintenance] */
MENU Tab_m_func4_target_mode
{
	LABEL		FUNC4_TITLE;
	ITEMS
	{
		func4_TOT_target_mode	(READ_ONLY),
		func4_TOT_actual_mode
	}
}

/* Target Mode -> Discrete Input1 [Specialist] */
MENU Tab_s_func5_target_mode
{
	LABEL		FUNC5_TITLE;
	ITEMS
	{
		func5_DI_target_mode,
		func5_DI_actual_mode
	}
}

/* Target Mode -> Discrete Input1 [Maintenance] */
MENU Tab_m_func5_target_mode
{
	LABEL		FUNC5_TITLE;
	ITEMS
	{
		func5_DI_target_mode	(READ_ONLY),
		func5_DI_actual_mode
	}
}

/* Target Mode -> Discrete Input2 [Specialist] */
MENU Tab_s_func6_target_mode
{
	LABEL		FUNC6_TITLE;
	ITEMS
	{
		func6_DI_target_mode,
		func6_DI_actual_mode
	}
}

/* Target Mode -> Discrete Input2 [Maintenance] */
MENU Tab_m_func6_target_mode
{
	LABEL		FUNC6_TITLE;
	ITEMS
	{
		func6_DI_target_mode	(READ_ONLY),
		func6_DI_actual_mode
	}
}


/*******************************************************************************/
/*********  MENU for Menu Bar "View" *******************************************/
/*******************************************************************************/

/* View -> Display */
MENU OnlineWindow_display
{
	LABEL		[menu_dialog_display];
	ITEMS
	{
		Page_display_func1,
		Page_display_func2,
		Page_display_func3,
		Page_display_func4,
		Page_display_func5,
		Page_display_func6,
		Page_display_trans1
	}
}


/* View -> Device Status -> Diagnosis */
MENU Page_diagnosis_axf_diagnosis
{
	LABEL	[view_diagnosis];
	ITEMS
	{
		phys_diagnosis,
/*
		phys_diagnosis_mask,

		phys_diagnosis_extension,
		phys_diagnosis_extension_mask
*/
		phys_diagnosis_extension_byte_1,
		phys_diagnosis_extension_byte_2,
#ifdef _PDM_
		SEPARATOR,
#endif
		phys_diagnosis_extension_byte_3,
		phys_diagnosis_extension_byte_4,
		phys_diagnosis_extension_byte_5,
		phys_diagnosis_extension_byte_6
	}
}

/* View -> Device Status -> Function Block Status */
MENU Page_diagnosis_axf_fb_status
{
	LABEL	[view_fb_status];
	ITEMS
	{
		phys_function_block_status_byte_1,
		phys_function_block_status_byte_2,
//		phys_function_block_status_byte_3,	(Not Use)
#ifdef _PDM_
		SEPARATOR,
#endif
		phys_function_block_status_byte_4,
		phys_function_block_status_byte_5,
//		phys_function_block_status_byte_6	(Not Use)
	}
	
}


/* View -> Alarm Record */
MENU OnlineWindow_alarm_record
{
	LABEL		[view_alarm_record];
	ITEMS
	{
		trans1_operation_time,
		trans1_alm_record_1,
		trans1_alm_record_time_1,
		trans1_alm_record_2,
		trans1_alm_record_time_2,
		trans1_alm_record_3,
		trans1_alm_record_time_3,
		trans1_alm_record_4,
		trans1_alm_record_time_4
	}
}


/* Mod AXF_DP View -> Enhancement EDD Test(Sample) 
MENU OnlineWindow_enhancement_test
{
	LABEL		"Enhancement EDD Test";
	ITEMS
	{
		chartGauge;
	}
}

/* Mod AXF_DP View -> Enhancement EDD Test(Sample) 
CHART chartGauge
{
	LABEL "Gauge";
	TYPE GAUGE;
	WIDTH SMALL;
	HEIGHT SMALL;
	MEMBERS
	{
		SOURCE1, sourceGauge1;
	}
}

/* Mod AXF_DP View -> Enhancement EDD Test(Sample) 
AXIS yaxisGauge1
{
	LABEL "yaxis Gauge 1";
	MIN_VALUE	func1_AI_out_lower_range_value;
	MAX_VALUE	func1_AI_out_upper_range_value;
}
*/


/*******************************************************************************/
/*********  MENU for Menu Bar "Device" *****************************************/
/*******************************************************************************/

/* Device -> Simulation -> Physical Block */
MENU OnlineDialog_simulation_phys
{
	LABEL		[pb_label];
	ITEMS
	{
		Page_simulation_diagnosis_extension_phys,
		Page_diagnosis_extension_phys
	}
}

/* Device -> Simulation -> Physical Block -> Simulation(Diagnosis Simulation Extension) */
MENU Page_simulation_diagnosis_extension_phys
{
	LABEL		[sim_diagnosis_sim_extension];
	ITEMS
	{
		phys_diagnosis_simulation_mode,
		phys_diagnosis_sim_extension_byte_1,
		phys_diagnosis_sim_extension_byte_2,
#ifdef _PDM_
		SEPARATOR,
#endif
		phys_diagnosis_sim_extension_byte_3,
		phys_diagnosis_sim_extension_byte_4,
		phys_diagnosis_sim_extension_byte_5,
		phys_diagnosis_sim_extension_byte_6
#ifdef _PDM_
		method_set
#endif
	}
}


/* Device -> Simulation -> Physical Block -> Simulation(Diagnosis Extension) */
MENU Page_diagnosis_extension_phys
{
	LABEL		[sim_diagnosis_extension];
	ITEMS
	{
		phys_diagnosis_extension_byte_1,
		phys_diagnosis_extension_byte_2,
#ifdef _PDM_
		SEPARATOR,
#endif
		phys_diagnosis_extension_byte_3,
		phys_diagnosis_extension_byte_4,
		phys_diagnosis_extension_byte_5,
		phys_diagnosis_extension_byte_6
	}
}




/* Device -> Simulation -> Transducer Block */
MENU OnlineDialog_simulation_trans1
{
	LABEL		[trans_block];
	ITEMS
	{
		Page_simulation_volume_flow_trans1,
		Page_simulation_output_trans1
	}
}

/* Device -> Simulation -> Transducer Block -> Simulation(Sensor Value) */
MENU Page_simulation_volume_flow_trans1
{
	LABEL		[sim_sensor_value];
	ITEMS
	{
		trans1_simulate_mode,
		trans1_simulate_type,
		trans1_simulate_up_value,
		trans1_simulate_lo_value,
		trans1_simulate_time,
		Group_simulate_trans1
	}
	
}

/* Device -> Simulation -> Transducer Block -> Simulation(Sensor Value) -> Simulate Value */
MENU Group_simulate_trans1
{
	LABEL		[simulate_value];
	ITEMS
	{
		trans1_simulate_volume_flow_value,
#ifdef _PDM_
		SEPARATOR,
#endif
		trans1_simulate_volume_flow_status_quality,
		trans1_simulate_volume_flow_status_limit
	}
}

/* Device -> Simulation -> Transducer Block -> Simulation(Output) */
MENU Page_simulation_output_trans1
{
	LABEL		[sim_output];
	ITEMS
	{
		trans1_target_mode,
		trans1_actual_mode,
		Group_volume_flow_value
	}
}

/* Device -> Simulation -> Transducer Block -> Simulation(Output) -> Volume Flow-Measured Value */
MENU Group_volume_flow_value
{
	LABEL		[volume_flow];
	ITEMS
	{
		trans1_volume_flow_value,
#ifdef _PDM_
		SEPARATOR,
#endif
		trans1_volume_flow_status_quality,
		trans1_volume_flow_status_limit
		
	}
}


/* Device -> Simulation -> Totilizer1 -> Simulation (Measured Value) */
MENU Page_simulation_input_func2
{
	LABEL		[menu_dialog_simulation_input];
	ITEMS
	{
		func2_TOT_simulation_enabled,
		Group_simulate_input_func2,
#ifdef _PDM_
		method_set,
#endif
	}
}

/* Device -> Simulation -> Totilizer1 -> Simulation (Measured Value) -> Simulation Value */
MENU Group_simulate_input_func2
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func2_TOT_simulate_value,
		SEPARATOR,
		func2_TOT_simulate_status_quality,
		func2_TOT_simulate_status_limit
	}
}

/* Device -> Simulation -> Totilizer2 -> Simulation (Measured Value) */
MENU Page_simulation_input_func3
{
	LABEL		[menu_dialog_simulation_input];
	ITEMS
	{
		func3_TOT_simulation_enabled,
		Group_simulate_input_func3,
#ifdef _PDM_
		method_set,
#endif
	}
}

/* Device -> Simulation -> Totilizer2 -> Simulation (Measured Value) -> Simulation Value */
MENU Group_simulate_input_func3
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func3_TOT_simulate_value,
		SEPARATOR,
		func3_TOT_simulate_status_quality,
		func3_TOT_simulate_status_limit
	}
}


/* Device -> Simulation -> Totilizer3 -> Simulation (Measured Value) */
MENU Page_simulation_input_func4
{
	LABEL		[menu_dialog_simulation_input];
	ITEMS
	{
		func4_TOT_simulation_enabled,
		Group_simulate_input_func4,
#ifdef _PDM_
		method_set,
#endif
	}
}

/* Device -> Simulation -> Totilizer3 -> Simulation (Measured Value) -> Simulation Value */
MENU Group_simulate_input_func4
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func4_TOT_simulate_value,
		SEPARATOR,
		func4_TOT_simulate_status_quality,
		func4_TOT_simulate_status_limit
	}
}

MENU OnlineDialog_total_reset
{
	LABEL		[reset_totalizer];
	ITEMS
	{
		Page_reset_func2,
		Page_reset_func3,
		Page_reset_func4
	}
}


MENU OnlineDialog_zero_point_adjustment
{
	LABEL		[zero_point_adjustment];
	ITEMS
	{
		Page_zero_point_adjustment
	}
	
}

MENU Page_zero_point_adjustment
{
	LABEL		[zero_point_adjustment];
	ITEMS
	{
		Group_display_func1,
		trans1_zero_point(READ_ONLY),
		
		start_zero_point_adjustment
	}

}

METHOD start_zero_point_adjustment
{
	LABEL  [start_zero_adjust];
	ACCESS		ONLINE;
	CLASS		INPUT;
	DEFINITION
	{
		float           flt_buf;
		unsigned long   dummy[1];
		int             ivalue;
		unsigned long   us8_buf;            /*  Unsigned8 data  */
		long            chk_cnt;
		unsigned long   id;                 /*  item id  */
		long            status;             /*  error return from builtins  */
		char            str_buf[256];
		long            maxlen;
		long            var_id[3];
		int             ret;
		char            local_param1;
		float           local_param2;
		char            local_param3;
		int             choice_mode;


		maxlen = 256;
		
		ACKNOWLEDGE("|en|Performs Auto Zero Method :\n"
		            "This method will automatically execute zero tuning.\n\n"
		            "This procedure will take several tens of seconds to complete.\n"
		            "The duration time will be listed periodically.\n");



		var_id[0] = VARID(trans1_zero_point_adjust);
		ReadCommand (read_trans1_zero_point_adjust);
		local_param1 = ivar_value(trans1_zero_point_adjust);

		var_id[1] = VARID(trans1_zero_point);
		ReadCommand (read_trans1_zero_point);
		local_param2 = fvar_value(trans1_zero_point);

		var_id[2] = VARID(trans1_zero_point_units);
		ReadCommand (read_trans1_zero_point_units);
		local_param3 = ivar_value(trans1_zero_point_units);

		ACKNOWLEDGE("|en|Do you want to execute the Auto Zero method ?\n"
		"Zero Point Adjust = %{local_param1} , Zero Point = %{local_param2} mm/s ");

		choice_mode = SELECT_FROM_LIST("Change to ", "Cancel;Execute;");

		if(choice_mode == 0) {
			abort();
			return;
		}

		iassign(trans1_zero_point_adjust, 1);
		WriteCommand (write_trans1_zero_point_adjust);
		
		
		chk_cnt = 0;

		/* Wait 30 seconds... */
		DELAY(30, "|en|Now tuning.\n"
		"Waiting for Auto Zero tuning to complete... \n");


		do {
			ReadCommand (read_trans1_zero_point_adjust);
			local_param1 = ivar_value(trans1_zero_point_adjust);

			if(local_param1 == 1) {
				DELAY(1, "|en|Now tuning.\n"
				"Waiting for Auto Zero tuning to complete... \n");
			} else {
				break;
			}
		} while(++chk_cnt < 30);

		if (chk_cnt >= 30) {
			ACKNOWLEDGE("|en|Auto Zero tuning Time out Error. ");
			abort();
		}

		ACKNOWLEDGE("|en|Auto Zero passed. \n\n"
		"Finished.\n");
	}
}


MENU OnlineDialog_signal_lock
{
	LABEL  [signal_lock];
	ITEMS
	{
		trans1_signal_lock,
		func1_AI_out_value,
		func1_AI_out_status_quality,
		func1_AI_out_status_limit
	}
}


/* Device -> Target Mode */
MENU OnlineDialog_target_mode
{
	LABEL		[target_mode];

	ITEMS
	{
		Page_target_mode_set,
	}
}

MENU Page_target_mode_set
{
	LABEL		[target_mode];
	ITEMS
	{
		Group_phys_target_mode_set,
		Group_trans1_target_mode_set,
		Group_func1_target_mode_set,
		Group_func2_target_mode_set,
#ifdef _PDM_
		method_set,
		SEPARATOR,
#endif
		Group_func3_target_mode_set,
		Group_func4_target_mode_set,
		Group_func5_target_mode_set,
		Group_func6_target_mode_set
	}
}


MENU Group_phys_target_mode_set
{
	LABEL		[blk_block_object_PHYSICAL];
	ITEMS
	{
		phys_target_mode,
		phys_actual_mode
	}
}

MENU Group_trans1_target_mode_set
{
	LABEL		[trans_block];
	ITEMS
	{
		trans1_target_mode,
		trans1_actual_mode
	}
}

MENU Group_func1_target_mode_set
{
	LABEL		FUNC1_TITLE;
	ITEMS
	{
		func1_AI_target_mode,
		func1_AI_actual_mode
	}
}

MENU Group_func2_target_mode_set
{
	LABEL		FUNC2_TITLE;
	ITEMS
	{
		func2_TOT_target_mode,
		func2_TOT_actual_mode
	}
}

MENU Group_func3_target_mode_set
{
	LABEL		FUNC3_TITLE;
	ITEMS
	{
		func3_TOT_target_mode,
		func3_TOT_actual_mode
	}
}

MENU Group_func4_target_mode_set
{
	LABEL		FUNC4_TITLE;
	ITEMS
	{
		func4_TOT_target_mode,
		func4_TOT_actual_mode
	}
}

MENU Group_func5_target_mode_set
{
	LABEL		FUNC5_TITLE;
	ITEMS
	{
		func5_DI_target_mode,
		func5_DI_actual_mode
	}
}

MENU Group_func6_target_mode_set
{
	LABEL		FUNC6_TITLE;
	ITEMS
	{
		func6_DI_target_mode,
		func6_DI_actual_mode
	}
}



/* Device -> Adhesion Level */
MENU OnlineDialog_adhesion_level
{
	LABEL  [adhesion_level];
	ITEMS
	{
		trans1_adhesion_check,
		trans1_adhesion_level_1,
		trans1_adhesion_level_2,
		trans1_adhesion_level_3,
		trans1_adhesion_level_4,
		trans1_adh_measure_value,
		
		start_adhesion_check,
#ifdef _PDM_
		method_set
#endif
	}
	
}

/* Device -> Adhesion Level -> Start Adhesion Check */
METHOD start_adhesion_check
{
	LABEL		[start_adhesion_check];
	ACCESS		ONLINE;
	CLASS		INPUT;
	DEFINITION
	{
		int   ret;
		char  local_param1;
		float current_value;
		float threshold;
		
		ACKNOWLEDGE("Performs Adhesion Level Method:\n" 
                    "This Method will automatically measure the adhesion level/value of Electrodes.\n\n" 
                    "The duration time will be listed periodically.\n");

		/* Read ADHESION_CHECK */
		ReadCommand(read_trans1_adhesion_check);
		local_param1 = ivar_value(trans1_adhesion_check);

		if(local_param1 == 0) {		/* ADHESION_CHECK = No */
			ACKNOWLEDGE("Adhesion Check = No\n"
			            "ADHESION LEVEL Method was canceled.\n\n"
			            "Please check the parameter of ADHESION_CHECK.");
			abort();
			return;
			
		} else {					/* ADHESION_CHECK = Yes */
			DELAY(3, "Adhesion Check = Yes\n"
			         "Executing the ADHESION LEVEL Method...\n");
			
			/* Read ADH_MEAURE_VALUE */
			ReadCommand(read_trans1_adh_measure_value);
			current_value = fvar_value(trans1_adh_measure_value);
			
			/* Compare Level1 */
			ReadCommand(read_trans1_adhesion_level_1);
			threshold = fvar_value(trans1_adhesion_level_1);
			if (current_value < threshold) {
				ACKNOWLEDGE("|en|Measure Value = %[.4f]{current_value} M Ohm\n\n"
                            "ADHESION LEVEL = 0\n\n"
                            "Status : Good\n\n\n"
                            "Finished.\n");
			} else {
				/* Compare Level2 */
				ReadCommand(read_trans1_adhesion_level_2);
				threshold = fvar_value(trans1_adhesion_level_2);
				if (current_value < threshold) {
					ACKNOWLEDGE("|en|Measure Value = %[.4f]{current_value} M Ohm\n\n"
                                "ADHESION LEVEL = 1\n\n"
                                "Status : Good\n\n\n"
                                "Finished.\n");
				} else {
					/* Compare Level3 */
					ReadCommand(read_trans1_adhesion_level_3);
					threshold = fvar_value(trans1_adhesion_level_3);
					if (current_value < threshold) {
						ACKNOWLEDGE("|en|Measure Value = %[.4f]{current_value} M Ohm\n\n"
                                    "ADHESION LEVEL = 2\n\n"
                                    "Status : Good\n\n\n"
                                    "Finished.\n");
					} else {
						/* Compare Level4 */
						ReadCommand(read_trans1_adhesion_level_4);
						threshold = fvar_value(trans1_adhesion_level_4);
						if (current_value < threshold) {
							ACKNOWLEDGE("|en|Measure Value = %[.4f]{current_value} M Ohm\n\n"
                                        "ADHESION LEVEL = 3\n\n"
                                        "Status : Warning\n\n\n"
                                        "Finished.\n");
						} else {
							ACKNOWLEDGE("|en|Measure Value = %[.4f]{current_value} M Ohm\n\n"
                                        "ADHESION LEVEL = 4\n\n"
                                        "Status : Alarm\n\n\n"
                                        "Finished.\n");
							
						}
					}
				}
			}
		}
		return;
	}
}



/* Device -> Query Device [Specialist] */
MENU Menu_s_query_device
{
	LABEL  [query_device];
	ITEMS
	{
		OnlineDialog_s_query_pb,	/* PB */ 
		OnlineDialog_s_query_tb,	/* TB */
		OnlineDialog_s_query_ai,	/* AI */
		OnlineDialog_s_query_tot1,	/* TOT1 */
		OnlineDialog_s_query_tot2,	/* TOT2 */
		OnlineDialog_s_query_tot3,	/* TOT3 */
		OnlineDialog_s_query_di1,	/* DI1 */
		OnlineDialog_s_query_di2,	/* DI2 */
		
		OnlineDialog_s_query_tb_service_parameter	/* TB Service Parameter(For Test) Later, this must be deleted. */
	}
	
}

/* Device -> Query Device -> Physical Block [Specialist] */
MENU OnlineDialog_s_query_pb
{
	LABEL	[blk_block_object_PHYSICAL];
	ITEMS
	{
		Page_s_query_pb_1,
		Page_s_query_pb_2,
		Page_s_query_pb_3,
		Page_s_query_pb_4
	}
}


/* Device -> Query Device -> Physical Block -> Index16-23 [Specialist] */
MENU Page_s_query_pb_1
{
	LABEL	[query_phys_1];
	ITEMS
	{
		phys_blk_reserve,					/* Index16 */
		phys_blk_object,					
		phys_blk_parent_class,				
		phys_blk_class,						
		phys_blk_dd_reference,				
		phys_blk_dd_rev,					
		phys_blk_profile,					
		phys_blk_profile_rev,				
		phys_blk_execution_time,			
		phys_blk_num_parameters,			
		phys_blk_index_view_1,				
		phys_blk_num_view_lists,			
#ifdef _PDM_
		SEPARATOR,
#endif
		phys_st_rev,						/* Index17 */
		phys_tag_desc,						/* Index18 */
		phys_strategy,						/* Index19 */
		phys_alert_key,						/* Index20 */
		phys_target_mode,					/* Index21 */
		phys_actual_mode,					/* Index22 */
		phys_permitted_mode,				
		phys_normal_mode,					
		phys_current_state_alarm_sum,		/* Index23 */
		phys_unacknowledged_state_alarm_sum,
		phys_unreported_state_alarm_sum,	
		phys_disabled_state_alarm_sum,		
	}
	
}

/* Device -> Query Device -> Physical Block -> Index24-31 [Specialist] */
MENU Page_s_query_pb_2
{
	LABEL	[query_phys_2];
	ITEMS
	{
		phys_software_rev,					/* Index24 */
		phys_hardware_rev,					/* Index25 */
		phys_device_man_id,					/* Index26 */
		phys_device_id,						/* Index27 */
		phys_device_ser_num,				/* Index28 */
		phys_diagnosis,						/* Index29 */
		phys_diagnosis_mask,				/* Index30 */
		phys_diagnosis_extension_byte_1,	/* Index31 */
#ifdef _PDM_
		SEPARATOR,
#endif
		phys_diagnosis_extension_byte_2,
		phys_diagnosis_extension_byte_3,
		phys_diagnosis_extension_byte_4,
		phys_diagnosis_extension_byte_5,
		phys_diagnosis_extension_byte_6
	}
}

/* Device -> Query Device -> Physical Block -> Index32-50 [Specialist] */
MENU Page_s_query_pb_3
{
//	LABEL	[query_phys_3];
	LABEL	"Index32-41";
	ITEMS
	{
		phys_diagnosis_extension_mask_byte_1,/* Index32 */
		phys_diagnosis_extension_mask_byte_2,
		phys_diagnosis_extension_mask_byte_3,
		phys_diagnosis_extension_mask_byte_4,
#ifdef _PDM_
		SEPARATOR,
#endif
		phys_diagnosis_extension_mask_byte_5,
		phys_diagnosis_extension_mask_byte_6,
		phys_device_certification,			/* Index33 */
		phys_write_locking,					/* Index34 */
		phys_factory_reset,					/* Index35 */
		phys_descriptor,					/* Index36 */
		phys_message,						/* Index37 */
		phys_install_date,					/* Index38 */
/* 		phys_local_operation_enable,*/		/* Index39 */
		phys_ident_number,					/* Index40 */
		phys_hw_write_protection,			/* Index41 */
	}
}

/* Device -> Query Device -> Physical Block -> Index51-53 [Specialist] */
MENU Page_s_query_pb_4
{
//	LABEL	[query_phys_4];
	LABEL	"Index49-53";
	ITEMS
	{
		phys_soft_desc,							/* Index49 */
		phys_set_address,						/* Index50 */
		phys_function_block_status_byte_1,		/* Index51 */
		phys_function_block_status_byte_2,		
//		phys_function_block_status_byte_3,		
		phys_function_block_status_byte_4,		
		phys_function_block_status_byte_5,		
//		phys_function_block_status_byte_6,		
		phys_diagnosis_simulation_mode,			/* Index52 */
#ifdef _PDM_
		SEPARATOR,
#endif
		phys_diagnosis_sim_extension_byte_1,	/* Index53 */
		phys_diagnosis_sim_extension_byte_2,	
		phys_diagnosis_sim_extension_byte_3,	
		phys_diagnosis_sim_extension_byte_4,	
		phys_diagnosis_sim_extension_byte_5	
		phys_diagnosis_sim_extension_byte_6,	
	}
}

/* Device -> Query Device -> Transducer Block [Specialist] */
MENU OnlineDialog_s_query_tb
{
	LABEL	[trans_block];
	ITEMS
	{
		Page_s_query_tb_1,
		Page_s_query_tb_2,
		Page_s_query_tb_3,
		Page_s_query_tb_4,
		Page_s_query_tb_5
	}
}

/* Device -> Query Device -> Transducer Block -> index16-23 [Specialist] */
MENU Page_s_query_tb_1
{
	LABEL	[query_tb_1];
	ITEMS
	{
		trans1_blk_reserve,					/* Index16 */
		trans1_blk_object,
		trans1_blk_parent_class,
		trans1_blk_class,
		trans1_blk_dd_reference,
		trans1_blk_dd_rev,
		trans1_blk_profile,
		trans1_blk_profile_rev,
		trans1_blk_execution_time,
		trans1_blk_highest_rel_offset,
		trans1_blk_index_view_1,
		trans1_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		trans1_st_rev,						/* Index17 */
		trans1_tag_desc,					/* Index18 */
		trans1_strategy,					/* Index19 */
		trans1_alert_key,					/* Index20 */
		trans1_target_mode,					/* Index21 */
		trans1_actual_mode,					/* Index22 */
		trans1_permitted_mode,
		trans1_normal_mode,
		trans1_current_state_alarm_sum,		/* Index23 */
		trans1_unacknowledged_state_alarm_sum,
		trans1_unreported_state_alarm_sum,
		trans1_disabled_state_alarm_sum
	}
}

/* Device -> Query Device -> Transducer Block -> index24-58 [Specialist] */
MENU Page_s_query_tb_2
{
	LABEL	[query_tb_2];
	ITEMS
	{
		trans1_calibration_factor,			/* Index24 */
		trans1_low_flow_cutoff,				/* Index25 */
		trans1_measurement_mode,			/* Index26 */
		trans1_flow_direction,				/* Index27 */
		trans1_zero_point,					/* Index28 */
		trans1_zero_point_adjust,			/* Index29 */
		trans1_zero_point_units,			/* Index30 */
		trans1_nominal_size,				/* Index31 */
		trans1_nominal_size_units,			/* Index32 */
#ifdef _PDM_
		SEPARATOR,
#endif
		trans1_volume_flow_value,			/* Index33 */
		trans1_volume_flow_status_quality	<0xFC>,
		trans1_volume_flow_status_limit		<0x03>,
		trans1_volume_flow_units,			/* Index34 */
		trans1_volume_flow_lower_limit,		/* Index35 */
		trans1_volume_flow_upper_limit,		/* Index36 */
		trans1_sample_rate,					/* Index57 */
		trans1_sample_rate_status_quality	<0xFC>,
		trans1_sample_rate_status_limit		<0x03>,
		trans1_sample_rate_units			/* Index58 */
	}
}

/* Device -> Query Device -> Transducer Block -> index69-89 [Specialist] */
MENU Page_s_query_tb_3
{
	LABEL	[query_tb_3];
	ITEMS
	{
		trans1_volume_flow_ftime,			/* Index69 */
		trans1_dual_frequency_mode,			/* Index70 */
		trans1_low_mf,						/* Index71 */
		trans1_high_mf,						/* Index72 */
		trans1_low_mf_edf,					/* Index73 */
		trans1_high_mf_edf,					/* Index74 */
		trans1_select_flow_tube,			/* Index75 */
		trans1_density_unit,				/* Index76 */
		trans1_mass_flow_density,			/* Index77 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_s_trans1_limit_switch_1,		/* Index78-83 */
		Group_s_trans1_limit_switch_2,		/* Index84-89 */
		Group_s_trans1_switch_1,			/* Index90-91 */
		Group_s_trans1_switch_2				/* Index92-93 */

	}
}

MENU Group_s_trans1_limit_switch_1
{
	LABEL	[limit_switch_1];
	ITEMS
	{
		trans1_limsw_1_value_d_value,		/* Index78 */
		trans1_limsw_1_value_d_status_quality,
		trans1_limsw_1_value_d_status_limit,
		trans1_limsw_1_target,				/* Index79 */
		trans1_limsw_1_setpoint,			/* Index80 */
		trans1_limsw_1_direction,			/* Index81 */
		trans1_limsw_1_hysteresis,			/* Index82 */
		trans1_limsw_1_unit					/* Index83 */
	}
}

MENU Group_s_trans1_limit_switch_2
{
	LABEL	[limit_switch_2];
	ITEMS
	{
		trans1_limsw_2_value_d_value,		/* Index84 */
		trans1_limsw_2_value_d_status_quality,
		trans1_limsw_2_value_d_status_limit,
		trans1_limsw_2_target,				/* Index85 */
		trans1_limsw_2_setpoint,			/* Index86 */
		trans1_limsw_2_direction,			/* Index87 */
		trans1_limsw_2_hysteresis,			/* Index88 */
		trans1_limsw_2_unit					/* Index89 */
	}
}

MENU Group_s_trans1_switch_1
{
	LABEL	[switch_1];
	ITEMS
	{
		trans1_switch_1_value_d_value,		/* Index90 */
		trans1_switch_1_value_d_status_quality,
		trans1_switch_1_value_d_status_limit,
		trans1_switch_1_target				/* Index91 */
	}
}

MENU Group_s_trans1_switch_2
{
	LABEL	[switch_2];
	ITEMS
	{
		trans1_switch_2_value_d_value,		/* Index92 */
		trans1_switch_2_value_d_status_quality,
		trans1_switch_2_value_d_status_limit,
		trans1_switch_2_target				/* Index93 */	}
}

/* Device -> Query Device -> Transducer Block -> index94-101 [Specialist] */
MENU Page_s_query_tb_4
{
	LABEL	[query_tb_4];
	ITEMS
	{
		trans1_signal_lock,					/* Index94 */
//		trans1_alarm_perform,				/* Index95 */
		trans1_alarm_perform_1,				/* Index95 */
		trans1_alarm_perform_2,
		
#ifdef _PDM_
		SEPARATOR,
#endif
		trans1_simulate_mode,				/* Index96 */
		trans1_simulate_type,				/* Index97 */
		trans1_simulate_volume_flow_value,	/* Index98 */
		trans1_simulate_volume_flow_status_quality,
		trans1_simulate_volume_flow_status_limit,
		trans1_simulate_up_value,			/* Index99 */
		trans1_simulate_lo_value,			/* Index100 */
		trans1_simulate_time				/* Index101 */
	}
}


/* Device -> Query Device -> Transducer Block -> index102-127 [Specialist] */
MENU Page_s_query_tb_5
{
	LABEL	[query_tb_5];
	ITEMS
	{
		trans1_operation_time,				/* Index102 */
		trans1_alm_record_1,				/* Index103 */
		trans1_alm_record_time_1,			/* Index104 */
		trans1_alm_record_2,				/* Index105 */
		trans1_alm_record_time_2,			/* Index106 */
		trans1_alm_record_3,				/* Index107 */
		trans1_alm_record_time_3,			/* Index108 */
		trans1_alm_record_4,				/* Index109 */
		trans1_alm_record_time_4,			/* Index110 */
		trans1_diplay_select1,				/* Index111 */
		trans1_diplay_select2,				/* Index112 */
		trans1_diplay_select3,				/* Index113 */
		trans1_diplay_cycle,				/* Index114 */
#ifdef _PDM_
		SEPARATOR,
#endif
		trans1_language,					/* Index115 */
		trans1_rate_limit,					/* Index116 */
		trans1_dead_time,					/* Index117 */
		trans1_pulsing_flow,				/* Index118 */
		trans1_power_synch,					/* Index119 */
		trans1_power_frequency,				/* Index120 */
		trans1_software_rev_no,				/* Index121 */
		trans1_adhesion_check,				/* Index122 */
		trans1_adhesion_level_1,			/* Index123 */
		trans1_adhesion_level_2,			/* Index124 */
		trans1_adhesion_level_3,			/* Index125 */
		trans1_adhesion_level_4,			/* Index126 */
		trans1_adh_measure_value			/* Index127 */
	}
}

/* Device -> Query Device -> Analog Input [Specialist] */
MENU OnlineDialog_s_query_ai
{
	LABEL	FUNC1_TITLE;
	ITEMS
	{
		Page_s_query_ai_1,
		Page_s_query_ai_2,
		Page_s_query_ai_3,
		Page_s_query_ai_4
	}
}

/* Device -> Query Device -> Analog Input index16-22 [Specialist] */
MENU Page_s_query_ai_1
{
	LABEL	[query_ai_1];
	ITEMS
	{
		func1_AI_blk_reserve,				/* Index16 */
		func1_AI_blk_object,
		func1_AI_blk_parent_class,
		func1_AI_blk_class,
		func1_AI_blk_dd_reference,
		func1_AI_blk_dd_rev,
		func1_AI_blk_profile,
		func1_AI_blk_profile_rev,
		func1_AI_blk_execution_time,
		func1_AI_blk_num_parameters,
		func1_AI_blk_index_view_1,
		func1_AI_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		func1_AI_st_rev,					/* Index17 */
		func1_AI_tag_desc,					/* Index18 */
		func1_AI_strategy,					/* Index19 */
		func1_AI_alert_key,					/* Index20 */
		func1_AI_target_mode,				/* Index21 */
		func1_AI_actual_mode,				/* Index22 */
		func1_AI_permitted_mode,			
		func1_AI_normal_mode,				
	}
}

/* Device -> Query Device -> Analog Input index23-28 [Specialist] */
MENU Page_s_query_ai_2
{
	LABEL	[query_ai_2];
	ITEMS
	{
		func1_AI_current_state_alarm_sum,	/* Index23 */
		func1_AI_unacknowledged_state_alarm_sum,
		func1_AI_unreported_state_alarm_sum,
		func1_AI_disabled_state_alarm_sum,
#ifdef _PDM_
		SEPARATOR,
#endif
		func1_AI_batch_id,					/* Index24 */
		func1_AI_batch_unit,
		func1_AI_batch_operation,
		func1_AI_batch_phase,
		Group_s_func1_ai_out,				/* Index26 */
		Group_s_func1_ai_pv_scale,			/* Index27 */
		Group_s_func1_ai_out_scale,			/* Index28 */
	}
}

MENU Group_s_func1_ai_out
{
	LABEL	[func_out_value];
	ITEMS
	{
		func1_AI_out_value,
		func1_AI_out_status_quality,
		func1_AI_out_status_limit,
	}
}

MENU Group_s_func1_ai_pv_scale
{
	LABEL	[menu_input_measwindow];
	ITEMS
	{
		func1_AI_pv_upper_range_value,
		func1_AI_pv_lower_range_value
	}
}


MENU Group_s_func1_ai_out_scale
{
	LABEL	[menu_output_scalewindow];
	ITEMS
	{
		func1_AI_out_upper_range_value,
		func1_AI_out_lower_range_value,
		func1_AI_out_unit,
		func1_AI_out_decimal_point
	}
}

/* Device -> Query Device -> Analog Input index29-49 [Specialist] */
MENU Page_s_query_ai_3
{
	LABEL	[query_ai_3];
	ITEMS
	{
		func1_AI_lin_type,					/* Index29 */
		func1_AI_channel,					/* Index30 */
		func1_AI_pv_ftime,					/* Index32 */
		func1_AI_FSafeType,					/* Index33 */
		func1_AI_FSafeValue,				/* Index34 */
		func1_AI_alarm_hys,					/* Index35 */
		func1_AI_hi_hi_lim,					/* Index37 */
		func1_AI_hi_lim,					/* Index39 */
		func1_AI_lo_lim,					/* Index41 */
		func1_AI_lo_lo_lim,					/* Index43 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_s_func1_ai_hi_hi_alm,			/* Index46 */
		Group_s_func1_ai_hi_alm,			/* Index47 */
		Group_s_func1_ai_lo_alm,			/* Index48 */
		Group_s_func1_ai_lo_lo_alm,			/* Index49 */
	}
}

MENU Group_s_func1_ai_hi_hi_alm
{
	LABEL	[limit_hi_hi];
	ITEMS
	{
		func1_AI_hi_hi_alm_unacknowledged,
		func1_AI_hi_hi_alm_state,
		func1_AI_hi_hi_alm_time_stamp,
		func1_AI_hi_hi_alm_subcode,
		func1_AI_hi_hi_alm_value
	}
}


MENU Group_s_func1_ai_hi_alm
{
	LABEL	[limit_hi];
	ITEMS
	{
		func1_AI_hi_alm_unacknowledged,
		func1_AI_hi_alm_state,
		func1_AI_hi_alm_time_stamp,
		func1_AI_hi_alm_subcode,
		func1_AI_hi_alm_value
	}
}

MENU Group_s_func1_ai_lo_alm
{
	LABEL	[limit_lo];
	ITEMS
	{
		func1_AI_lo_alm_unacknowledged,
		func1_AI_lo_alm_state,
		func1_AI_lo_alm_time_stamp,
		func1_AI_lo_alm_subcode,
		func1_AI_lo_alm_value
	}
}


MENU Group_s_func1_ai_lo_lo_alm
{
	LABEL	[limit_lo_lo];
	ITEMS
	{
		func1_AI_lo_lo_alm_unacknowledged,
		func1_AI_lo_lo_alm_state,
		func1_AI_lo_lo_alm_time_stamp,
		func1_AI_lo_lo_alm_subcode,
		func1_AI_lo_lo_alm_value
	}
}

/* Device -> Query Device -> Analog Input index50- [Specialist] */
MENU Page_s_query_ai_4
{
	LABEL	[query_ai_4];
	ITEMS
	{
		Group_s_func1_ai_simulate,			/* Index50 */
		func1_AI_out_unit_text,				/* Index52 */
		func1_AI_velocity_check				/* Index61 */
		
	}
}

MENU Group_s_func1_ai_simulate
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func1_AI_simulate_status_quality,
		func1_AI_simulate_status_limit
		func1_AI_simulate_value,
		func1_AI_simulation_enabled
	}
}


/* Device -> Query Device -> Totilizer1 [Specialist] */
MENU OnlineDialog_s_query_tot1
{
	LABEL	FUNC2_TITLE;
	ITEMS
	{
		Page_s_query_tot1_1,
		Page_s_query_tot1_2,
		Page_s_query_tot1_3
	}
}

/* Device -> Query Device -> Totilizer1 -> index16-22 [Specialist] */
MENU Page_s_query_tot1_1
{
	LABEL	[query_tot_1];
	ITEMS
	{
		func2_TOT_blk_reserve,				/* Index16 */
		func2_TOT_blk_object,
		func2_TOT_blk_parent_class,
		func2_TOT_blk_class,
		func2_TOT_blk_dd_reference,
		func2_TOT_blk_dd_rev,
		func2_TOT_blk_profile,
		func2_TOT_blk_profile_rev,
		func2_TOT_blk_execution_time,
		func2_TOT_blk_num_parameters,
		func2_TOT_blk_index_view_1,
		func2_TOT_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		func2_TOT_st_rev,					/* Index17 */
		func2_TOT_tag_desc,					/* Index18 */
		func2_TOT_strategy,					/* Index19 */
		func2_TOT_alert_key,				/* Index20 */
		func2_TOT_target_mode,				/* Index21 */
		func2_TOT_actual_mode,				/* Index22 */
		func2_TOT_permitted_mode,
		func2_TOT_normal_mode
	}
}

/* Device -> Query Device -> Totilizer1 -> index23-29 [Specialist] */
MENU Page_s_query_tot1_2
{
	LABEL	[query_tot_2];
	ITEMS
	{
		func2_TOT_current_state_alarm_sum,	/* Index23 */
		func2_TOT_unacknowledged_state_alarm_sum,
		func2_TOT_unreported_state_alarm_sum,
		func2_TOT_disabled_state_alarm_sum,
#ifdef _PDM_
		SEPARATOR,
#endif
		func2_TOT_batch_id,					/* Index24 */
		func2_TOT_batch_unit,
		func2_TOT_batch_operation,
		func2_TOT_batch_phase,
		func2_TOT_total_value,				/* Index26 */
		func2_TOT_total_status_quality,
		func2_TOT_total_status_limit,
		func2_TOT_unit_tot,					/* Index27 */
		func2_TOT_channel,					/* Index28 */
		func2_TOT_set_tot,					/* Index29 */
	}
}

/* Device -> Query Device -> Totilizer1 -> index30 [Specialist] */
MENU Page_s_query_tot1_3
{
	LABEL	[query_tot_3];
	ITEMS
	{
		func2_TOT_mode_tot,					/* Index30 */
		func2_TOT_fail_tot,					/* Index31 */
		func2_TOT_preset_tot,				/* Index32 */
		func2_TOT_alarm_hys,				/* Index33*/
		func2_TOT_hi_hi_lim,				/* Index34 */
		func2_TOT_hi_lim ,					/* Index35 */
		func2_TOT_lo_lim,					/* Index36 */
		func2_TOT_lo_lo_lim,				/* Index37 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_s_func2_tot_hi_hi_alm,		/* Index38 */
		Group_s_func2_tot_hi_alm,			/* Index39 */
		Group_s_func2_tot_lo_alm,			/* Index40 */
		Group_s_func2_tot_lo_lo_alm,		/* Index41 */
		func2_TOT_simulation_enabled,		/* Index52 */
		Group_simulate_input_func2
	}
}



MENU Group_s_func2_tot_hi_hi_alm
{
	LABEL	[limit_hi_hi];
	ITEMS
	{
		func2_TOT_hi_hi_alm_unacknowledged,
		func2_TOT_hi_hi_alm_state,
		func2_TOT_hi_hi_alm_time_stamp,
		func2_TOT_hi_hi_alm_subcode,
		
		func2_TOT_hi_hi_alm_value
	}
}


MENU Group_s_func2_tot_hi_alm
{
	LABEL	[limit_hi];
	ITEMS
	{
		func2_TOT_hi_alm_unacknowledged,
		func2_TOT_hi_alm_state,
		func2_TOT_hi_alm_time_stamp,
		func2_TOT_hi_alm_subcode,
		
		func2_TOT_hi_alm_value
	}
}

MENU Group_s_func2_tot_lo_alm
{
	LABEL	[limit_lo];
	ITEMS
	{
		func2_TOT_lo_alm_unacknowledged,
		func2_TOT_lo_alm_state,
		func2_TOT_lo_alm_time_stamp,
		func2_TOT_lo_alm_subcode,
		
		func2_TOT_lo_alm_value
	}
}


MENU Group_s_func2_tot_lo_lo_alm
{
	LABEL	[limit_lo_lo];
	ITEMS
	{
		func2_TOT_lo_lo_alm_unacknowledged,
		func2_TOT_lo_lo_alm_state,
		func2_TOT_lo_lo_alm_time_stamp,
		func2_TOT_lo_lo_alm_subcode,
		
		func2_TOT_lo_lo_alm_value
	}
}

/* Device -> Query Device -> Totilizer2 [Specialist] */
MENU OnlineDialog_s_query_tot2
{
	LABEL	FUNC3_TITLE;
	ITEMS
	{
		Page_s_query_tot2_1,
		Page_s_query_tot2_2,
		Page_s_query_tot2_3
	}
}


MENU Page_s_query_tot2_1
{
	LABEL	[query_tot_1];
	ITEMS
	{
		func3_TOT_blk_reserve,				/* Index16 */
		func3_TOT_blk_object,
		func3_TOT_blk_parent_class,
		func3_TOT_blk_class,
		func3_TOT_blk_dd_reference,
		func3_TOT_blk_dd_rev,
		func3_TOT_blk_profile,
		func3_TOT_blk_profile_rev,
		func3_TOT_blk_execution_time,
		func3_TOT_blk_num_parameters,
		func3_TOT_blk_index_view_1,
		func3_TOT_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		func3_TOT_st_rev,					/* Index17 */
		func3_TOT_tag_desc,					/* Index18 */
		func3_TOT_strategy,					/* Index19 */
		func3_TOT_alert_key,				/* Index20 */
		func3_TOT_target_mode,				/* Index21 */
		func3_TOT_actual_mode,				/* Index22 */
		func3_TOT_permitted_mode,
		func3_TOT_normal_mode
	}
}

MENU Page_s_query_tot2_2
{
	LABEL	[query_tot_2];
	ITEMS
	{
		func3_TOT_current_state_alarm_sum,	/* Index23 */
		func3_TOT_unacknowledged_state_alarm_sum,
		func3_TOT_unreported_state_alarm_sum,
		func3_TOT_disabled_state_alarm_sum,
#ifdef _PDM_
		SEPARATOR,
#endif
		func3_TOT_batch_id,					/* Index24 */
		func3_TOT_batch_unit,
		func3_TOT_batch_operation,
		func3_TOT_batch_phase,
		func3_TOT_total_value,				/* Index26 */
		func3_TOT_total_status_quality,
		func3_TOT_total_status_limit,
		func3_TOT_unit_tot,					/* Index27 */
		func3_TOT_channel,					/* Index28 */
		func3_TOT_set_tot,					/* Index29 */
	}
	
}

MENU Page_s_query_tot2_3
{
	LABEL	[query_tot_3];
	ITEMS
	{
		func3_TOT_mode_tot,					/* Index30 */
		func3_TOT_fail_tot,					/* Index31 */
		func3_TOT_preset_tot,				/* Index32 */
		func3_TOT_alarm_hys,				/* Index33*/
		func3_TOT_hi_hi_lim,				/* Index34 */
		func3_TOT_hi_lim ,					/* Index35 */
		func3_TOT_lo_lim,					/* Index36 */
		func3_TOT_lo_lo_lim,				/* Index37 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_s_func3_tot_hi_hi_alm,		/* Index38 */
		Group_s_func3_tot_hi_alm,			/* Index39 */
		Group_s_func3_tot_lo_alm,			/* Index40 */
		Group_s_func3_tot_lo_lo_alm,		/* Index41 */
		func3_TOT_simulation_enabled,		/* Index52 */
		Group_simulate_input_func3
	}
}



MENU Group_s_func3_tot_hi_hi_alm
{
	LABEL	[limit_hi_hi];
	ITEMS
	{
		func3_TOT_hi_hi_alm_unacknowledged,
		func3_TOT_hi_hi_alm_state,
		func3_TOT_hi_hi_alm_time_stamp,
		func3_TOT_hi_hi_alm_subcode,
		
		func3_TOT_hi_hi_alm_value
	}
}


MENU Group_s_func3_tot_hi_alm
{
	LABEL	[limit_hi];
	ITEMS
	{
		func3_TOT_hi_alm_unacknowledged,
		func3_TOT_hi_alm_state,
		func3_TOT_hi_alm_time_stamp,
		func3_TOT_hi_alm_subcode,
		
		func3_TOT_hi_alm_value
	}
}

MENU Group_s_func3_tot_lo_alm
{
	LABEL	[limit_lo];
	ITEMS
	{
		func3_TOT_lo_alm_unacknowledged,
		func3_TOT_lo_alm_state,
		func3_TOT_lo_alm_time_stamp,
		func3_TOT_lo_alm_subcode,
		
		func3_TOT_lo_alm_value
	}
}


MENU Group_s_func3_tot_lo_lo_alm
{
	LABEL	[limit_lo_lo];
	ITEMS
	{
		func3_TOT_lo_lo_alm_unacknowledged,
		func3_TOT_lo_lo_alm_state,
		func3_TOT_lo_lo_alm_time_stamp,
		func3_TOT_lo_lo_alm_subcode,
		
		func3_TOT_lo_lo_alm_value
	}
}




/* Device -> Query Device -> Totilizer3 [Specialist] */
MENU OnlineDialog_s_query_tot3
{
	LABEL	FUNC4_TITLE;
	ITEMS
	{
		Page_s_query_tot3_1,
		Page_s_query_tot3_2,
		Page_s_query_tot3_3
	}
}

MENU Page_s_query_tot3_1
{
	LABEL	[query_tot_1];
	ITEMS
	{
		func4_TOT_blk_reserve,				/* Index16 */
		func4_TOT_blk_object,
		func4_TOT_blk_parent_class,
		func4_TOT_blk_class,
		func4_TOT_blk_dd_reference,
		func4_TOT_blk_dd_rev,
		func4_TOT_blk_profile,
		func4_TOT_blk_profile_rev,
		func4_TOT_blk_execution_time,
		func4_TOT_blk_num_parameters,
		func4_TOT_blk_index_view_1,
		func4_TOT_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		func4_TOT_st_rev,					/* Index17 */
		func4_TOT_tag_desc,					/* Index18 */
		func4_TOT_strategy,					/* Index19 */
		func4_TOT_alert_key,				/* Index20 */
		func4_TOT_target_mode,				/* Index21 */
		func4_TOT_actual_mode,				/* Index22 */
		func4_TOT_permitted_mode,
		func4_TOT_normal_mode
	}
}

MENU Page_s_query_tot3_2
{
	LABEL	[query_tot_2];
	ITEMS
	{
		func4_TOT_current_state_alarm_sum,	/* Index23 */
		func4_TOT_unacknowledged_state_alarm_sum,
		func4_TOT_unreported_state_alarm_sum,
		func4_TOT_disabled_state_alarm_sum,
#ifdef _PDM_
		SEPARATOR,
#endif
		func4_TOT_batch_id,					/* Index24 */
		func4_TOT_batch_unit,
		func4_TOT_batch_operation,
		func4_TOT_batch_phase,
		func4_TOT_total_value,				/* Index26 */
		func4_TOT_total_status_quality,
		func4_TOT_total_status_limit,
		func4_TOT_unit_tot,					/* Index27 */
		func4_TOT_channel,					/* Index28 */
		func4_TOT_set_tot,					/* Index29 */
	}
	
}

MENU Page_s_query_tot3_3
{
	LABEL	[query_tot_3];
	ITEMS
	{
		func4_TOT_mode_tot,					/* Index30 */
		func4_TOT_fail_tot,					/* Index31 */
		func4_TOT_preset_tot,				/* Index32 */
		func4_TOT_alarm_hys,				/* Index33*/
		func4_TOT_hi_hi_lim,				/* Index34 */
		func4_TOT_hi_lim ,					/* Index35 */
		func4_TOT_lo_lim,					/* Index36 */
		func4_TOT_lo_lo_lim,				/* Index37 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_s_func4_tot_hi_hi_alm,		/* Index38 */
		Group_s_func4_tot_hi_alm,			/* Index39 */
		Group_s_func4_tot_lo_alm,			/* Index40 */
		Group_s_func4_tot_lo_lo_alm,		/* Index41 */
		func4_TOT_simulation_enabled,		/* Index52 */
		Group_simulate_input_func4
	}
}



MENU Group_s_func4_tot_hi_hi_alm
{
	LABEL	[limit_hi_hi];
	ITEMS
	{
		func4_TOT_hi_hi_alm_unacknowledged,
		func4_TOT_hi_hi_alm_state,
		func4_TOT_hi_hi_alm_time_stamp,
		func4_TOT_hi_hi_alm_subcode,
		
		func4_TOT_hi_hi_alm_value
	}
}


MENU Group_s_func4_tot_hi_alm
{
	LABEL	[limit_hi];
	ITEMS
	{
		func4_TOT_hi_alm_unacknowledged,
		func4_TOT_hi_alm_state,
		func4_TOT_hi_alm_time_stamp,
		func4_TOT_hi_alm_subcode,
		
		func4_TOT_hi_alm_value
	}
}

MENU Group_s_func4_tot_lo_alm
{
	LABEL	[limit_lo];
	ITEMS
	{
		func4_TOT_lo_alm_unacknowledged,
		func4_TOT_lo_alm_state,
		func4_TOT_lo_alm_time_stamp,
		func4_TOT_lo_alm_subcode,
		
		func4_TOT_lo_alm_value
	}
}


MENU Group_s_func4_tot_lo_lo_alm
{
	LABEL	[limit_lo_lo];
	ITEMS
	{
		func4_TOT_lo_lo_alm_unacknowledged,
		func4_TOT_lo_lo_alm_state,
		func4_TOT_lo_lo_alm_time_stamp,
		func4_TOT_lo_lo_alm_subcode,
		
		func4_TOT_lo_lo_alm_value
	}
}


/* Device -> Query Device -> Discrete Input1 [Specialist] */
MENU OnlineDialog_s_query_di1
{
	LABEL	FUNC5_TITLE;
	ITEMS
	{
		Page_s_query_di1_1,
		Page_s_query_di1_2
	}
}

/* Device -> Query Device -> Discrete Input1 -> index16-23 [Specialist] */
MENU Page_s_query_di1_1
{
	LABEL	[query_di_1];
	ITEMS
	{
		func5_DI_blk_reserve,				/* Index16 */
		func5_DI_blk_object,
		func5_DI_blk_parent_class,
		func5_DI_blk_class,
		func5_DI_blk_dd_reference,
		func5_DI_blk_dd_rev,
		func5_DI_blk_profile,
		func5_DI_blk_profile_rev,
		func5_DI_blk_execution_time,
		func5_DI_blk_num_parameters,
		func5_DI_blk_index_view_1,
		func5_DI_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		func5_DI_st_rev,					/* Index17 */
		func5_DI_tag_desc,					/* Index18 */
		func5_DI_strategy,					/* Index19 */
		func5_DI_alert_key,					/* Index20 */
		func5_DI_target_mode,				/* Index21 */
		func5_DI_actual_mode,				/* Index22 */
		func5_DI_permitted_mode,
		func5_DI_normal_mode
		func5_DI_current_state_alarm_sum,	/* Index23 */
		func5_DI_unacknowledged_state_alarm_sum,
		func5_DI_unreported_state_alarm_sum,
		func5_DI_disabled_state_alarm_sum
	}
}

/* Device -> Query Device -> Discrete Input1 -> index24- [Specialist] */
MENU Page_s_query_di1_2
{
	LABEL	[query_di_2];
	ITEMS
	{
		func5_DI_batch_id,					/* Index24 */
		func5_DI_batch_unit,
		func5_DI_batch_operation,
		func5_DI_batch_phase,
		func5_DI_out_value,					/* Index26 */
		func5_DI_out_status_quality,
		func5_DI_out_status_limit,
		func5_DI_channel,					/* Index30 */
		func5_DI_invert,					/* Index31 */
		func5_DI_fsafe_type,				/* Index36 */
		func5_DI_fsafe_value,				/* Index37 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_s_func5_di_simulate			/* Index40 */
	}
}


MENU Group_s_func5_di_simulate
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func5_DI_simulate_status_quality,
		func5_DI_simulate_status_limit,
		func5_DI_simulate_value,
		func5_DI_simulation_enabled
	}
}

/* Device -> Query Device -> Discrete Input2 [Specialist] */
MENU OnlineDialog_s_query_di2
{
	LABEL	FUNC6_TITLE;
	ITEMS
	{
		Page_s_query_di2_1,
		Page_s_query_di2_2
	}
}

MENU Page_s_query_di2_1
{
	LABEL	[query_di_1];
	ITEMS
	{
		func6_DI_blk_reserve,				/* Index16 */
		func6_DI_blk_object,
		func6_DI_blk_parent_class,
		func6_DI_blk_class,
		func6_DI_blk_dd_reference,
		func6_DI_blk_dd_rev,
		func6_DI_blk_profile,
		func6_DI_blk_profile_rev,
		func6_DI_blk_execution_time,
		func6_DI_blk_num_parameters,
		func6_DI_blk_index_view_1,
		func6_DI_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		func6_DI_st_rev,					/* Index17 */
		func6_DI_tag_desc,					/* Index18 */
		func6_DI_strategy,					/* Index19 */
		func6_DI_alert_key,					/* Index20 */
		func6_DI_target_mode,				/* Index21 */
		func6_DI_actual_mode,				/* Index22 */
		func6_DI_permitted_mode,
		func6_DI_normal_mode
		func6_DI_current_state_alarm_sum,	/* Index23 */
		func6_DI_unacknowledged_state_alarm_sum,
		func6_DI_unreported_state_alarm_sum,
		func6_DI_disabled_state_alarm_sum
	}
}


MENU Page_s_query_di2_2
{
	LABEL	[query_di_2];
	ITEMS
	{
		func6_DI_batch_id,					/* Index24 */
		func6_DI_batch_unit,
		func6_DI_batch_operation,
		func6_DI_batch_phase,
		func6_DI_out_value,					/* Index26 */
		func6_DI_out_status_quality,
		func6_DI_out_status_limit,
		func6_DI_channel,					/* Index30 */
		func6_DI_invert,					/* Index31 */
		func6_DI_fsafe_type,				/* Index36 */
		func6_DI_fsafe_value,				/* Index37 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_s_func6_di_simulate			/* Index40 */
	}
}


MENU Group_s_func6_di_simulate
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func6_DI_simulate_status_quality,
		func6_DI_simulate_status_limit,
		func6_DI_simulate_value,
		func6_DI_simulation_enabled
	}
}



/* Device -> Query Device [Maintenance] */
MENU Menu_m_query_device
{
	LABEL  [query_device];
	ITEMS
	{
		OnlineDialog_m_query_pb,	/* PB */ 
		OnlineDialog_m_query_tb,	/* TB */
		OnlineDialog_m_query_ai,	/* AI */
		OnlineDialog_m_query_tot1,	/* TOT1 */
		OnlineDialog_m_query_tot2,	/* TOT2 */
		OnlineDialog_m_query_tot3,	/* TOT3 */
		OnlineDialog_m_query_di1,	/* DI1 */
		OnlineDialog_m_query_di2	/* DI2 */
	}
	
}


/* Device -> Query Device -> Physical Block [Maintenance] */
MENU OnlineDialog_m_query_pb
{
	LABEL	[blk_block_object_PHYSICAL];
	ITEMS
	{
		Page_m_query_pb_1,
		Page_m_query_pb_2,
		Page_m_query_pb_3,
		Page_m_query_pb_4
	}
}

/* Device -> Query Device -> Physical Block -> Index16-23 [Maintenance] */
MENU Page_m_query_pb_1
{
	LABEL	[query_phys_1];
	ITEMS
	{
		phys_blk_reserve,					/* Index16 */
		phys_blk_object,					
		phys_blk_parent_class,				
		phys_blk_class,						
		phys_blk_dd_reference,				
		phys_blk_dd_rev,					
		phys_blk_profile,					
		phys_blk_profile_rev,				
		phys_blk_execution_time,			
		phys_blk_num_parameters,			
		phys_blk_index_view_1,				
		phys_blk_num_view_lists,			
#ifdef _PDM_
		SEPARATOR,
#endif
		phys_st_rev,						/* Index17 */
		phys_tag_desc	(READ_ONLY),		/* Index18 */
		phys_strategy	(READ_ONLY),		/* Index19 */
		phys_alert_key	(READ_ONLY),		/* Index20 */
		phys_target_mode(READ_ONLY),		/* Index21 */
		phys_actual_mode,					/* Index22 */
		phys_permitted_mode,				
		phys_normal_mode,					
		phys_current_state_alarm_sum,		/* Index23 */
		phys_unacknowledged_state_alarm_sum,
		phys_unreported_state_alarm_sum,	
		phys_disabled_state_alarm_sum,		
	}
	
}

/* Device -> Query Device -> Physical Block -> Index24-31 [Maintenance] */
MENU Page_m_query_pb_2
{
	LABEL	[query_phys_2];
	ITEMS
	{
		phys_software_rev,					/* Index24 */
		phys_hardware_rev,					/* Index25 */
		phys_device_man_id,					/* Index26 */
		phys_device_id,						/* Index27 */
		phys_device_ser_num,				/* Index28 */
		phys_diagnosis,						/* Index29 */
		phys_diagnosis_mask,				/* Index30 */
		phys_diagnosis_extension_byte_1,	/* Index31 */
#ifdef _PDM_
		SEPARATOR,
#endif
		phys_diagnosis_extension_byte_2,
		phys_diagnosis_extension_byte_3,
		phys_diagnosis_extension_byte_4,
		phys_diagnosis_extension_byte_5,
		phys_diagnosis_extension_byte_6
	}
}

/* Device -> Query Device -> Physical Block -> Index32- [Maintenance] */
MENU Page_m_query_pb_3
{
//	LABEL	[query_phys_3];
	LABEL	"Index32-41";
	ITEMS
	{
		phys_diagnosis_extension_mask_byte_1,/* Index32 */
		phys_diagnosis_extension_mask_byte_2,
		phys_diagnosis_extension_mask_byte_3,
		phys_diagnosis_extension_mask_byte_4,
#ifdef _PDM_
		SEPARATOR,
#endif
		phys_diagnosis_extension_mask_byte_5,
		phys_diagnosis_extension_mask_byte_6,
		phys_device_certification,			/* Index33 */
		phys_write_locking	(READ_ONLY),	/* Index34 */
		phys_factory_reset	(READ_ONLY),	/* Index35 */
		phys_descriptor,					/* Index36 */
		phys_message,						/* Index37 */
		phys_install_date	(READ_ONLY),	/* Index38 */
/*		phys_local_operation_enable,*/		/* Index39 */
		phys_ident_number	(READ_ONLY),	/* Index40 */
		phys_hw_write_protection,			/* Index41 */
	}
}

/* Device -> Query Device -> Physical Block -> Index51-53 [Maintenance] */
MENU Page_m_query_pb_4
{
//	LABEL	[query_phys_4];
	LABEL	"Index49-53";
	ITEMS
	{
		phys_soft_desc,						/* Index49 */
		phys_set_address	(READ_ONLY),	/* Index50 */
		phys_function_block_status_byte_1,					/* Index51 */
		phys_function_block_status_byte_2,					
//		phys_function_block_status_byte_3,					
		phys_function_block_status_byte_4,					
		phys_function_block_status_byte_5,					
//		phys_function_block_status_byte_6,					
		phys_diagnosis_simulation_mode		(READ_ONLY),	/* Index52 */
#ifdef _PDM_
		SEPARATOR,
#endif
		phys_diagnosis_sim_extension_byte_1	(READ_ONLY),	/* Index53 */
		phys_diagnosis_sim_extension_byte_2	(READ_ONLY),	
		phys_diagnosis_sim_extension_byte_3	(READ_ONLY),	
		phys_diagnosis_sim_extension_byte_4	(READ_ONLY),	
		phys_diagnosis_sim_extension_byte_5	(READ_ONLY)
		phys_diagnosis_sim_extension_byte_6	(READ_ONLY)
	}
}

/* Device -> Query Device -> Transducer Block [Maintenance] */
MENU OnlineDialog_m_query_tb
{
	LABEL	[trans_block];
	ITEMS
	{
		Page_m_query_tb_1,
		Page_m_query_tb_2,
		Page_m_query_tb_3,
		Page_m_query_tb_4,
		Page_m_query_tb_5
	}
}

/* Device -> Query Device -> Transducer Block -> index16-23 [Maintenance] */
MENU Page_m_query_tb_1
{
	LABEL	[query_tb_1];
	ITEMS
	{
		trans1_blk_reserve,					/* Index16 */
		trans1_blk_object,
		trans1_blk_parent_class,
		trans1_blk_class,
		trans1_blk_dd_reference,
		trans1_blk_dd_rev,
		trans1_blk_profile,
		trans1_blk_profile_rev,
		trans1_blk_execution_time,
		trans1_blk_highest_rel_offset,
		trans1_blk_index_view_1,
		trans1_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		trans1_st_rev,						/* Index17 */
		trans1_tag_desc		(READ_ONLY),	/* Index18 */
		trans1_strategy		(READ_ONLY),	/* Index19 */
		trans1_alert_key	(READ_ONLY),	/* Index20 */
		trans1_target_mode	(READ_ONLY),	/* Index21 */
		trans1_actual_mode,					/* Index22 */
		trans1_permitted_mode,
		trans1_normal_mode,
		trans1_current_state_alarm_sum,		/* Index23 */
		trans1_unacknowledged_state_alarm_sum,
		trans1_unreported_state_alarm_sum,
		trans1_disabled_state_alarm_sum
	}
}

/* Device -> Query Device -> Transducer Block -> index24-58 [Maintenance] */
MENU Page_m_query_tb_2
{
	LABEL	[query_tb_2];
	ITEMS
	{
		trans1_calibration_factor,				/* Index24 */
		trans1_low_flow_cutoff,					/* Index25 */
		trans1_measurement_mode,				/* Index26 */
		trans1_flow_direction		(READ_ONLY),/* Index27 */
		trans1_zero_point			(READ_ONLY),/* Index28 */
		trans1_zero_point_adjust	(READ_ONLY),/* Index29 */
		trans1_zero_point_units		(READ_ONLY),/* Index30 */
		trans1_nominal_size			(READ_ONLY),/* Index31 */
		trans1_nominal_size_units	(READ_ONLY),/* Index32 */
#ifdef _PDM_
		SEPARATOR,
#endif
		trans1_volume_flow_value,				/* Index33 */
		trans1_volume_flow_status_quality	<0xFC>,
		trans1_volume_flow_status_limit		<0x03>,
		trans1_volume_flow_units	(READ_ONLY),/* Index34 */
		trans1_volume_flow_lower_limit,			/* Index35 */
		trans1_volume_flow_upper_limit,			/* Index36 */
		trans1_sample_rate,						/* Index57 */
		trans1_sample_rate_status_quality	<0xFC>,
		trans1_sample_rate_status_limit		<0x03>,
		trans1_sample_rate_units	(READ_ONLY)	/* Index58 */
	}
}

/* Device -> Query Device -> Transducer Block -> index69-87 [Maintenance] */
MENU Page_m_query_tb_3
{
	LABEL	[query_tb_3];
	ITEMS
	{
		trans1_volume_flow_ftime	(READ_ONLY),/* Index69 */
		trans1_dual_frequency_mode	(READ_ONLY),/* Index70 */
		trans1_low_mf				(READ_ONLY),/* Index71 */
		trans1_high_mf				(READ_ONLY),/* Index72 */
		trans1_low_mf_edf			(READ_ONLY),/* Index73 */
		trans1_high_mf_edf			(READ_ONLY),/* Index74 */
		trans1_select_flow_tube		(READ_ONLY),/* Index75 */
		trans1_density_unit			(READ_ONLY),/* Index76 */
		trans1_mass_flow_density	(READ_ONLY),/* Index77 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_m_trans1_limit_switch_1,		/* Index78-83 */
		Group_m_trans1_limit_switch_2,		/* Index84-89 */
		Group_m_trans1_switch_1,			/* Index90-91 */
		Group_m_trans1_switch_2				/* Index92-93 */	}
}

MENU Group_m_trans1_limit_switch_1
{
	LABEL	[limit_switch_1];
	ITEMS
	{
		trans1_limsw_1_value_d_value,			/* Index78 */
		trans1_limsw_1_value_d_status_quality,
		trans1_limsw_1_value_d_status_limit,
		trans1_limsw_1_target		(READ_ONLY),/* Index79 */
		trans1_limsw_1_setpoint		(READ_ONLY),/* Index80 */
		trans1_limsw_1_direction	(READ_ONLY),/* Index81 */
		trans1_limsw_1_hysteresis	(READ_ONLY),/* Index82 */
		trans1_limsw_1_unit						/* Index83 */
	}
}

MENU Group_m_trans1_limit_switch_2
{
	LABEL	[limit_switch_2];
	ITEMS
	{
		trans1_limsw_2_value_d_value,			/* Index84 */
		trans1_limsw_2_value_d_status_quality,
		trans1_limsw_2_value_d_status_limit,
		trans1_limsw_2_target		(READ_ONLY),/* Index85 */
		trans1_limsw_2_setpoint		(READ_ONLY),/* Index86 */
		trans1_limsw_2_direction	(READ_ONLY),/* Index87 */
		trans1_limsw_2_hysteresis	(READ_ONLY),/* Index88 */
		trans1_limsw_2_unit						/* Index89 */
	}
}

MENU Group_m_trans1_switch_1
{
	LABEL	[switch_1];
	ITEMS
	{
		trans1_switch_1_value_d_value,		/* Index90 */
		trans1_switch_1_value_d_status_quality,
		trans1_switch_1_value_d_status_limit,
		trans1_switch_1_target	(READ_ONLY)	/* Index91 */
	}
}

MENU Group_m_trans1_switch_2
{
	LABEL	[switch_2];
	ITEMS
	{
		trans1_switch_2_value_d_value,		/* Index92 */
		trans1_switch_2_value_d_status_quality,
		trans1_switch_2_value_d_status_limit,
		trans1_switch_2_target	(READ_ONLY)	/* Index93 */	
	}
}

/* Device -> Query Device -> Transducer Block -> index94-101 [Maintenance] */
MENU Page_m_query_tb_4
{
	LABEL	[query_tb_4];
	ITEMS
	{
		trans1_signal_lock		(READ_ONLY),/* Index94 */
//		trans1_alarm_perform	(READ_ONLY),/* Index95 */
		trans1_alarm_perform_1	(READ_ONLY),/* Index95 */
		trans1_alarm_perform_2	(READ_ONLY),
		
#ifdef _PDM_
		SEPARATOR,
#endif
		trans1_simulate_mode						(READ_ONLY),/* Index96 */
		trans1_simulate_type						(READ_ONLY),/* Index97 */
		trans1_simulate_volume_flow_value			(READ_ONLY),/* Index98 */
		trans1_simulate_volume_flow_status_quality	(READ_ONLY),
		trans1_simulate_volume_flow_status_limit	(READ_ONLY),
		trans1_simulate_up_value					(READ_ONLY),/* Index99 */
		trans1_simulate_lo_value					(READ_ONLY),/* Index100 */
		trans1_simulate_time						(READ_ONLY)	/* Index101 */
	}
}

/* Device -> Query Device -> Transducer Block -> index102-127 [Maintenance] */
MENU Page_m_query_tb_5
{
	LABEL	[query_tb_5];
	ITEMS
	{
		trans1_operation_time,				/* Index102 */
		trans1_alm_record_1,				/* Index103 */
		trans1_alm_record_time_1,			/* Index104 */
		trans1_alm_record_2,				/* Index105 */
		trans1_alm_record_time_2,			/* Index106 */
		trans1_alm_record_3,				/* Index107 */
		trans1_alm_record_time_3,			/* Index108 */
		trans1_alm_record_4,				/* Index109 */
		trans1_alm_record_time_4,			/* Index110 */
		trans1_diplay_select1,				/* Index111 */
		trans1_diplay_select2,				/* Index112 */
		trans1_diplay_select3,				/* Index113 */
		trans1_diplay_cycle,				/* Index114 */
#ifdef _PDM_
		SEPARATOR,
#endif
		trans1_language,					/* Index115 */
		trans1_rate_limit		(READ_ONLY),/* Index116 */
		trans1_dead_time		(READ_ONLY),/* Index117 */
		trans1_pulsing_flow		(READ_ONLY),/* Index118 */
		trans1_power_synch		(READ_ONLY),/* Index119 */
		trans1_power_frequency	(READ_ONLY),/* Index120 */
		
		trans1_software_rev_no,				/* Index121 */
		trans1_adhesion_check	(READ_ONLY),/* Index122 */
		trans1_adhesion_level_1	(READ_ONLY),/* Index123 */
		trans1_adhesion_level_2	(READ_ONLY),/* Index124 */
		trans1_adhesion_level_3	(READ_ONLY),/* Index125 */
		trans1_adhesion_level_4	(READ_ONLY),/* Index126 */
		trans1_adh_measure_value			/* Index127 */
	}
}


/* Device -> Query Device -> Analog Input [Maintenance] */
MENU OnlineDialog_m_query_ai
{
	LABEL	FUNC1_TITLE;
	ITEMS
	{
		Page_m_query_ai_1,
		Page_m_query_ai_2,
		Page_m_query_ai_3,
		Page_m_query_ai_4
	}
}

/* Device -> Query Device -> Analog Input index16-22 [Maintenance] */
MENU Page_m_query_ai_1
{
	LABEL	[query_ai_1];
	ITEMS
	{
		func1_AI_blk_reserve,				/* Index16 */
		func1_AI_blk_object,
		func1_AI_blk_parent_class,
		func1_AI_blk_class,
		func1_AI_blk_dd_reference,
		func1_AI_blk_dd_rev,
		func1_AI_blk_profile,
		func1_AI_blk_profile_rev,
		func1_AI_blk_execution_time,
		func1_AI_blk_num_parameters,
		func1_AI_blk_index_view_1,
		func1_AI_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		func1_AI_st_rev,					/* Index17 */
		func1_AI_tag_desc	(READ_ONLY),	/* Index18 */
		func1_AI_strategy	(READ_ONLY),	/* Index19 */
		func1_AI_alert_key	(READ_ONLY),	/* Index20 */
		func1_AI_target_mode(READ_ONLY),	/* Index21 */
		func1_AI_actual_mode,				/* Index22 */
		func1_AI_permitted_mode,			
		func1_AI_normal_mode,				
	}
}

/* Device -> Query Device -> Analog Input index23-28 [Maintenance] */
MENU Page_m_query_ai_2
{
	LABEL	[query_ai_2];
	ITEMS
	{
		func1_AI_current_state_alarm_sum,	/* Index23 */
		func1_AI_unacknowledged_state_alarm_sum,
		func1_AI_unreported_state_alarm_sum,
		func1_AI_disabled_state_alarm_sum,
#ifdef _PDM_
		SEPARATOR,
#endif
		func1_AI_batch_id,					/* Index24 */
		func1_AI_batch_unit,
		func1_AI_batch_operation,
		func1_AI_batch_phase,
		Group_m_func1_ai_out,				/* Index26 */
		Group_m_func1_ai_pv_scale,			/* Index27 */
		Group_m_func1_ai_out_scale,			/* Index28 */
	}
}

MENU Group_m_func1_ai_out
{
	LABEL	[func_out_value];
	ITEMS
	{
		func1_AI_out_value,
		func1_AI_out_status_quality,
		func1_AI_out_status_limit,
	}
}

MENU Group_m_func1_ai_pv_scale
{
	LABEL	[menu_input_measwindow];
	ITEMS
	{
		func1_AI_pv_upper_range_value	(READ_ONLY),
		func1_AI_pv_lower_range_value	(READ_ONLY)
	}
}


MENU Group_m_func1_ai_out_scale
{
	LABEL	[menu_output_scalewindow];
	ITEMS
	{
		func1_AI_out_upper_range_value	(READ_ONLY),
		func1_AI_out_lower_range_value	(READ_ONLY),
		func1_AI_out_unit				(READ_ONLY),
		func1_AI_out_decimal_point		(READ_ONLY)
	}
}

/* Device -> Query Device -> Analog Input index29-49 [Maintenance] */
MENU Page_m_query_ai_3
{
	LABEL	[query_ai_3];
	ITEMS
	{
		func1_AI_lin_type	(READ_ONLY),	/* Index29 */
		func1_AI_channel	(READ_ONLY),	/* Index30 */
		func1_AI_pv_ftime	(READ_ONLY),	/* Index32 */
		func1_AI_FSafeType	(READ_ONLY),	/* Index33 */
		func1_AI_FSafeValue,				/* Index34 */
		func1_AI_alarm_hys	(READ_ONLY),	/* Index35 */
		func1_AI_hi_hi_lim	(READ_ONLY),	/* Index37 */
		func1_AI_hi_lim		(READ_ONLY),	/* Index39 */
		func1_AI_lo_lim		(READ_ONLY),	/* Index41 */
		func1_AI_lo_lo_lim	(READ_ONLY),	/* Index43 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_m_func1_ai_hi_hi_alm,			/* Index46 */
		Group_m_func1_ai_hi_alm,			/* Index47 */
		Group_m_func1_ai_lo_alm,			/* Index48 */
		Group_m_func1_ai_lo_lo_alm,			/* Index49 */
	}
}

MENU Group_m_func1_ai_hi_hi_alm
{
	LABEL	[limit_hi_hi];
	ITEMS
	{
		func1_AI_hi_hi_alm_unacknowledged,
		func1_AI_hi_hi_alm_state,
		func1_AI_hi_hi_alm_time_stamp,
		func1_AI_hi_hi_alm_subcode,
		func1_AI_hi_hi_alm_value
	}
}


MENU Group_m_func1_ai_hi_alm
{
	LABEL	[limit_hi];
	ITEMS
	{
		func1_AI_hi_alm_unacknowledged,
		func1_AI_hi_alm_state,
		func1_AI_hi_alm_time_stamp,
		func1_AI_hi_alm_subcode,
		func1_AI_hi_alm_value
	}
}

MENU Group_m_func1_ai_lo_alm
{
	LABEL	[limit_lo];
	ITEMS
	{
		func1_AI_lo_alm_unacknowledged,
		func1_AI_lo_alm_state,
		func1_AI_lo_alm_time_stamp,
		func1_AI_lo_alm_subcode,
		func1_AI_lo_alm_value
	}
}


MENU Group_m_func1_ai_lo_lo_alm
{
	LABEL	[limit_lo_lo];
	ITEMS
	{
		func1_AI_lo_lo_alm_unacknowledged,
		func1_AI_lo_lo_alm_state,
		func1_AI_lo_lo_alm_time_stamp,
		func1_AI_lo_lo_alm_subcode,
		func1_AI_lo_lo_alm_value
	}
}

/* Device -> Query Device -> Analog Input index50- [Maintenance] */
MENU Page_m_query_ai_4
{
	LABEL	[query_ai_4];
	ITEMS
	{
		Group_m_func1_ai_simulate,			/* Index50 */
		func1_AI_out_unit_text	(READ_ONLY),/* Index52 */
		func1_AI_velocity_check				/* Index61 */
	}
}

MENU Group_m_func1_ai_simulate
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func1_AI_simulate_status_quality	(READ_ONLY),
		func1_AI_simulate_status_limit		(READ_ONLY),
		func1_AI_simulate_value				(READ_ONLY),
		func1_AI_simulation_enabled			(READ_ONLY)
	}
}


/* Device -> Query Device -> Totilizer1 [Maintenance] */
MENU OnlineDialog_m_query_tot1
{
	LABEL	FUNC2_TITLE;
	ITEMS
	{
		Page_m_query_tot1_1,
		Page_m_query_tot1_2,
		Page_m_query_tot1_3
	}
}

/* Device -> Query Device -> Totilizer1 -> index16-22 [Maintenance] */
MENU Page_m_query_tot1_1
{
	LABEL	[query_tot_1];
	ITEMS
	{
		func2_TOT_blk_reserve,				/* Index16 */
		func2_TOT_blk_object,
		func2_TOT_blk_parent_class,
		func2_TOT_blk_class,
		func2_TOT_blk_dd_reference,
		func2_TOT_blk_dd_rev,
		func2_TOT_blk_profile,
		func2_TOT_blk_profile_rev,
		func2_TOT_blk_execution_time,
		func2_TOT_blk_num_parameters,
		func2_TOT_blk_index_view_1,
		func2_TOT_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		func2_TOT_st_rev,					/* Index17 */
		func2_TOT_tag_desc		(READ_ONLY),/* Index18 */
		func2_TOT_strategy		(READ_ONLY),/* Index19 */
		func2_TOT_alert_key		(READ_ONLY),/* Index20 */
		func2_TOT_target_mode	(READ_ONLY),/* Index21 */
		func2_TOT_actual_mode,				/* Index22 */
		func2_TOT_permitted_mode,
		func2_TOT_normal_mode
	}
}

/* Device -> Query Device -> Totilizer1 -> index23-29 [Maintenance] */
MENU Page_m_query_tot1_2
{
	LABEL	[query_tot_2];
	ITEMS
	{
		func2_TOT_current_state_alarm_sum,	/* Index23 */
		func2_TOT_unacknowledged_state_alarm_sum,
		func2_TOT_unreported_state_alarm_sum,
		func2_TOT_disabled_state_alarm_sum,
#ifdef _PDM_
		SEPARATOR,
#endif
		func2_TOT_batch_id,					/* Index24 */
		func2_TOT_batch_unit,
		func2_TOT_batch_operation,
		func2_TOT_batch_phase,
		func2_TOT_total_value,				/* Index26 */
		func2_TOT_total_status_quality,
		func2_TOT_total_status_limit,
		func2_TOT_unit_tot	(READ_ONLY),	/* Index27 */
		func2_TOT_channel	(READ_ONLY),	/* Index28 */
		func2_TOT_set_tot	(READ_ONLY),	/* Index29 */
	}
}

/* Device -> Query Device -> Totilizer1 -> index30 [Maintenance] */
MENU Page_m_query_tot1_3
{
	LABEL	[query_tot_3];
	ITEMS
	{
		func2_TOT_mode_tot	(READ_ONLY),			/* Index30 */
		func2_TOT_fail_tot	(READ_ONLY),			/* Index31 */
		func2_TOT_preset_tot(READ_ONLY),			/* Index32 */
		func2_TOT_alarm_hys,						/* Index33*/
		func2_TOT_hi_hi_lim,						/* Index34 */
		func2_TOT_hi_lim ,							/* Index35 */
		func2_TOT_lo_lim,							/* Index36 */
		func2_TOT_lo_lo_lim,						/* Index37 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_m_func2_tot_hi_hi_alm,				/* Index38 */
		Group_m_func2_tot_hi_alm,					/* Index39 */
		Group_m_func2_tot_lo_alm,					/* Index40 */
		Group_m_func2_tot_lo_lo_alm,				/* Index41 */
		func2_TOT_simulation_enabled	(READ_ONLY),/* Index52 */
		Group_m_simulate_input_func2
	}
}

MENU Group_m_func2_tot_hi_hi_alm
{
	LABEL	[limit_hi_hi];
	ITEMS
	{
		func2_TOT_hi_hi_alm_unacknowledged,
		func2_TOT_hi_hi_alm_state,
		func2_TOT_hi_hi_alm_time_stamp,
		func2_TOT_hi_hi_alm_subcode,
		
		func2_TOT_hi_hi_alm_value
	}
}

MENU Group_m_func2_tot_hi_alm
{
	LABEL	[limit_hi];
	ITEMS
	{
		func2_TOT_hi_alm_unacknowledged,
		func2_TOT_hi_alm_state,
		func2_TOT_hi_alm_time_stamp,
		func2_TOT_hi_alm_subcode,
		
		func2_TOT_hi_alm_value
	}
}

MENU Group_m_func2_tot_lo_alm
{
	LABEL	[limit_lo];
	ITEMS
	{
		func2_TOT_lo_alm_unacknowledged,
		func2_TOT_lo_alm_state,
		func2_TOT_lo_alm_time_stamp,
		func2_TOT_lo_alm_subcode,
		
		func2_TOT_lo_alm_value
	}
}

MENU Group_m_func2_tot_lo_lo_alm
{
	LABEL	[limit_lo_lo];
	ITEMS
	{
		func2_TOT_lo_lo_alm_unacknowledged,
		func2_TOT_lo_lo_alm_state,
		func2_TOT_lo_lo_alm_time_stamp,
		func2_TOT_lo_lo_alm_subcode,
		
		func2_TOT_lo_lo_alm_value
	}
}

MENU Group_m_simulate_input_func2
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func2_TOT_simulate_value			(READ_ONLY),
		SEPARATOR,
		func2_TOT_simulate_status_quality	(READ_ONLY),
		func2_TOT_simulate_status_limit		(READ_ONLY)
	}
}

/* Device -> Query Device -> Totilizer2 [Maintenance] */
MENU OnlineDialog_m_query_tot2
{
	LABEL	FUNC3_TITLE;
	ITEMS
	{
		Page_m_query_tot2_1,
		Page_m_query_tot2_2,
		Page_m_query_tot2_3
	}
}

/* Device -> Query Device -> Totilizer2 -> index16-22 [Maintenance] */
MENU Page_m_query_tot2_1
{
	LABEL	[query_tot_1];
	ITEMS
	{
		func3_TOT_blk_reserve,				/* Index16 */
		func3_TOT_blk_object,
		func3_TOT_blk_parent_class,
		func3_TOT_blk_class,
		func3_TOT_blk_dd_reference,
		func3_TOT_blk_dd_rev,
		func3_TOT_blk_profile,
		func3_TOT_blk_profile_rev,
		func3_TOT_blk_execution_time,
		func3_TOT_blk_num_parameters,
		func3_TOT_blk_index_view_1,
		func3_TOT_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		func3_TOT_st_rev,					/* Index17 */
		func3_TOT_tag_desc		(READ_ONLY),/* Index18 */
		func3_TOT_strategy		(READ_ONLY),/* Index19 */
		func3_TOT_alert_key		(READ_ONLY),/* Index20 */
		func3_TOT_target_mode	(READ_ONLY),/* Index21 */
		func3_TOT_actual_mode,				/* Index22 */
		func3_TOT_permitted_mode,
		func3_TOT_normal_mode
	}
}

/* Device -> Query Device -> Totilizer2 -> index23-29 [Maintenance] */
MENU Page_m_query_tot2_2
{
	LABEL	[query_tot_2];
	ITEMS
	{
		func3_TOT_current_state_alarm_sum,	/* Index23 */
		func3_TOT_unacknowledged_state_alarm_sum,
		func3_TOT_unreported_state_alarm_sum,
		func3_TOT_disabled_state_alarm_sum,
#ifdef _PDM_
		SEPARATOR,
#endif
		func3_TOT_batch_id,					/* Index24 */
		func3_TOT_batch_unit,
		func3_TOT_batch_operation,
		func3_TOT_batch_phase,
		func3_TOT_total_value,				/* Index26 */
		func3_TOT_total_status_quality,
		func3_TOT_total_status_limit,
		func3_TOT_unit_tot	(READ_ONLY),	/* Index27 */
		func3_TOT_channel	(READ_ONLY),	/* Index28 */
		func3_TOT_set_tot	(READ_ONLY),	/* Index29 */
	}
}

/* Device -> Query Device -> Totilizer2 -> index30 [Maintenance] */
MENU Page_m_query_tot2_3
{
	LABEL	[query_tot_3];
	ITEMS
	{
		func3_TOT_mode_tot	(READ_ONLY),		/* Index30 */
		func3_TOT_fail_tot	(READ_ONLY),		/* Index31 */
		func3_TOT_preset_tot(READ_ONLY),		/* Index32 */
		func3_TOT_alarm_hys,					/* Index33*/
		func3_TOT_hi_hi_lim,					/* Index34 */
		func3_TOT_hi_lim ,						/* Index35 */
		func3_TOT_lo_lim,						/* Index36 */
		func3_TOT_lo_lo_lim,					/* Index37 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_m_func3_tot_hi_hi_alm,			/* Index38 */
		Group_m_func3_tot_hi_alm,				/* Index39 */
		Group_m_func3_tot_lo_alm,				/* Index40 */
		Group_m_func3_tot_lo_lo_alm,			/* Index41 */
		func3_TOT_simulation_enabled(READ_ONLY),/* Index52 */
		Group_m_simulate_input_func3
	}
}

MENU Group_m_func3_tot_hi_hi_alm
{
	LABEL	[limit_hi_hi];
	ITEMS
	{
		func3_TOT_hi_hi_alm_unacknowledged,
		func3_TOT_hi_hi_alm_state,
		func3_TOT_hi_hi_alm_time_stamp,
		func3_TOT_hi_hi_alm_subcode,
		
		func3_TOT_hi_hi_alm_value
	}
}

MENU Group_m_func3_tot_hi_alm
{
	LABEL	[limit_hi];
	ITEMS
	{
		func3_TOT_hi_alm_unacknowledged,
		func3_TOT_hi_alm_state,
		func3_TOT_hi_alm_time_stamp,
		func3_TOT_hi_alm_subcode,
		
		func3_TOT_hi_alm_value
	}
}

MENU Group_m_func3_tot_lo_alm
{
	LABEL	[limit_lo];
	ITEMS
	{
		func3_TOT_lo_alm_unacknowledged,
		func3_TOT_lo_alm_state,
		func3_TOT_lo_alm_time_stamp,
		func3_TOT_lo_alm_subcode,
		
		func3_TOT_lo_alm_value
	}
}

MENU Group_m_func3_tot_lo_lo_alm
{
	LABEL	[limit_lo_lo];
	ITEMS
	{
		func3_TOT_lo_lo_alm_unacknowledged,
		func3_TOT_lo_lo_alm_state,
		func3_TOT_lo_lo_alm_time_stamp,
		func3_TOT_lo_lo_alm_subcode,
		
		func3_TOT_lo_lo_alm_value
	}
}

MENU Group_m_simulate_input_func3
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func3_TOT_simulate_value			(READ_ONLY),
		SEPARATOR,
		func3_TOT_simulate_status_quality	(READ_ONLY),
		func3_TOT_simulate_status_limit		(READ_ONLY)
	}
}

/* Device -> Query Device -> Totilizer3 [Maintenance] */
MENU OnlineDialog_m_query_tot3
{
	LABEL	FUNC4_TITLE;
	ITEMS
	{
		Page_m_query_tot3_1,
		Page_m_query_tot3_2,
		Page_m_query_tot3_3
	}
}

/* Device -> Query Device -> Totilizer3 -> index16-22 [Maintenance] */
MENU Page_m_query_tot3_1
{
	LABEL	[query_tot_1];
	ITEMS
	{
		func4_TOT_blk_reserve,				/* Index16 */
		func4_TOT_blk_object,
		func4_TOT_blk_parent_class,
		func4_TOT_blk_class,
		func4_TOT_blk_dd_reference,
		func4_TOT_blk_dd_rev,
		func4_TOT_blk_profile,
		func4_TOT_blk_profile_rev,
		func4_TOT_blk_execution_time,
		func4_TOT_blk_num_parameters,
		func4_TOT_blk_index_view_1,
		func4_TOT_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		func4_TOT_st_rev,					/* Index17 */
		func4_TOT_tag_desc		(READ_ONLY),/* Index18 */
		func4_TOT_strategy		(READ_ONLY),/* Index19 */
		func4_TOT_alert_key		(READ_ONLY),/* Index20 */
		func4_TOT_target_mode	(READ_ONLY),/* Index21 */
		func4_TOT_actual_mode,				/* Index22 */
		func4_TOT_permitted_mode,
		func4_TOT_normal_mode
	}
}

/* Device -> Query Device -> Totilizer3 -> index23-29 [Maintenance] */
MENU Page_m_query_tot3_2
{
	LABEL	[query_tot_2];
	ITEMS
	{
		func4_TOT_current_state_alarm_sum,	/* Index23 */
		func4_TOT_unacknowledged_state_alarm_sum,
		func4_TOT_unreported_state_alarm_sum,
		func4_TOT_disabled_state_alarm_sum,
#ifdef _PDM_
		SEPARATOR,
#endif
		func4_TOT_batch_id,					/* Index24 */
		func4_TOT_batch_unit,
		func4_TOT_batch_operation,
		func4_TOT_batch_phase,
		func4_TOT_total_value,				/* Index26 */
		func4_TOT_total_status_quality,
		func4_TOT_total_status_limit,
		func4_TOT_unit_tot	(READ_ONLY),	/* Index27 */
		func4_TOT_channel	(READ_ONLY),	/* Index28 */
		func4_TOT_set_tot	(READ_ONLY),	/* Index29 */
	}
}

/* Device -> Query Device -> Totilizer3 -> index30 [Maintenance] */
MENU Page_m_query_tot3_3
{
	LABEL	[query_tot_3];
	ITEMS
	{
		func4_TOT_mode_tot	(READ_ONLY),		/* Index30 */
		func4_TOT_fail_tot	(READ_ONLY),		/* Index31 */
		func4_TOT_preset_tot(READ_ONLY),		/* Index32 */
		func4_TOT_alarm_hys,					/* Index33*/
		func4_TOT_hi_hi_lim,					/* Index34 */
		func4_TOT_hi_lim ,						/* Index35 */
		func4_TOT_lo_lim,						/* Index36 */
		func4_TOT_lo_lo_lim,					/* Index37 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_m_func4_tot_hi_hi_alm,			/* Index38 */
		Group_m_func4_tot_hi_alm,				/* Index39 */
		Group_m_func4_tot_lo_alm,				/* Index40 */
		Group_m_func4_tot_lo_lo_alm,			/* Index41 */
		func4_TOT_simulation_enabled(READ_ONLY),/* Index52 */
		Group_m_simulate_input_func4
	}
}

MENU Group_m_func4_tot_hi_hi_alm
{
	LABEL	[limit_hi_hi];
	ITEMS
	{
		func4_TOT_hi_hi_alm_unacknowledged,
		func4_TOT_hi_hi_alm_state,
		func4_TOT_hi_hi_alm_time_stamp,
		func4_TOT_hi_hi_alm_subcode,
		
		func4_TOT_hi_hi_alm_value
	}
}

MENU Group_m_func4_tot_hi_alm
{
	LABEL	[limit_hi];
	ITEMS
	{
		func4_TOT_hi_alm_unacknowledged,
		func4_TOT_hi_alm_state,
		func4_TOT_hi_alm_time_stamp,
		func4_TOT_hi_alm_subcode,
		
		func4_TOT_hi_alm_value
	}
}

MENU Group_m_func4_tot_lo_alm
{
	LABEL	[limit_lo];
	ITEMS
	{
		func4_TOT_lo_alm_unacknowledged,
		func4_TOT_lo_alm_state,
		func4_TOT_lo_alm_time_stamp,
		func4_TOT_lo_alm_subcode,
		
		func4_TOT_lo_alm_value
	}
}

MENU Group_m_func4_tot_lo_lo_alm
{
	LABEL	[limit_lo_lo];
	ITEMS
	{
		func4_TOT_lo_lo_alm_unacknowledged,
		func4_TOT_lo_lo_alm_state,
		func4_TOT_lo_lo_alm_time_stamp,
		func4_TOT_lo_lo_alm_subcode,
		
		func4_TOT_lo_lo_alm_value
	}
}

MENU Group_m_simulate_input_func4
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func4_TOT_simulate_value			(READ_ONLY),
		SEPARATOR,
		func4_TOT_simulate_status_quality	(READ_ONLY),
		func4_TOT_simulate_status_limit		(READ_ONLY)
	}
}

/* Device -> Query Device -> Discrete Input1 [Maintenance] */
MENU OnlineDialog_m_query_di1
{
	LABEL	FUNC5_TITLE;
	ITEMS
	{
		Page_m_query_di1_1,
		Page_m_query_di1_2
	}
}

/* Device -> Query Device -> Discrete Input1 -> index16-23 [Maintenance] */
MENU Page_m_query_di1_1
{
	LABEL	[query_di_1];
	ITEMS
	{
		func5_DI_blk_reserve,				/* Index16 */
		func5_DI_blk_object,
		func5_DI_blk_parent_class,
		func5_DI_blk_class,
		func5_DI_blk_dd_reference,
		func5_DI_blk_dd_rev,
		func5_DI_blk_profile,
		func5_DI_blk_profile_rev,
		func5_DI_blk_execution_time,
		func5_DI_blk_num_parameters,
		func5_DI_blk_index_view_1,
		func5_DI_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		func5_DI_st_rev,					/* Index17 */
		func5_DI_tag_desc	(READ_ONLY),	/* Index18 */
		func5_DI_strategy	(READ_ONLY),	/* Index19 */
		func5_DI_alert_key	(READ_ONLY),	/* Index20 */
		func5_DI_target_mode(READ_ONLY),	/* Index21 */
		func5_DI_actual_mode,				/* Index22 */
		func5_DI_permitted_mode,
		func5_DI_normal_mode
		func5_DI_current_state_alarm_sum,	/* Index23 */
		func5_DI_unacknowledged_state_alarm_sum,
		func5_DI_unreported_state_alarm_sum,
		func5_DI_disabled_state_alarm_sum
	}
}

/* Device -> Query Device -> Discrete Input1 -> index24- [Maintenance] */
MENU Page_m_query_di1_2
{
	LABEL	[query_di_2];
	ITEMS
	{
		func5_DI_batch_id,					/* Index24 */
		func5_DI_batch_unit,
		func5_DI_batch_operation,
		func5_DI_batch_phase,
		func5_DI_out_value,					/* Index26 */
		func5_DI_out_status_quality,
		func5_DI_out_status_limit,
		func5_DI_channel	(READ_ONLY),	/* Index30 */
		func5_DI_invert		(READ_ONLY),	/* Index31 */
		func5_DI_fsafe_type	(READ_ONLY),	/* Index36 */
		func5_DI_fsafe_value(READ_ONLY),	/* Index37 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_m_func5_di_simulate			/* Index40 */
	}
}


MENU Group_m_func5_di_simulate
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func5_DI_simulate_status_quality(READ_ONLY),
		func5_DI_simulate_status_limit	(READ_ONLY),
		func5_DI_simulate_value			(READ_ONLY),
		func5_DI_simulation_enabled		(READ_ONLY)
	}
}


/* Device -> Query Device -> Discrete Input2 [Maintenance] */
MENU OnlineDialog_m_query_di2
{
	LABEL	FUNC6_TITLE;
	ITEMS
	{
		Page_m_query_di2_1,
		Page_m_query_di2_2
	}
}

/* Device -> Query Device -> Discrete Input2 -> index16-23 [Maintenance] */
MENU Page_m_query_di2_1
{
	LABEL	[query_di_1];
	ITEMS
	{
		func6_DI_blk_reserve,				/* Index16 */
		func6_DI_blk_object,
		func6_DI_blk_parent_class,
		func6_DI_blk_class,
		func6_DI_blk_dd_reference,
		func6_DI_blk_dd_rev,
		func6_DI_blk_profile,
		func6_DI_blk_profile_rev,
		func6_DI_blk_execution_time,
		func6_DI_blk_num_parameters,
		func6_DI_blk_index_view_1,
		func6_DI_blk_num_view_lists,
#ifdef _PDM_
		SEPARATOR,
#endif
		func6_DI_st_rev,					/* Index17 */
		func6_DI_tag_desc	(READ_ONLY),	/* Index18 */
		func6_DI_strategy	(READ_ONLY),	/* Index19 */
		func6_DI_alert_key	(READ_ONLY),	/* Index20 */
		func6_DI_target_mode(READ_ONLY),	/* Index21 */
		func6_DI_actual_mode,				/* Index22 */
		func6_DI_permitted_mode,
		func6_DI_normal_mode
		func6_DI_current_state_alarm_sum,	/* Index23 */
		func6_DI_unacknowledged_state_alarm_sum,
		func6_DI_unreported_state_alarm_sum,
		func6_DI_disabled_state_alarm_sum
	}
}

/* Device -> Query Device -> Discrete Input2 -> index24- [Maintenance] */
MENU Page_m_query_di2_2
{
	LABEL	[query_di_2];
	ITEMS
	{
		func6_DI_batch_id,					/* Index24 */
		func6_DI_batch_unit,
		func6_DI_batch_operation,
		func6_DI_batch_phase,
		func6_DI_out_value,					/* Index26 */
		func6_DI_out_status_quality,
		func6_DI_out_status_limit,
		func6_DI_channel	(READ_ONLY),	/* Index30 */
		func6_DI_invert		(READ_ONLY),	/* Index31 */
		func6_DI_fsafe_type	(READ_ONLY),	/* Index36 */
		func6_DI_fsafe_value(READ_ONLY),	/* Index37 */
#ifdef _PDM_
		SEPARATOR,
#endif
		Group_m_func6_di_simulate			/* Index40 */
	}
}


MENU Group_m_func6_di_simulate
{
	LABEL		[func_simulate_value];
	ITEMS
	{
		func6_DI_simulate_status_quality(READ_ONLY),
		func6_DI_simulate_status_limit	(READ_ONLY),
		func6_DI_simulate_value			(READ_ONLY),
		func6_DI_simulation_enabled		(READ_ONLY)
	}
}


/**************************************************************************************/
/*****	MENU for AXF AI ***************************************************************/
/**************************************************************************************/
MENU Tab_func1_velocity_check
{
	LABEL "Velocity Check";
	ITEMS
	{
		func1_AI_velocity_check
	}
	
}


/*******************************************************************************/
/*********  REDEFINE ************ **********************************************/
/*******************************************************************************/
IMPORT "YEC_AXF0101PA_import.inc"
{
	EVERYTHING;


	REDEFINITIONS
	{
		/*********************************************************************/
		/********************** REDEFINE for VARIABLE  ***********************/
		/*********************************************************************/
	#ifndef _V600_
		/* PB PROFILE_REV */
		VARIABLE phys_blk_profile_rev
		{
			REDEFINE TYPE		ENUMERATED (2)
			{
		#ifdef CHECK_PROFILE_REV
				DEFAULT_VALUE	CHECK_PROFILE_REV ;
		#else
				DEFAULT_VALUE	0x0300;
		#endif
				{	0x025A,	"2.90"	},
				{	0x025B,	"2.91"	},
				{	0x025C,	"2.92"	},
				{	0x025D,	"2.93"	},
				{	0x025E,	"2.94"	},
				{	0x025F,	"2.95"	},
				{	0x0260,	"2.96"	},
				{	0x0261,	"2.97"	},
				{	0x0262,	"2.98"	},
				{	0x0263,	"2.99"	},
				{	0x0300,	"3.0"	},
				{	0x0301,	"3.01"	}

			}
		}
	#endif
		
		/* TB PROFILE_REV */
		VARIABLE trans1_blk_profile_rev
		{
			REDEFINE TYPE		ENUMERATED (2)
			{
		#ifdef PROFILE_REV
				DEFAULT_VALUE PROFILE_REV ;
		#endif
				{	0x0200,	"2.0"	},
				{	0x025D,	"2.93"	},
				{	0x025F,	"2.95"	},
				{	0x0300,	"3.0"	},
				{	0x0301,	"3.01"	}
			}
		}
		
		/* AI PROFILE_REV */
		VARIABLE func1_AI_blk_profile_rev
		{
			REDEFINE TYPE		ENUMERATED (2)
			{
		#ifdef CHECK_PROFILE_REV
				DEFAULT_VALUE	CHECK_PROFILE_REV ;
		#else
				DEFAULT_VALUE	0x0300;
		#endif
				{	0x025A,	"2.90"	},
				{	0x025B,	"2.91"	},
				{	0x025C,	"2.92"	},
				{	0x025D,	"2.93"	},
				{	0x025E,	"2.94"	},
				{	0x025F,	"2.95"	},
				{	0x0260,	"2.96"	},
				{	0x0261,	"2.97"	},
				{	0x0262,	"2.98"	},
				{	0x0263,	"2.99"	},
				{	0x0300,	"3.0"	},
				{	0x0301,	"3.01"	}
			}
		}
		
		/* TOT1 PROFILE_REV */
		VARIABLE func2_TOT_blk_profile_rev
		{
			REDEFINE TYPE		ENUMERATED (2)
			{
		#ifdef CHECK_PROFILE_REV
				DEFAULT_VALUE	CHECK_PROFILE_REV ;
		#else
				DEFAULT_VALUE	0x0300;
		#endif
				{	0x025A,	"2.90"	},
				{	0x025B,	"2.91"	},
				{	0x025C,	"2.92"	},
				{	0x025D,	"2.93"	},
				{	0x025E,	"2.94"	},
				{	0x025F,	"2.95"	},
				{	0x0260,	"2.96"	},
				{	0x0261,	"2.97"	},
				{	0x0262,	"2.98"	},
				{	0x0263,	"2.99"	},
				{	0x0300,	"3.0"	},
				{	0x0301,	"3.01"	}
			}
		}
		
		/* TOT2 PROFILE_REV */
		VARIABLE func3_TOT_blk_profile_rev
		{
			REDEFINE TYPE		ENUMERATED (2)
			{
		#ifdef CHECK_PROFILE_REV
				DEFAULT_VALUE	CHECK_PROFILE_REV ;
		#else
				DEFAULT_VALUE	0x0300;
		#endif
				{	0x025A,	"2.90"	},
				{	0x025B,	"2.91"	},
				{	0x025C,	"2.92"	},
				{	0x025D,	"2.93"	},
				{	0x025E,	"2.94"	},
				{	0x025F,	"2.95"	},
				{	0x0260,	"2.96"	},
				{	0x0261,	"2.97"	},
				{	0x0262,	"2.98"	},
				{	0x0263,	"2.99"	},
				{	0x0300,	"3.0"	},
				{	0x0301,	"3.01"	}
			}
		}
		
		/* TOT3 PROFILE_REV */
		VARIABLE func4_TOT_blk_profile_rev
		{
			REDEFINE TYPE		ENUMERATED (2)
			{
		#ifdef CHECK_PROFILE_REV
				DEFAULT_VALUE	CHECK_PROFILE_REV ;
		#else
				DEFAULT_VALUE	0x0300;
		#endif
				{	0x025A,	"2.90"	},
				{	0x025B,	"2.91"	},
				{	0x025C,	"2.92"	},
				{	0x025D,	"2.93"	},
				{	0x025E,	"2.94"	},
				{	0x025F,	"2.95"	},
				{	0x0260,	"2.96"	},
				{	0x0261,	"2.97"	},
				{	0x0262,	"2.98"	},
				{	0x0263,	"2.99"	},
				{	0x0300,	"3.0"	},
				{	0x0301,	"3.01"	}
			}
		}
		
		/* TB TARGET_MODE */
		VARIABLE trans1_target_mode
		{
			REDEFINE TYPE		ENUMERATED (1)
			{
				DEFAULT_VALUE	0x08;
				{ 0x08, [mode_AUTO]           },
				{ 0x80, [mode_OUT_OF_SERVICE] }
			}
		}
		
		/* PB TARGET_MODE */
		VARIABLE phys_target_mode
		{
			REDEFINE TYPE		ENUMERATED (1)
			{
				DEFAULT_VALUE	0x08;
				{ 0x08, [mode_AUTO]           },
				{ 0x80, [mode_OUT_OF_SERVICE] }
			}
		}
		
		/* TB VOLUME_FLOW_UNIT */
		VARIABLE trans1_volume_flow_units
		{
			REDEFINE TYPE		ENUMERATED (2)
			{
				DEFAULT_VALUE 1349;
				AXFPA_TRANS_UNIT_LIST
			}
		}
		
		/* TB NOMINAL_SIZE */
		VARIABLE trans1_nominal_size_units
		{
			REDEFINE TYPE		ENUMERATED (2)
			{
				DEFAULT_VALUE	1013;			/* mm */
				{1013,	[unit_1013],       [unit_1013_help]},	/* mm */
				{1019,	[unit_1019],       [unit_1019_help]}	/* inch */
			}
		}
		
		/* AI LIN_TYPE */
		
		
		
		/* AI DECIMAL POINT */
		VARIABLE func1_AI_out_decimal_point
		{
			REDEFINE TYPE		ENUMERATED (1)
			{
				DEFAULT_VALUE	3;
				{	0,   "0"		},
				{	1,   "1"		},
				{	2,   "2"		},
				{	3,   "3"		},
				{	4,   "4"		},
				{	5,   "5"		},
				{	6,   "6"		},
				{	7,   "7"		}
			}
		}
		
		/* AI ALARM_HYS */
		VARIABLE func1_AI_alarm_hys
		{
			REDEFINE TYPE		FLOAT
			{
				// MIN_VALUE 0 ; problems with temperature units 
//				DEFAULT_VALUE (func1_AI_out_upper_range_value - func1_AI_out_lower_range_value) / 100 ;
				DEFAULT_VALUE ((func1_AI_out_upper_range_value - func1_AI_out_lower_range_value) / 100) * 0.5 ;
				MIN_VALUE     ((func1_AI_out_upper_range_value - func1_AI_out_lower_range_value) / 100) * 0.0 ;
				MAX_VALUE     ((func1_AI_out_upper_range_value - func1_AI_out_lower_range_value) / 100) * 50.0 ;
				DISPLAY_FORMAT DEF_DISPLAY_FORMAT_FUNC1_AI(func1_AI_alarm_hys);
			}
		}
		
		/* AI OUT_SCALE.EU100 */
		VARIABLE func1_AI_out_upper_range_value
		{
//			LABEL		[func_upper_value];
			REDEFINE LABEL		[func_out_scale_upper_value];
		}
		
		/* AI OUT_SCALE.EU0 */
		VARIABLE func1_AI_out_lower_range_value
		{
//			LABEL		[func_lower_value];
			REDEFINE LABEL		[func_out_scale_lower_value];
		}
		
		/* TOT1 ADRESS_OF_VIEW1 */
		VARIABLE func2_TOT_blk_index_view_1
		{
//			LABEL		[blk_num_parameters];
//			HELP		[blk_num_parameters_help];
			REDEFINE LABEL		[blk_index_view_1];
			REDEFINE HELP		[blk_index_view_1_help];
		}
		
		/* TOT2 ADRESS_OF_VIEW1 */
		VARIABLE func3_TOT_blk_index_view_1
		{
//			LABEL		[blk_num_parameters];
//			HELP		[blk_num_parameters_help];
			REDEFINE LABEL		[blk_index_view_1];
			REDEFINE HELP		[blk_index_view_1_help];
		}
		
		/* TOT3 ADRESS_OF_VIEW1 */
		VARIABLE func4_TOT_blk_index_view_1
		{
//			LABEL		[blk_num_parameters];
//			HELP		[blk_num_parameters_help];
			REDEFINE LABEL		[blk_index_view_1];
			REDEFINE HELP		[blk_index_view_1_help];
		}
		
		/* TOT1 PRESET_VALUE */
		VARIABLE func2_TOT_preset_tot
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE  0.0;
				MIN_VALUE -99999999;
				MAX_VALUE 99999999;
			}
		}
		
		/* TOT2 PRESET_VALUE */
		VARIABLE func3_TOT_preset_tot
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE  0.0;
				MIN_VALUE -99999999;
				MAX_VALUE 99999999;
			}
		}
		
		/* TOT3 PRESET_VALUE */
		VARIABLE func4_TOT_preset_tot
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE  0.0;
				MIN_VALUE -99999999;
				MAX_VALUE 99999999;
			}
		}
		
		/* TOT1 HI_HI_LIM */
		VARIABLE func2_TOT_hi_hi_lim
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE	DEFAULT_VALUE_func2_TOT_hi_hi_lim ;
//				DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC2_TOT
				DISPLAY_FORMAT	".6g";
			}
		}
		
		/* TOT1 HI_LIM */
		VARIABLE func2_TOT_hi_lim
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE	DEFAULT_VALUE_func2_TOT_hi_lim ;
//				DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC2_TOT
				DISPLAY_FORMAT	".6g";
			}
		}
		
		/* TOT1 LO_LIM */
		VARIABLE func2_TOT_lo_lim
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE	DEFAULT_VALUE_func2_TOT_lo_lim ;
//				DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC2_TOT
				DISPLAY_FORMAT	".6g";
			}
		}
		
		/* TOT1 LO_LO_LIM */
		VARIABLE func2_TOT_lo_lo_lim
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE	DEFAULT_VALUE_func2_TOT_lo_lo_lim ;
//				DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC2_TOT
				DISPLAY_FORMAT	".6g";
			}
		}
		
		/* TOT2 HI_HI_LIM */
		VARIABLE func3_TOT_hi_hi_lim
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE	DEFAULT_VALUE_func3_TOT_hi_hi_lim ;
//				DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC3_TOT
				DISPLAY_FORMAT	".6g";
			}
		}
		
		/* TOT2 HI_LIM */
		VARIABLE func3_TOT_hi_lim
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE	DEFAULT_VALUE_func3_TOT_hi_lim ;
//				DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC3_TOT
				DISPLAY_FORMAT	".6g";
			}
		}
		
		/* TOT2 LO_LIM */
		VARIABLE func3_TOT_lo_lim
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE	DEFAULT_VALUE_func3_TOT_lo_lim ;
//				DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC3_TOT
				DISPLAY_FORMAT	".6g";
			}
		}
		
		/* TOT2 LO_LO_LIM */
		VARIABLE func3_TOT_lo_lo_lim
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE	DEFAULT_VALUE_func3_TOT_lo_lo_lim ;
//				DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC3_TOT
				DISPLAY_FORMAT	".6g";
			}
		}
		
		/* TOT3 HI_HI_LIM */
		VARIABLE func4_TOT_hi_hi_lim
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE	DEFAULT_VALUE_func4_TOT_hi_hi_lim ;
//				DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC4_TOT
				DISPLAY_FORMAT	".6g";
			}
		}
		
		/* TOT3 HI_LIM */
		VARIABLE func4_TOT_hi_lim
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE	DEFAULT_VALUE_func4_TOT_hi_lim ;
//				DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC4_TOT
				DISPLAY_FORMAT	".6g";
			}
		}
		
		/* TOT3 LO_LIM */
		VARIABLE func4_TOT_lo_lim
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE	DEFAULT_VALUE_func4_TOT_lo_lim ;
//				DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC4_TOT
				DISPLAY_FORMAT	".6g";
			}
		}
		
		/* TOT3 LO_LO_LIM */
		VARIABLE func4_TOT_lo_lo_lim
		{
		REDEFINE TYPE		FLOAT
			{
				DEFAULT_VALUE	DEFAULT_VALUE_func4_TOT_lo_lo_lim ;
//				DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC4_TOT
				DISPLAY_FORMAT	".6g";
			}
		}
		
		/* TB CALIBR_FACTOR */
		VARIABLE trans1_calibration_factor
		{
			REDEFINE TYPE		FLOAT
			{   
				DEFAULT_VALUE   1.0;
//				MIN_VALUE		0.1;
//				MAX_VALUE		9.9;
				MIN_VALUE		0.01;
				MAX_VALUE		3.00;
				EDIT_FORMAT		"8.6f";
				DISPLAY_FORMAT	".6f";
			}
		}
		
		/* TB NOMINAL_SIZE */
		VARIABLE trans1_nominal_size
		{
			REDEFINE TYPE		FLOAT
			{   
//				DEFAULT_VALUE	0.02540;
				DEFAULT_VALUE	100;
				MIN_VALUE		0.01;
				MAX_VALUE		3000.10;
			}
		}
		
		/* TB BLOCK_OBJECT.Profile */
		VARIABLE trans1_blk_profile
		{
		//	TYPE				UNSIGNED_INTEGER (2)
			REDEFINE TYPE		ENUMERATED (2)
			{
				DEFAULT_VALUE	0x4001;
				{ 0x4001,	[blk_profile_PA_COMPACT_A]	},
				{ 0x4002,	[blk_profile_PA_COMPACT_B]	},
				{ 0x4081,	[blk_profile_PA_SIMPLE_A]	},
				{ 0x4082,	[blk_profile_PA_SIMPLE_B]	}
			}
		}
		
		/* TB MEASUREMENT_MODE */
		VARIABLE trans1_measurement_mode
		{
			REDEFINE TYPE		ENUMERATED (1)
			{
//				DEFAULT_VALUE 1 ;	// Profil: DEFAULT_VALUE	0 ;
				DEFAULT_VALUE 0;
				{   0,  [uni_directional]	},
				{	1,  [bi_directional]	}
			}
		}
		
		/* TB VOLUME_FLOW */
		VARIABLE trans1_volume_flow_value
		{
		//	LABEL				[trans_value];
			REDEFINE LABEL		[volume_flow];
		}
		
		/* TB VOLUME_FLOW_LO_LIMIT */
		VARIABLE trans1_volume_flow_lower_limit
		{
		//	LABEL				[trans_sensor_lower_limit];
			REDEFINE LABEL		[volume_flow_lower_limit];
		}
		
		/* TB VOLUME_FLOW_HI_LIMIT */
		VARIABLE trans1_volume_flow_upper_limit
		{
		//	LABEL				[trans_sensor_upper_limit];
			REDEFINE LABEL		[volume_flow_upper_limit];
		}
		
		
		/* AI LIN_TYPE */
		VARIABLE func1_AI_lin_type
		{
			REDEFINE TYPE		ENUMERATED (1)
			{
				DEFAULT_VALUE	0;
//				{ 0,	[linear]	}
				{ 0,	[no_linearisation]	}
			}
		}
		
		
		/*********************************************************************/
		/******************* REDEFINE for Parameter Table ********************/
		/*********************************************************************/
		
		/* Identification->Device (Maintenance) */
		MENU Tab_m_ident_device
		{
			REDEFINE ITEMS
			{
				phys_device_man_id,
				phys_device_id,
				phys_device_ser_num,
				phys_software_rev,
				phys_hardware_rev,
				phys_blk_profile_rev,
				phys_st_rev,
				phys_ident_number	(READ_ONLY),
				phys_install_date	(READ_ONLY),
				
				phys_soft_desc		/* Additional */
			}
		}

		
		/* Imput->Transducer Block-Flow (Maintenance) */
		MENU Tab_m_trans1
		{
//			LABEL				[trans_flow];
			REDEFINE LABEL		[trans_block_flow];
			
			REDEFINE ITEMS
			{
				trans1_calibration_factor,
//				trans1_volume_flow_unit,
				trans1_volume_flow_units			(READ_ONLY),
				trans1_flow_direction				(READ_ONLY),
				trans1_low_flow_cutoff,
				trans1_measurement_mode,
				trans1_nominal_size					(READ_ONLY),
				trans1_nominal_size_units			(READ_ONLY),
				trans1_volume_flow_lower_limit		(READ_ONLY),
				trans1_volume_flow_upper_limit		(READ_ONLY),

				trans1_zero_point					(READ_ONLY),
				trans1_volume_flow_ftime			(READ_ONLY),
				trans1_density_unit					(READ_ONLY),
				trans1_mass_flow_density			(READ_ONLY),
				trans1_target_mode					(READ_ONLY),
				trans1_actual_mode,
	
				Tab_m_trans_flow_tube,
				Tab_m_trans_di_set,
				Tab_m_trans_aux,
				Tab_m_trans_mask_alarm,
				Tab_m_trans_adhesion
			}
		}
		
		/* Imput->Transducer Block-Flow (Specialist) */
		MENU Tab_s_trans1
		{
//			LABEL				[trans_flow];
			REDEFINE LABEL		[trans_block_flow];
			
			REDEFINE ITEMS
			{
				trans1_calibration_factor,
//				trans1_volume_flow_unit,
				trans1_volume_flow_units,
				trans1_flow_direction,
				trans1_low_flow_cutoff,
				trans1_measurement_mode,
				trans1_nominal_size,
				trans1_nominal_size_units,
				trans1_volume_flow_lower_limit		(READ_ONLY),
				trans1_volume_flow_upper_limit		(READ_ONLY),

				trans1_zero_point					(READ_ONLY),
				trans1_volume_flow_ftime,
				trans1_density_unit,
				trans1_mass_flow_density,
				trans1_target_mode,
				trans1_actual_mode,

				Tab_s_trans_flow_tube,
				Tab_s_trans_di_set,
				Tab_s_trans_aux,
				Tab_s_trans_mask_alarm,
				Tab_s_trans_adhesion
			}
		}
		
		
		/* Output -> Analog Input (Specialist) */
		MENU Tab_s_func1
		{
			REDEFINE ITEMS
			{
				func1_AI_st_rev,

		#ifdef FUNC1_TAG_IN_TABLE
				func1_AI_tag_desc,
		#endif

		#ifdef FUNC1_CHANNEL_LIST
				func1_AI_channel,
		#endif

				func1_AI_out_unit,
		#ifndef NO_func1_AI_out_unit_text
				func1_AI_out_unit_text,
		#endif
				func1_AI_pv_ftime,

				func1_AI_lin_type,			//Add
				func1_AI_target_mode,		//Add
				func1_AI_actual_mode,		//Add

				Tab_s_func1_batch,
				Tab_s_func1_pv_range,
				Tab_s_func1_outscale,
				Tab_s_func1_limits,
				Tab_s_func1_FSafe,
				Tab_s_func1_interface,
				Tab_func1_velocity_check	//Add
			}
		}
		
		/* Output -> Analog Input (Maintenance) */
		MENU Tab_m_func1
		{
			REDEFINE ITEMS
			{
				func1_AI_st_rev,

		#ifdef FUNC1_TAG_IN_TABLE
				func1_AI_tag_desc (READ_ONLY),
		#endif

		#ifdef FUNC1_CHANNEL_LIST
				func1_AI_channel	(READ_ONLY),
		#endif

				func1_AI_out_unit	(READ_ONLY),	
		#ifndef NO_func1_AI_out_unit_text
				func1_AI_out_unit_text (READ_ONLY),
		#endif	
				func1_AI_pv_ftime (READ_ONLY),

				func1_AI_lin_type    (READ_ONLY),	//Add
				func1_AI_target_mode (READ_ONLY),	//Add
				func1_AI_actual_mode,				//Add

				Tab_s_func1_batch,
				Tab_m_func1_pv_range,
				Tab_m_func1_outscale,
				Tab_m_func1_limits,
				Tab_m_func1_FSafe,
				Tab_s_func1_interface
				Tab_func1_velocity_check			//Add
			}
		}
		
		/* Output -> Totalizer1 [Specialist] */
		MENU Tab_s_func2
		{
			REDEFINE ITEMS
			{
				func2_TOT_st_rev,
		#ifdef FUNC2_TAG_IN_TABLE
				func2_TOT_tag_desc,
		#endif

		#ifdef FUNC2_CHANNEL_LIST
		#ifdef FUNC2_TOT_CHANNEL_FIXED
				func2_TOT_channel			(READ_ONLY),
		#else
				func2_TOT_channel,
		#endif
		#endif

		#ifdef FUNC2_TOT_UNIT_TOT_FIXED
				func2_TOT_unit_tot			(READ_ONLY),
		#else
				func2_TOT_unit_tot,
		#endif
		
		#ifdef FUNC2_TOT_MODE_TOT_FIXED
				func2_TOT_mode_tot				(READ_ONLY),
		#else
				func2_TOT_mode_tot,
		#endif
		
				func2_TOT_preset_tot,
				func2_TOT_fail_tot,

				func2_TOT_target_mode,		//Add
				func2_TOT_actual_mode,		//Add

				Tab_s_func2_tot_batch_info,
				Tab_s_func2_tot_limits
			}
		}
		
		
		/* Output -> Totalizer1 [Maintenance] */
		MENU Tab_m_func2
		{
			REDEFINE ITEMS
			{
				func2_TOT_st_rev,
		
		#ifdef FUNC2_TAG_IN_TABLE
				func2_TOT_tag_desc,
		#endif
		
		#ifdef FUNC2_CHANNEL_LIST
				func2_TOT_channel				(READ_ONLY),
		#endif
				func2_TOT_unit_tot			(READ_ONLY),
				func2_TOT_mode_tot			(READ_ONLY),
				func2_TOT_fail_tot			(READ_ONLY),
		
				func2_TOT_target_mode		(READ_ONLY),	//Add
				func2_TOT_actual_mode		(READ_ONLY),	//Add

				Tab_s_func2_tot_batch_info,
				Tab_s_func2_tot_limits
			}
		}
		
		/* Output -> Totalizer2 [Specialist] */
		MENU Tab_s_func3
		{
			REDEFINE ITEMS
			{
				func3_TOT_st_rev,
		#ifdef FUNC3_TAG_IN_TABLE
				func3_TOT_tag_desc,
		#endif
		
		#ifdef FUNC3_CHANNEL_LIST
		#ifdef FUNC3_TOT_CHANNEL_FIXED
				func3_TOT_channel			(READ_ONLY),
		#else
				func3_TOT_channel,
		#endif
		#endif
		
		#ifdef FUNC3_TOT_UNIT_TOT_FIXED
				func3_TOT_unit_tot			(READ_ONLY),
		#else
				func3_TOT_unit_tot,
		#endif
		
		#ifdef FUNC3_TOT_MODE_TOT_FIXED
				func3_TOT_mode_tot				(READ_ONLY),
		#else
				func3_TOT_mode_tot,
		#endif
		
				func3_TOT_preset_tot,
				func3_TOT_fail_tot,
		
				func3_TOT_target_mode,		//Add
				func3_TOT_actual_mode,		//Add
		
				Tab_s_func3_tot_batch_info,
				Tab_s_func3_tot_limits
			}
		}
		
		/* Output -> Totalizer2 [Maintenance] */
		MENU Tab_m_func3
		{
			REDEFINE ITEMS
			{
				func3_TOT_st_rev,
		
		#ifdef FUNC3_TAG_IN_TABLE
				func3_TOT_tag_desc,
		#endif
		
		#ifdef FUNC3_CHANNEL_LIST
				func3_TOT_channel				(READ_ONLY),
		#endif
				func3_TOT_unit_tot			(READ_ONLY),
				func3_TOT_mode_tot			(READ_ONLY),
				func3_TOT_fail_tot			(READ_ONLY),
		
				func3_TOT_target_mode		(READ_ONLY),	//Add
				func3_TOT_actual_mode		(READ_ONLY),	//Add
		
				Tab_s_func3_tot_batch_info,
				Tab_s_func3_tot_limits
			}
		}
		
		/* Output -> Totalizer3 [Specialist] */
		MENU Tab_s_func4
		{
			REDEFINE ITEMS
			{
				func4_TOT_st_rev,
		#ifdef FUNC4_TAG_IN_TABLE
				func4_TOT_tag_desc,
		#endif
		
		#ifdef FUNC4_CHANNEL_LIST
		#ifdef FUNC4_TOT_CHANNEL_FIXED
				func4_TOT_channel			(READ_ONLY),
		#else
				func4_TOT_channel,
		#endif
		#endif
		
		#ifdef FUNC4_TOT_UNIT_TOT_FIXED
				func4_TOT_unit_tot			(READ_ONLY),
		#else
				func4_TOT_unit_tot,
		#endif
		
		#ifdef FUNC4_TOT_MODE_TOT_FIXED
				func4_TOT_mode_tot				(READ_ONLY),
		#else
				func4_TOT_mode_tot,
		#endif
		
				func4_TOT_preset_tot,
				func4_TOT_fail_tot,
		
				func4_TOT_target_mode,		//Add
				func4_TOT_actual_mode,		//Add
		
				Tab_s_func4_tot_batch_info,
				Tab_s_func4_tot_limits
			}
		}
		
		/* Output -> Totalizer3 [Maintenance] */
		MENU Tab_m_func4
		{
		
			REDEFINE ITEMS
			{
				func4_TOT_st_rev,
		
		#ifdef FUNC4_TAG_IN_TABLE
				func4_TOT_tag_desc,
		#endif
		
		#ifdef FUNC4_CHANNEL_LIST
				func4_TOT_channel			(READ_ONLY),
		#endif
				func4_TOT_unit_tot			(READ_ONLY),
				func4_TOT_mode_tot			(READ_ONLY),
				func4_TOT_fail_tot			(READ_ONLY),
		
				func4_TOT_target_mode		(READ_ONLY),	//Add
				func4_TOT_actual_mode		(READ_ONLY),	//Add
		
				Tab_s_func4_tot_batch_info,
				Tab_s_func4_tot_limits
			}
		}
		
		/*********************************************************************/
		/****************  REDEFINE for Menu Bar "View" **********************/
		/*********************************************************************/
		
		/* Menu Bar View (Specialist) */
		MENU Menu_S_View
		{
			REDEFINE ITEMS
			{
				OnlineWindow_display,
				OnlineWindow_yt,

		#ifdef EXTRA_ITEMS_VIEW_MENU_SPECIALIST_COMMON_DLGS
				EXTRA_ITEMS_VIEW_MENU_SPECIALIST_COMMON_DLGS,
		#endif

		#ifdef EXTRA_ITEMS_VIEW_MENU_SPECIALIST
				EXTRA_ITEMS_VIEW_MENU_SPECIALIST,
		#endif

				OnlineWindow_alarm_record,	//Add

				SEPARATOR,
				std_Funktionsleiste,
				std_Statuszeile,
				SEPARATOR,
				std_Update
				
		/****** For Test ******
			SEPARATOR,
			OnlineWindow_enhancement_test
		**********************/
			}
		}
		
		/* Menu Bar View (Maintenance) */
		MENU Menu_M_View
		{
			REDEFINE ITEMS
			{
				OnlineWindow_display,
				OnlineWindow_yt,

		#ifdef EXTRA_ITEMS_VIEW_MENU_MAINTENANCE_COMMON_DLGS
				EXTRA_ITEMS_VIEW_MENU_SPECIALIST_COMMON_DLGS,
		#endif

		#ifdef EXTRA_ITEMS_VIEW_MENU_MAINTENANCE
				EXTRA_ITEMS_VIEW_MENU_MAINTENANCE,
		#endif
		
				OnlineWindow_alarm_record,	//Add
		
				SEPARATOR,
				std_Funktionsleiste,
				std_Statuszeile,
				SEPARATOR,
				std_Update
			}
		}
		
		/* View -> Display */
		MENU Val_pv_display
		{
		//	LABEL [trans_value] ;
			REDEFINE LABEL [volume_flow];
		}
		
		/* View -> Y t diagram */
		MENU OnlineWindow_yt
		{
			REDEFINE ITEMS
			{
		#ifdef _V600_
					Page_process_yt_1,
					Page_process_yt_2,
					Page_process_yt_3,
					Page_process_yt_4
		#else
					Page_process_yt,
					Page_process_yt_2
		#endif
			}
		}
		
		/* View -> Device Status */
		MENU OnlineWindow_diagnosis
		{
			REDEFINE ITEMS
			{
				Page_diagnosis_overview,
				Page_diagnosis_general,
				Page_diagnosis_axf_diagnosis,	//Add
				Page_diagnosis_axf_fb_status,	//Add
				Page_diagnosis_phys_block,
				Page_diagnosis_trans1,
		
		#ifdef TRANS2_AVAILABLE
				Page_diagnosis_trans2,
		#endif
		
		#ifdef TRANS3_AVAILABLE
				Page_diagnosis_trans3,
		#endif
		
		#ifdef TRANS4_AVAILABLE
				Page_diagnosis_trans4,
		#endif
		
		
		#ifdef FUNC1_AVAILABLE
				Page_diagnosis_func1,
		#endif
		
		#ifdef FUNC2_AVAILABLE
				Page_diagnosis_func2,
		#endif
		
		#ifdef FUNC3_AVAILABLE
				Page_diagnosis_func3,
		#endif
		
		#ifdef FUNC4_AVAILABLE
				Page_diagnosis_func4,
		#endif
		
		/************* Add **************/
		#ifdef FUNC5_AVAILABLE
				Page_diagnosis_func5,
		#endif
		
		#ifdef FUNC6_AVAILABLE
				Page_diagnosis_func6,
		#endif
		/********************************/
			}
		}
		
		/* View -> Device Status -> Overview */
		MENU Page_diagnosis_overview
		{
			REDEFINE ITEMS
			{
				trans1.actual_mode,
		
		#ifdef TRANS2_AVAILABLE
				trans2.actual_mode,
		#endif
		
		#ifdef TRANS3_AVAILABLE
				trans3.actual_mode,
		#endif
		
				func1.actual_mode,
		
		#ifdef FUNC2_AVAILABLE
				func2.actual_mode,
		#endif
		
		#ifdef FUNC3_AVAILABLE
				func3.actual_mode,
		#endif
		
		#ifdef FUNC4_AVAILABLE
				func4.actual_mode,
		#endif
		
		/************** Add *************/
		#ifdef FUNC5_AVAILABLE
				func5.actual_mode,
		#endif
		
		#ifdef FUNC6_AVAILABLE
				func6.actual_mode
		#endif
		/********************************/
			}
		}
		
		/* View -> Alarm States (Specialist) */
		MENU Menu_S_alarm
		{
			REDEFINE ITEMS
			{
		#ifdef FUNC1_AVAILABLE
				OnlineWindow_S_alarm_func1,
		#endif
		
		#ifdef FUNC2_AVAILABLE
				OnlineWindow_S_alarm_func2,
		#endif
		
		#ifdef FUNC3_AVAILABLE
				OnlineWindow_S_alarm_func3,
		#endif
		
		#ifdef FUNC4_AVAILABLE
				OnlineWindow_S_alarm_func4,
		#endif
		
		/************** Add *************/
		#ifdef FUNC5_AVAILABLE
				OnlineWindow_S_alarm_func5,
		#endif
		
		#ifdef FUNC6_AVAILABLE
				OnlineWindow_S_alarm_func6,
		#endif
		/********************************/
			}
		}
		
		/* View -> Alarm States (Maintenance) */
		MENU Menu_M_alarm
		{
			REDEFINE ITEMS
			{
		#ifdef FUNC1_AVAILABLE
				OnlineWindow_M_alarm_func1,
		#endif
		
		#ifdef FUNC2_AVAILABLE
				OnlineWindow_M_alarm_func2,
		#endif
		
		#ifdef FUNC3_AVAILABLE
				OnlineWindow_M_alarm_func3,
		#endif
		
		#ifdef FUNC4_AVAILABLE
				OnlineWindow_M_alarm_func4,
		#endif
		
		/************** Add *************/
		#ifdef FUNC5_AVAILABLE
				OnlineWindow_M_alarm_func5,
		#endif
		
		#ifdef FUNC6_AVAILABLE
				OnlineWindow_M_alarm_func6,
		#endif
		/********************************/
			}
		}
		
		/*********************************************************************/
		/****************** REDEFINE for Menu Bar "Device" *******************/
		/*********************************************************************/
		
		/* Device (Specialist) */
		MENU Menu_S_Device
		{
			REDEFINE ITEMS
			{
				DEVMENU_SETNODEADDR,
				SEPARATOR,
				std_LoadinDevice,										
				std_LoadinPC,
		
		#ifdef EXTRA_ITEMS_DEVICE_MENU_SPECIALIST_COMMON_DLGS
				SEPARATOR,
				EXTRA_ITEMS_DEVICE_MENU_SPECIALIST_COMMON_DLGS,
		#endif
		
		#ifdef EXTRA_ITEMS_DEVICE_MENU_SPECIALIST
				SEPARATOR,
				EXTRA_ITEMS_DEVICE_MENU_SPECIALIST,
		#endif
		/***************************** Add ******************************/
				SEPARATOR,
				OnlineDialog_target_mode,
				SEPARATOR,
				OnlineDialog_reset,
				OnlineDialog_total_reset,
				SEPARATOR,
				OnlineDialog_zero_point_adjustment,
				OnlineDialog_adhesion_level,
//				OnlineDialog_limit_switch,
				OnlineDialog_signal_lock,
				OnlineDialog_write_locking,
				SEPARATOR,
				Menu_s_query_device
		/****************************************************************/
			}
		}
		
		/* Device (Maintenance) */
		MENU Menu_M_Device
		{
			REDEFINE ITEMS
			{
				std_LoadinDevice,										
				std_LoadinPC,											
		/***************************** Add ******************************/
				SEPARATOR,
				Menu_m_query_device
		/****************************************************************/
			}
		}
		
		/* Device -> Simulation */
		MENU Menu_simulation
		{
			REDEFINE ITEMS
			{
		/**************** Add ****************/
				OnlineDialog_simulation_phys,
				
				OnlineDialog_simulation_trans1,
		/*************************************/
		
		#ifdef FUNC1_SIMULATION_AVAILABLE
				OnlineDialog_simulation_func1,
		#endif
		
		#ifdef FUNC2_SIMULATION_AVAILABLE
				OnlineDialog_simulation_func2,
		#endif
		
		#ifdef FUNC3_SIMULATION_AVAILABLE
				OnlineDialog_simulation_func3,
		#endif
		
		#ifdef FUNC4_SIMULATION_AVAILABLE
				OnlineDialog_simulation_func4,
		#endif
		
		/************** Add **************/
		#ifdef FUNC5_SIMULATION_AVAILABLE
				OnlineDialog_simulation_func5,
		#endif
		
		#ifdef FUNC6_SIMULATION_AVAILABLE
				OnlineDialog_simulation_func6
		#endif
		/********************************/
			}
		}
		
		/* Device -> Simulation -> Totilizer1 */
		MENU OnlineDialog_simulation_func2
		{
			REDEFINE ITEMS
			{
				Page_simulation_input_func2
				Page_simulation_output_func2,
			}
		}
		
		
		/* Device -> Simulation -> Totilizer2 */
		MENU OnlineDialog_simulation_func3
		{
			REDEFINE ITEMS
			{
				Page_simulation_input_func3
				Page_simulation_output_func3,
			}
		}
		
		
		/* Device -> Simulation -> Totilizer3 */
		MENU OnlineDialog_simulation_func4
		{
			REDEFINE ITEMS
			{
				Page_simulation_input_func4
				Page_simulation_output_func4,
			}
		}
		
		
		/*********************************************************************/
		/****************** REDEFINE for Trend Graph *************************/
		/*********************************************************************/
	#ifdef _V600_
		MENU Page_process_yt_1
		{
		//	LABEL	[menu_yt_diagram];
			REDEFINE LABEL	"Output Value";
		}
	#else
		MENU Page_process_yt
		{
		//	LABEL	[menu_yt_diagram];
			REDEFINE LABEL	"Output Value";
		}
	#endif
		
		MENU Page_process_yt_2
		{
		//	LABEL	[menu_yt_diagram];
		#ifdef _V600_
			REDEFINE LABEL	"Totalizer1";
		#else
			REDEFINE LABEL	"Totalizer1-3";
		#endif		}
		
		MENU Page_process_yt_3
		{
		//	LABEL	[menu_yt_diagram];
			REDEFINE LABEL	"Totalizer2";
		}
		
		MENU Page_process_yt_4
		{
		//	LABEL	[menu_yt_diagram];
			REDEFINE LABEL	"Totalizer3";
		}
	}/* End REDEFINITIONS */
}/* End IMPORT */


/* Unit Relation of VOLUME_FLOW_UNITS */
UNIT unitrelation_trans1_volume_flow_units
{
	trans1_volume_flow_units:

	trans1_volume_flow_value,
	trans1_volume_flow_lower_limit,
	trans1_volume_flow_upper_limit,
	func1_AI_pv_upper_range_value,
	func1_AI_pv_lower_range_value,
	func1_AI_simulate_value,
	trans1_low_flow_cutoff,
	trans1_simulate_volume_flow_value,
	func2_TOT_simulate_value,
	func3_TOT_simulate_value,
	func4_TOT_simulate_value
}